# coding: utf-8

"""
AsyncMirrorGroupMemberFaultIndication.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupMemberFaultIndication(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupMemberFaultIndication - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'mirror_member': 'str',  # (required parameter)
            'fault_time': 'int',  # (required parameter)
            'percent_complete': 'int'
        }

        self.attribute_map = {
            'mirror_member': 'mirrorMember',  # (required parameter)
            'fault_time': 'faultTime',  # (required parameter)
            'percent_complete': 'percentComplete'
        }

        self._mirror_member = None
        self._fault_time = None
        self._percent_complete = None

    @property
    def mirror_member(self):
        """
        Gets the mirror_member of this AsyncMirrorGroupMemberFaultIndication.
        The mirror group member with the fault.

        :return: The mirror_member of this AsyncMirrorGroupMemberFaultIndication.
        :rtype: str
        :required/optional: required
        """
        return self._mirror_member

    @mirror_member.setter
    def mirror_member(self, mirror_member):
        """
        Sets the mirror_member of this AsyncMirrorGroupMemberFaultIndication.
        The mirror group member with the fault.

        :param mirror_member: The mirror_member of this AsyncMirrorGroupMemberFaultIndication.
        :type: str
        """
        self._mirror_member = mirror_member

    @property
    def fault_time(self):
        """
        Gets the fault_time of this AsyncMirrorGroupMemberFaultIndication.
        The last time at which the fault occurred represented in seconds since midnight GMT on January 1, 1970.

        :return: The fault_time of this AsyncMirrorGroupMemberFaultIndication.
        :rtype: int
        :required/optional: required
        """
        return self._fault_time

    @fault_time.setter
    def fault_time(self, fault_time):
        """
        Sets the fault_time of this AsyncMirrorGroupMemberFaultIndication.
        The last time at which the fault occurred represented in seconds since midnight GMT on January 1, 1970.

        :param fault_time: The fault_time of this AsyncMirrorGroupMemberFaultIndication.
        :type: int
        """
        self._fault_time = fault_time

    @property
    def percent_complete(self):
        """
        Gets the percent_complete of this AsyncMirrorGroupMemberFaultIndication.
        The completion percentage for the operation running at the time of the fault. If no operation was running at the time of the fault, this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. If the percentage complete is unknown or not applicable to the particular fault, this value will be equal to PERCENT_COMPLETE_UNKNOWN.

        :return: The percent_complete of this AsyncMirrorGroupMemberFaultIndication.
        :rtype: int
        :required/optional: required
        """
        return self._percent_complete

    @percent_complete.setter
    def percent_complete(self, percent_complete):
        """
        Sets the percent_complete of this AsyncMirrorGroupMemberFaultIndication.
        The completion percentage for the operation running at the time of the fault. If no operation was running at the time of the fault, this value will be equal to PERCENT_COMPLETE_OP_NOT_RUNNING. If the percentage complete is unknown or not applicable to the particular fault, this value will be equal to PERCENT_COMPLETE_UNKNOWN.

        :param percent_complete: The percent_complete of this AsyncMirrorGroupMemberFaultIndication.
        :type: int
        """
        self._percent_complete = percent_complete

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

