# coding: utf-8

"""
AsyncMirrorGroupMirrorConnectionDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupMirrorConnectionDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupMirrorConnectionDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'candidate_type': 'str',  # (required parameter)
            'existing_remote_target': 'str',  
            'new_remote_target': 'RemoteTargetCreationDescriptor'
        }

        self.attribute_map = {
            'candidate_type': 'candidateType',  # (required parameter)
            'existing_remote_target': 'existingRemoteTarget',  
            'new_remote_target': 'newRemoteTarget'
        }

        self._candidate_type = None
        self._existing_remote_target = None
        self._new_remote_target = None

    @property
    def candidate_type(self):
        """
        Gets the candidate_type of this AsyncMirrorGroupMirrorConnectionDescriptor.
        This enumeration lists the Async Mirror Group connection candidate types.

        :return: The candidate_type of this AsyncMirrorGroupMirrorConnectionDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._candidate_type

    @candidate_type.setter
    def candidate_type(self, candidate_type):
        """
        Sets the candidate_type of this AsyncMirrorGroupMirrorConnectionDescriptor.
        This enumeration lists the Async Mirror Group connection candidate types.

        :param candidate_type: The candidate_type of this AsyncMirrorGroupMirrorConnectionDescriptor.
        :type: str
        """
        allowed_values = ["unknown", "existingRemoteTarget", "newRemoteTarget", "__UNDEFINED"]
        if candidate_type not in allowed_values:
            raise ValueError(
                "Invalid value for `candidate_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._candidate_type = candidate_type

    @property
    def existing_remote_target(self):
        """
        Gets the existing_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        This field is present only if the value of candidateType is equal to ASYNC_MIRROR_CONNECTION_EXISTING_REMOTE_TARGET.

        :return: The existing_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        :rtype: str
        :required/optional: optional
        """
        return self._existing_remote_target

    @existing_remote_target.setter
    def existing_remote_target(self, existing_remote_target):
        """
        Sets the existing_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        This field is present only if the value of candidateType is equal to ASYNC_MIRROR_CONNECTION_EXISTING_REMOTE_TARGET.

        :param existing_remote_target: The existing_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        :type: str
        """
        self._existing_remote_target = existing_remote_target

    @property
    def new_remote_target(self):
        """
        Gets the new_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        This field is present only if the value of candidateType is equal to ASYNC_MIRROR_CONNECTION_NEW_REMOTE_TARGET

        :return: The new_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        :rtype: RemoteTargetCreationDescriptor
        :required/optional: optional
        """
        return self._new_remote_target

    @new_remote_target.setter
    def new_remote_target(self, new_remote_target):
        """
        Sets the new_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        This field is present only if the value of candidateType is equal to ASYNC_MIRROR_CONNECTION_NEW_REMOTE_TARGET

        :param new_remote_target: The new_remote_target of this AsyncMirrorGroupMirrorConnectionDescriptor.
        :type: RemoteTargetCreationDescriptor
        """
        self._new_remote_target = new_remote_target

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

