# coding: utf-8

"""
AutoConfigSummary.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AutoConfigSummary(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AutoConfigSummary - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'total_volume_groups': 'int',  # (required parameter)
            'hot_spare_count': 'int',  # (required parameter)
            'unassigned_count': 'int',  # (required parameter)
            'volume_group_summary': 'list[VolumeGroupSummary]'
        }

        self.attribute_map = {
            'total_volume_groups': 'totalVolumeGroups',  # (required parameter)
            'hot_spare_count': 'hotSpareCount',  # (required parameter)
            'unassigned_count': 'unassignedCount',  # (required parameter)
            'volume_group_summary': 'volumeGroupSummary'
        }

        self._total_volume_groups = None
        self._hot_spare_count = None
        self._unassigned_count = None
        self._volume_group_summary = None

    @property
    def total_volume_groups(self):
        """
        Gets the total_volume_groups of this AutoConfigSummary.
        The total number of volume groups.

        :return: The total_volume_groups of this AutoConfigSummary.
        :rtype: int
        :required/optional: required
        """
        return self._total_volume_groups

    @total_volume_groups.setter
    def total_volume_groups(self, total_volume_groups):
        """
        Sets the total_volume_groups of this AutoConfigSummary.
        The total number of volume groups.

        :param total_volume_groups: The total_volume_groups of this AutoConfigSummary.
        :type: int
        """
        self._total_volume_groups = total_volume_groups

    @property
    def hot_spare_count(self):
        """
        Gets the hot_spare_count of this AutoConfigSummary.
        The total number of hot spares.

        :return: The hot_spare_count of this AutoConfigSummary.
        :rtype: int
        :required/optional: required
        """
        return self._hot_spare_count

    @hot_spare_count.setter
    def hot_spare_count(self, hot_spare_count):
        """
        Sets the hot_spare_count of this AutoConfigSummary.
        The total number of hot spares.

        :param hot_spare_count: The hot_spare_count of this AutoConfigSummary.
        :type: int
        """
        self._hot_spare_count = hot_spare_count

    @property
    def unassigned_count(self):
        """
        Gets the unassigned_count of this AutoConfigSummary.
        The total number of unassigned drives.

        :return: The unassigned_count of this AutoConfigSummary.
        :rtype: int
        :required/optional: required
        """
        return self._unassigned_count

    @unassigned_count.setter
    def unassigned_count(self, unassigned_count):
        """
        Sets the unassigned_count of this AutoConfigSummary.
        The total number of unassigned drives.

        :param unassigned_count: The unassigned_count of this AutoConfigSummary.
        :type: int
        """
        self._unassigned_count = unassigned_count

    @property
    def volume_group_summary(self):
        """
        Gets the volume_group_summary of this AutoConfigSummary.
        The list of volume groups.

        :return: The volume_group_summary of this AutoConfigSummary.
        :rtype: list[VolumeGroupSummary]
        :required/optional: required
        """
        return self._volume_group_summary

    @volume_group_summary.setter
    def volume_group_summary(self, volume_group_summary):
        """
        Sets the volume_group_summary of this AutoConfigSummary.
        The list of volume groups.

        :param volume_group_summary: The volume_group_summary of this AutoConfigSummary.
        :type: list[VolumeGroupSummary]
        """
        self._volume_group_summary = volume_group_summary

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

