# coding: utf-8

"""
BatteryParamsUpdateDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class BatteryParamsUpdateDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        BatteryParamsUpdateDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'reset_battery_age': 'bool',  # (required parameter)
            'component': 'str',  # (required parameter)
            'next_learn_cycle_time': 'list[int]'
        }

        self.attribute_map = {
            'reset_battery_age': 'resetBatteryAge',  # (required parameter)
            'component': 'component',  # (required parameter)
            'next_learn_cycle_time': 'nextLearnCycleTime'
        }

        self._reset_battery_age = None
        self._component = None
        self._next_learn_cycle_time = None

    @property
    def reset_battery_age(self):
        """
        Gets the reset_battery_age of this BatteryParamsUpdateDescriptor.
        Resets the age of the specified cache battery

        :return: The reset_battery_age of this BatteryParamsUpdateDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._reset_battery_age

    @reset_battery_age.setter
    def reset_battery_age(self, reset_battery_age):
        """
        Sets the reset_battery_age of this BatteryParamsUpdateDescriptor.
        Resets the age of the specified cache battery

        :param reset_battery_age: The reset_battery_age of this BatteryParamsUpdateDescriptor.
        :type: bool
        """
        self._reset_battery_age = reset_battery_age

    @property
    def component(self):
        """
        Gets the component of this BatteryParamsUpdateDescriptor.
        Identifies the appropriate battery.

        :return: The component of this BatteryParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._component

    @component.setter
    def component(self, component):
        """
        Sets the component of this BatteryParamsUpdateDescriptor.
        Identifies the appropriate battery.

        :param component: The component of this BatteryParamsUpdateDescriptor.
        :type: str
        """
        self._component = component

    @property
    def next_learn_cycle_time(self):
        """
        Gets the next_learn_cycle_time of this BatteryParamsUpdateDescriptor.
        The new value to apply for the nextLearnCycleTime property in the BatteryParamsUpdateDescriptor structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time.

        :return: The next_learn_cycle_time of this BatteryParamsUpdateDescriptor.
        :rtype: list[int]
        :required/optional: required
        """
        return self._next_learn_cycle_time

    @next_learn_cycle_time.setter
    def next_learn_cycle_time(self, next_learn_cycle_time):
        """
        Sets the next_learn_cycle_time of this BatteryParamsUpdateDescriptor.
        The new value to apply for the nextLearnCycleTime property in the BatteryParamsUpdateDescriptor structure. This value is expressed as seconds since midnight GMT, January 1, 1970. This field is only applicable if the smartBatteryTechnology Boolean in FeatureParams is set to true. The array will return an error if an attempt is made to set this time more than seven days later than the current scheduled time.

        :param next_learn_cycle_time: The next_learn_cycle_time of this BatteryParamsUpdateDescriptor.
        :type: list[int]
        """
        self._next_learn_cycle_time = next_learn_cycle_time

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

