# coding: utf-8

"""
BatteryTypeData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class BatteryTypeData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        BatteryTypeData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'battery_type': 'str',  # (required parameter)
            'cru_parent_controller': 'str',  
            'parent_controller': 'str'
        }

        self.attribute_map = {
            'battery_type': 'batteryType',  # (required parameter)
            'cru_parent_controller': 'cruParentController',  
            'parent_controller': 'parentController'
        }

        self._battery_type = None
        self._cru_parent_controller = None
        self._parent_controller = None

    @property
    def battery_type(self):
        """
        Gets the battery_type of this BatteryTypeData.
        This enumeration object is used to specify the battery configurations present on a controller.

        :return: The battery_type of this BatteryTypeData.
        :rtype: str
        :required/optional: required
        """
        return self._battery_type

    @battery_type.setter
    def battery_type(self, battery_type):
        """
        Sets the battery_type of this BatteryTypeData.
        This enumeration object is used to specify the battery configurations present on a controller.

        :param battery_type: The battery_type of this BatteryTypeData.
        :type: str
        """
        allowed_values = ["singleSharedCru", "dualIndividualFrus", "dualSharedCrus", "dualIndividualCrus", "__UNDEFINED"]
        if battery_type not in allowed_values:
            raise ValueError(
                "Invalid value for `battery_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._battery_type = battery_type

    @property
    def cru_parent_controller(self):
        """
        Gets the cru_parent_controller of this BatteryTypeData.
        This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_CRUS. It is a reference to the controller that the battery CRU is associated with.

        :return: The cru_parent_controller of this BatteryTypeData.
        :rtype: str
        :required/optional: optional
        """
        return self._cru_parent_controller

    @cru_parent_controller.setter
    def cru_parent_controller(self, cru_parent_controller):
        """
        Sets the cru_parent_controller of this BatteryTypeData.
        This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_CRUS. It is a reference to the controller that the battery CRU is associated with.

        :param cru_parent_controller: The cru_parent_controller of this BatteryTypeData.
        :type: str
        """
        self._cru_parent_controller = cru_parent_controller

    @property
    def parent_controller(self):
        """
        Gets the parent_controller of this BatteryTypeData.
        This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_FRUS. It is a reference to the the controller that the battery FRU is associated with.

        :return: The parent_controller of this BatteryTypeData.
        :rtype: str
        :required/optional: optional
        """
        return self._parent_controller

    @parent_controller.setter
    def parent_controller(self, parent_controller):
        """
        Sets the parent_controller of this BatteryTypeData.
        This field is present only if the batteryType value is equal to BATTERY_TYPE_DUAL_INDIVIDUAL_FRUS. It is a reference to the the controller that the battery FRU is associated with.

        :param parent_controller: The parent_controller of this BatteryTypeData.
        :type: str
        """
        self._parent_controller = parent_controller

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

