# coding: utf-8

"""
ChannelDiagDataPatternTypeData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ChannelDiagDataPatternTypeData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ChannelDiagDataPatternTypeData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',  # (required parameter)
            'pattern': 'int',  
            'random_number_seed': 'int'
        }

        self.attribute_map = {
            'type': 'type',  # (required parameter)
            'pattern': 'pattern',  
            'random_number_seed': 'randomNumberSeed'
        }

        self._type = None
        self._pattern = None
        self._random_number_seed = None

    @property
    def type(self):
        """
        Gets the type of this ChannelDiagDataPatternTypeData.
        This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics.

        :return: The type of this ChannelDiagDataPatternTypeData.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this ChannelDiagDataPatternTypeData.
        This enumeration data type identifies the types of data patterns that may be used in running the drive channel fault isolation diagnostics.

        :param type: The type of this ChannelDiagDataPatternTypeData.
        :type: str
        """
        allowed_values = ["fixed", "random", "__UNDEFINED"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def pattern(self):
        """
        Gets the pattern of this ChannelDiagDataPatternTypeData.
        A four-byte user-supplied data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_FIXED.

        :return: The pattern of this ChannelDiagDataPatternTypeData.
        :rtype: int
        :required/optional: optional
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """
        Sets the pattern of this ChannelDiagDataPatternTypeData.
        A four-byte user-supplied data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_FIXED.

        :param pattern: The pattern of this ChannelDiagDataPatternTypeData.
        :type: int
        """
        self._pattern = pattern

    @property
    def random_number_seed(self):
        """
        Gets the random_number_seed of this ChannelDiagDataPatternTypeData.
        A 32-bit value that is used as the seed for a pseudo-random sequence that is used to establish the data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_RANDOM.

        :return: The random_number_seed of this ChannelDiagDataPatternTypeData.
        :rtype: int
        :required/optional: optional
        """
        return self._random_number_seed

    @random_number_seed.setter
    def random_number_seed(self, random_number_seed):
        """
        Sets the random_number_seed of this ChannelDiagDataPatternTypeData.
        A 32-bit value that is used as the seed for a pseudo-random sequence that is used to establish the data pattern. This field is valid only if type is equal to CHANNEL_DIAG_DATA_PATTERN_RANDOM.

        :param random_number_seed: The random_number_seed of this ChannelDiagDataPatternTypeData.
        :type: int
        """
        self._random_number_seed = random_number_seed

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

