# coding: utf-8

"""
CheckedPendingHost.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CheckedPendingHost(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CheckedPendingHost - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'type': 'str',  # (required parameter)
            'matched_pending_host': 'MatchedPendingHost',  
            'unmatched_pending_host': 'UnmatchedPendingHost'
        }

        self.attribute_map = {
            'type': 'type',  # (required parameter)
            'matched_pending_host': 'matchedPendingHost',  
            'unmatched_pending_host': 'unmatchedPendingHost'
        }

        self._type = None
        self._matched_pending_host = None
        self._unmatched_pending_host = None

    @property
    def type(self):
        """
        Gets the type of this CheckedPendingHost.
        This enumeration data type indicates whether a CheckedPendingHost matches or does not match a host in the configured topology.

        :return: The type of this CheckedPendingHost.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this CheckedPendingHost.
        This enumeration data type indicates whether a CheckedPendingHost matches or does not match a host in the configured topology.

        :param type: The type of this CheckedPendingHost.
        :type: str
        """
        allowed_values = ["matched", "unmatched", "__UNDEFINED"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def matched_pending_host(self):
        """
        Gets the matched_pending_host of this CheckedPendingHost.
        This field is only present if type is PENDING_HOST_MATCHED. It contains data about a pending host and its relationship to a likely matching host in the configured topology.

        :return: The matched_pending_host of this CheckedPendingHost.
        :rtype: MatchedPendingHost
        :required/optional: optional
        """
        return self._matched_pending_host

    @matched_pending_host.setter
    def matched_pending_host(self, matched_pending_host):
        """
        Sets the matched_pending_host of this CheckedPendingHost.
        This field is only present if type is PENDING_HOST_MATCHED. It contains data about a pending host and its relationship to a likely matching host in the configured topology.

        :param matched_pending_host: The matched_pending_host of this CheckedPendingHost.
        :type: MatchedPendingHost
        """
        self._matched_pending_host = matched_pending_host

    @property
    def unmatched_pending_host(self):
        """
        Gets the unmatched_pending_host of this CheckedPendingHost.
        This field is only present if type is PENDING_HOST_UNMATCHED. It contains data about a pending host that does not match any configured host and the relationship of that hosts ports to ports in the configured topology.

        :return: The unmatched_pending_host of this CheckedPendingHost.
        :rtype: UnmatchedPendingHost
        :required/optional: optional
        """
        return self._unmatched_pending_host

    @unmatched_pending_host.setter
    def unmatched_pending_host(self, unmatched_pending_host):
        """
        Sets the unmatched_pending_host of this CheckedPendingHost.
        This field is only present if type is PENDING_HOST_UNMATCHED. It contains data about a pending host that does not match any configured host and the relationship of that hosts ports to ports in the configured topology.

        :param unmatched_pending_host: The unmatched_pending_host of this CheckedPendingHost.
        :type: UnmatchedPendingHost
        """
        self._unmatched_pending_host = unmatched_pending_host

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

