# coding: utf-8

"""
ClusterPerformanceLimitationValues.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ClusterPerformanceLimitationValues(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ClusterPerformanceLimitationValues - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'cluster_ref': 'str',  # (required parameter)
            'max_iops_permitted_on_cluster': 'int',  # (required parameter)
            'max_m_bs_permitted_on_cluster': 'int',  # (required parameter)
            'iops_impacted_by_limitations_on_this_cluster': 'int'
        }

        self.attribute_map = {
            'cluster_ref': 'clusterRef',  # (required parameter)
            'max_iops_permitted_on_cluster': 'maxIopsPermittedOnCluster',  # (required parameter)
            'max_m_bs_permitted_on_cluster': 'maxMBsPermittedOnCluster',  # (required parameter)
            'iops_impacted_by_limitations_on_this_cluster': 'iopsImpactedByLimitationsOnThisCluster'
        }

        self._cluster_ref = None
        self._max_iops_permitted_on_cluster = None
        self._max_m_bs_permitted_on_cluster = None
        self._iops_impacted_by_limitations_on_this_cluster = None

    @property
    def cluster_ref(self):
        """
        Gets the cluster_ref of this ClusterPerformanceLimitationValues.
        This is a reference to the cluster for which the parameters apply.

        :return: The cluster_ref of this ClusterPerformanceLimitationValues.
        :rtype: str
        :required/optional: required
        """
        return self._cluster_ref

    @cluster_ref.setter
    def cluster_ref(self, cluster_ref):
        """
        Sets the cluster_ref of this ClusterPerformanceLimitationValues.
        This is a reference to the cluster for which the parameters apply.

        :param cluster_ref: The cluster_ref of this ClusterPerformanceLimitationValues.
        :type: str
        """
        self._cluster_ref = cluster_ref

    @property
    def max_iops_permitted_on_cluster(self):
        """
        Gets the max_iops_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        This is the maximum number of IOPs permitted on this cluster.

        :return: The max_iops_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        :rtype: int
        :required/optional: required
        """
        return self._max_iops_permitted_on_cluster

    @max_iops_permitted_on_cluster.setter
    def max_iops_permitted_on_cluster(self, max_iops_permitted_on_cluster):
        """
        Sets the max_iops_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        This is the maximum number of IOPs permitted on this cluster.

        :param max_iops_permitted_on_cluster: The max_iops_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        :type: int
        """
        self._max_iops_permitted_on_cluster = max_iops_permitted_on_cluster

    @property
    def max_m_bs_permitted_on_cluster(self):
        """
        Gets the max_m_bs_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        This is the maximum number of MB per second permitted on this cluster.

        :return: The max_m_bs_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        :rtype: int
        :required/optional: required
        """
        return self._max_m_bs_permitted_on_cluster

    @max_m_bs_permitted_on_cluster.setter
    def max_m_bs_permitted_on_cluster(self, max_m_bs_permitted_on_cluster):
        """
        Sets the max_m_bs_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        This is the maximum number of MB per second permitted on this cluster.

        :param max_m_bs_permitted_on_cluster: The max_m_bs_permitted_on_cluster of this ClusterPerformanceLimitationValues.
        :type: int
        """
        self._max_m_bs_permitted_on_cluster = max_m_bs_permitted_on_cluster

    @property
    def iops_impacted_by_limitations_on_this_cluster(self):
        """
        Gets the iops_impacted_by_limitations_on_this_cluster of this ClusterPerformanceLimitationValues.
        This is a count of the number of IOPs that have been impacted by the performance limitations set on this cluster.

        :return: The iops_impacted_by_limitations_on_this_cluster of this ClusterPerformanceLimitationValues.
        :rtype: int
        :required/optional: required
        """
        return self._iops_impacted_by_limitations_on_this_cluster

    @iops_impacted_by_limitations_on_this_cluster.setter
    def iops_impacted_by_limitations_on_this_cluster(self, iops_impacted_by_limitations_on_this_cluster):
        """
        Sets the iops_impacted_by_limitations_on_this_cluster of this ClusterPerformanceLimitationValues.
        This is a count of the number of IOPs that have been impacted by the performance limitations set on this cluster.

        :param iops_impacted_by_limitations_on_this_cluster: The iops_impacted_by_limitations_on_this_cluster of this ClusterPerformanceLimitationValues.
        :type: int
        """
        self._iops_impacted_by_limitations_on_this_cluster = iops_impacted_by_limitations_on_this_cluster

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

