# coding: utf-8

"""
ConcatVolumeNewVolumeCandidate.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ConcatVolumeNewVolumeCandidate(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ConcatVolumeNewVolumeCandidate - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'member_volume_label': 'str',  # (required parameter)
            'member_volume_group_label': 'str',  # (required parameter)
            'member_candidate': 'VolumeCandidate',  # (required parameter)
            'member_capacity': 'int'
        }

        self.attribute_map = {
            'member_volume_label': 'memberVolumeLabel',  # (required parameter)
            'member_volume_group_label': 'memberVolumeGroupLabel',  # (required parameter)
            'member_candidate': 'memberCandidate',  # (required parameter)
            'member_capacity': 'memberCapacity'
        }

        self._member_volume_label = None
        self._member_volume_group_label = None
        self._member_candidate = None
        self._member_capacity = None

    @property
    def member_volume_label(self):
        """
        Gets the member_volume_label of this ConcatVolumeNewVolumeCandidate.
        The label for the new member volume.

        :return: The member_volume_label of this ConcatVolumeNewVolumeCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._member_volume_label

    @member_volume_label.setter
    def member_volume_label(self, member_volume_label):
        """
        Sets the member_volume_label of this ConcatVolumeNewVolumeCandidate.
        The label for the new member volume.

        :param member_volume_label: The member_volume_label of this ConcatVolumeNewVolumeCandidate.
        :type: str
        """
        self._member_volume_label = member_volume_label

    @property
    def member_volume_group_label(self):
        """
        Gets the member_volume_group_label of this ConcatVolumeNewVolumeCandidate.
        An optional volume group label if creating a new volume group.

        :return: The member_volume_group_label of this ConcatVolumeNewVolumeCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._member_volume_group_label

    @member_volume_group_label.setter
    def member_volume_group_label(self, member_volume_group_label):
        """
        Sets the member_volume_group_label of this ConcatVolumeNewVolumeCandidate.
        An optional volume group label if creating a new volume group.

        :param member_volume_group_label: The member_volume_group_label of this ConcatVolumeNewVolumeCandidate.
        :type: str
        """
        self._member_volume_group_label = member_volume_group_label

    @property
    def member_candidate(self):
        """
        Gets the member_candidate of this ConcatVolumeNewVolumeCandidate.
        The candidate to be used to create the member volume.

        :return: The member_candidate of this ConcatVolumeNewVolumeCandidate.
        :rtype: VolumeCandidate
        :required/optional: required
        """
        return self._member_candidate

    @member_candidate.setter
    def member_candidate(self, member_candidate):
        """
        Sets the member_candidate of this ConcatVolumeNewVolumeCandidate.
        The candidate to be used to create the member volume.

        :param member_candidate: The member_candidate of this ConcatVolumeNewVolumeCandidate.
        :type: VolumeCandidate
        """
        self._member_candidate = member_candidate

    @property
    def member_capacity(self):
        """
        Gets the member_capacity of this ConcatVolumeNewVolumeCandidate.
        The capacity of the new volume to create, in bytes.

        :return: The member_capacity of this ConcatVolumeNewVolumeCandidate.
        :rtype: int
        :required/optional: required
        """
        return self._member_capacity

    @member_capacity.setter
    def member_capacity(self, member_capacity):
        """
        Sets the member_capacity of this ConcatVolumeNewVolumeCandidate.
        The capacity of the new volume to create, in bytes.

        :param member_capacity: The member_capacity of this ConcatVolumeNewVolumeCandidate.
        :type: int
        """
        self._member_capacity = member_capacity

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

