# coding: utf-8

"""
ConcatVolumeTrimDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ConcatVolumeTrimDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ConcatVolumeTrimDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'concat_vol': 'str',  # (required parameter)
            'trim_count': 'int',  # (required parameter)
            'retain_repository_members': 'bool'
        }

        self.attribute_map = {
            'concat_vol': 'concatVol',  # (required parameter)
            'trim_count': 'trimCount',  # (required parameter)
            'retain_repository_members': 'retainRepositoryMembers'
        }

        self._concat_vol = None
        self._trim_count = None
        self._retain_repository_members = None

    @property
    def concat_vol(self):
        """
        Gets the concat_vol of this ConcatVolumeTrimDescriptor.
        The ConcatVolume to trim.

        :return: The concat_vol of this ConcatVolumeTrimDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._concat_vol

    @concat_vol.setter
    def concat_vol(self, concat_vol):
        """
        Sets the concat_vol of this ConcatVolumeTrimDescriptor.
        The ConcatVolume to trim.

        :param concat_vol: The concat_vol of this ConcatVolumeTrimDescriptor.
        :type: str
        """
        self._concat_vol = concat_vol

    @property
    def trim_count(self):
        """
        Gets the trim_count of this ConcatVolumeTrimDescriptor.
        The number of members to remove (starting from the end). Must be less than or equal to the number of current members minus 1.

        :return: The trim_count of this ConcatVolumeTrimDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._trim_count

    @trim_count.setter
    def trim_count(self, trim_count):
        """
        Sets the trim_count of this ConcatVolumeTrimDescriptor.
        The number of members to remove (starting from the end). Must be less than or equal to the number of current members minus 1.

        :param trim_count: The trim_count of this ConcatVolumeTrimDescriptor.
        :type: int
        """
        self._trim_count = trim_count

    @property
    def retain_repository_members(self):
        """
        Gets the retain_repository_members of this ConcatVolumeTrimDescriptor.
        An indication of whether the member volumes removed should be deleted or retained.

        :return: The retain_repository_members of this ConcatVolumeTrimDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._retain_repository_members

    @retain_repository_members.setter
    def retain_repository_members(self, retain_repository_members):
        """
        Sets the retain_repository_members of this ConcatVolumeTrimDescriptor.
        An indication of whether the member volumes removed should be deleted or retained.

        :param retain_repository_members: The retain_repository_members of this ConcatVolumeTrimDescriptor.
        :type: bool
        """
        self._retain_repository_members = retain_repository_members

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

