# coding: utf-8

"""
CopyThenReplaceDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CopyThenReplaceDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CopyThenReplaceDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'drive_to_replace': 'str',  # (required parameter)
            'replacement_drive': 'str',  # (required parameter)
            'fail_after_evacuate': 'bool'
        }

        self.attribute_map = {
            'drive_to_replace': 'driveToReplace',  # (required parameter)
            'replacement_drive': 'replacementDrive',  # (required parameter)
            'fail_after_evacuate': 'failAfterEvacuate'
        }

        self._drive_to_replace = None
        self._replacement_drive = None
        self._fail_after_evacuate = None

    @property
    def drive_to_replace(self):
        """
        Gets the drive_to_replace of this CopyThenReplaceDescriptor.
        The drive to be replaced.

        :return: The drive_to_replace of this CopyThenReplaceDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._drive_to_replace

    @drive_to_replace.setter
    def drive_to_replace(self, drive_to_replace):
        """
        Sets the drive_to_replace of this CopyThenReplaceDescriptor.
        The drive to be replaced.

        :param drive_to_replace: The drive_to_replace of this CopyThenReplaceDescriptor.
        :type: str
        """
        self._drive_to_replace = drive_to_replace

    @property
    def replacement_drive(self):
        """
        Gets the replacement_drive of this CopyThenReplaceDescriptor.
        A reference to the replacement drive.

        :return: The replacement_drive of this CopyThenReplaceDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._replacement_drive

    @replacement_drive.setter
    def replacement_drive(self, replacement_drive):
        """
        Sets the replacement_drive of this CopyThenReplaceDescriptor.
        A reference to the replacement drive.

        :param replacement_drive: The replacement_drive of this CopyThenReplaceDescriptor.
        :type: str
        """
        self._replacement_drive = replacement_drive

    @property
    def fail_after_evacuate(self):
        """
        Gets the fail_after_evacuate of this CopyThenReplaceDescriptor.
        This flag indicates what the state of the source drive should be after the evacuation is complete. True means the source drive's Availability state should be set to FAILED after successful evacuation; False means the state should not change.

        :return: The fail_after_evacuate of this CopyThenReplaceDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._fail_after_evacuate

    @fail_after_evacuate.setter
    def fail_after_evacuate(self, fail_after_evacuate):
        """
        Sets the fail_after_evacuate of this CopyThenReplaceDescriptor.
        This flag indicates what the state of the source drive should be after the evacuation is complete. True means the source drive's Availability state should be set to FAILED after successful evacuation; False means the state should not change.

        :param fail_after_evacuate: The fail_after_evacuate of this CopyThenReplaceDescriptor.
        :type: bool
        """
        self._fail_after_evacuate = fail_after_evacuate

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

