# coding: utf-8

"""
DaylightSavingsTime.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DaylightSavingsTime(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DaylightSavingsTime - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'time': 'int',  # (required parameter)
            'clock_mode': 'str',  # (required parameter)
            'month': 'int',  # (required parameter)
            'day_of_month': 'int',  # (required parameter)
            'day_of_week': 'int'
        }

        self.attribute_map = {
            'time': 'time',  # (required parameter)
            'clock_mode': 'clockMode',  # (required parameter)
            'month': 'month',  # (required parameter)
            'day_of_month': 'dayOfMonth',  # (required parameter)
            'day_of_week': 'dayOfWeek'
        }

        self._time = None
        self._clock_mode = None
        self._month = None
        self._day_of_month = None
        self._day_of_week = None

    @property
    def time(self):
        """
        Gets the time of this DaylightSavingsTime.
        Time of day for DST change measured as seconds past midnight.

        :return: The time of this DaylightSavingsTime.
        :rtype: int
        :required/optional: required
        """
        return self._time

    @time.setter
    def time(self, time):
        """
        Sets the time of this DaylightSavingsTime.
        Time of day for DST change measured as seconds past midnight.

        :param time: The time of this DaylightSavingsTime.
        :type: int
        """
        self._time = time

    @property
    def clock_mode(self):
        """
        Gets the clock_mode of this DaylightSavingsTime.
        Reference for time.

        :return: The clock_mode of this DaylightSavingsTime.
        :rtype: str
        :required/optional: required
        """
        return self._clock_mode

    @clock_mode.setter
    def clock_mode(self, clock_mode):
        """
        Sets the clock_mode of this DaylightSavingsTime.
        Reference for time.

        :param clock_mode: The clock_mode of this DaylightSavingsTime.
        :type: str
        """
        allowed_values = ["unknown", "wallClockTime", "standardTime", "utcTime", "__UNDEFINED"]
        if clock_mode not in allowed_values:
            raise ValueError(
                "Invalid value for `clock_mode`, must be one of {0}"
                .format(allowed_values)
            )
        self._clock_mode = clock_mode

    @property
    def month(self):
        """
        Gets the month of this DaylightSavingsTime.
        Month value: 0 to 12 (and negatives).

        :return: The month of this DaylightSavingsTime.
        :rtype: int
        :required/optional: required
        """
        return self._month

    @month.setter
    def month(self, month):
        """
        Sets the month of this DaylightSavingsTime.
        Month value: 0 to 12 (and negatives).

        :param month: The month of this DaylightSavingsTime.
        :type: int
        """
        self._month = month

    @property
    def day_of_month(self):
        """
        Gets the day_of_month of this DaylightSavingsTime.
        Day of month: 0 to 31 (and negatives).

        :return: The day_of_month of this DaylightSavingsTime.
        :rtype: int
        :required/optional: required
        """
        return self._day_of_month

    @day_of_month.setter
    def day_of_month(self, day_of_month):
        """
        Sets the day_of_month of this DaylightSavingsTime.
        Day of month: 0 to 31 (and negatives).

        :param day_of_month: The day_of_month of this DaylightSavingsTime.
        :type: int
        """
        self._day_of_month = day_of_month

    @property
    def day_of_week(self):
        """
        Gets the day_of_week of this DaylightSavingsTime.
        Day of week: 0 to 7 (and negatives).

        :return: The day_of_week of this DaylightSavingsTime.
        :rtype: int
        :required/optional: required
        """
        return self._day_of_week

    @day_of_week.setter
    def day_of_week(self, day_of_week):
        """
        Sets the day_of_week of this DaylightSavingsTime.
        Day of week: 0 to 7 (and negatives).

        :param day_of_week: The day_of_week of this DaylightSavingsTime.
        :type: int
        """
        self._day_of_week = day_of_week

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

