# coding: utf-8

"""
DebugInfo.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DebugInfo(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DebugInfo - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'handle': 'str',  # (required parameter)
            'number_of_chunks': 'int',  # (required parameter)
            'debug_chunk_data': 'str',  # (required parameter)
            'next_chunk_to_retrieve': 'int'
        }

        self.attribute_map = {
            'handle': 'handle',  # (required parameter)
            'number_of_chunks': 'numberOfChunks',  # (required parameter)
            'debug_chunk_data': 'debugChunkData',  # (required parameter)
            'next_chunk_to_retrieve': 'nextChunkToRetrieve'
        }

        self._handle = None
        self._number_of_chunks = None
        self._debug_chunk_data = None
        self._next_chunk_to_retrieve = None

    @property
    def handle(self):
        """
        Gets the handle of this DebugInfo.
        The handle representing the collection of debug information extents for a particular controller.

        :return: The handle of this DebugInfo.
        :rtype: str
        :required/optional: required
        """
        return self._handle

    @handle.setter
    def handle(self, handle):
        """
        Sets the handle of this DebugInfo.
        The handle representing the collection of debug information extents for a particular controller.

        :param handle: The handle of this DebugInfo.
        :type: str
        """
        self._handle = handle

    @property
    def number_of_chunks(self):
        """
        Gets the number_of_chunks of this DebugInfo.
        Number of extents in the collection.

        :return: The number_of_chunks of this DebugInfo.
        :rtype: int
        :required/optional: required
        """
        return self._number_of_chunks

    @number_of_chunks.setter
    def number_of_chunks(self, number_of_chunks):
        """
        Sets the number_of_chunks of this DebugInfo.
        Number of extents in the collection.

        :param number_of_chunks: The number_of_chunks of this DebugInfo.
        :type: int
        """
        self._number_of_chunks = number_of_chunks

    @property
    def debug_chunk_data(self):
        """
        Gets the debug_chunk_data of this DebugInfo.
        An actual chunk of debug data.

        :return: The debug_chunk_data of this DebugInfo.
        :rtype: str
        :required/optional: required
        """
        return self._debug_chunk_data

    @debug_chunk_data.setter
    def debug_chunk_data(self, debug_chunk_data):
        """
        Sets the debug_chunk_data of this DebugInfo.
        An actual chunk of debug data.

        :param debug_chunk_data: The debug_chunk_data of this DebugInfo.
        :type: str
        """
        self._debug_chunk_data = debug_chunk_data

    @property
    def next_chunk_to_retrieve(self):
        """
        Gets the next_chunk_to_retrieve of this DebugInfo.
        The extent (chunk) to start with on next request.

        :return: The next_chunk_to_retrieve of this DebugInfo.
        :rtype: int
        :required/optional: required
        """
        return self._next_chunk_to_retrieve

    @next_chunk_to_retrieve.setter
    def next_chunk_to_retrieve(self, next_chunk_to_retrieve):
        """
        Sets the next_chunk_to_retrieve of this DebugInfo.
        The extent (chunk) to start with on next request.

        :param next_chunk_to_retrieve: The next_chunk_to_retrieve of this DebugInfo.
        :type: int
        """
        self._next_chunk_to_retrieve = next_chunk_to_retrieve

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

