# coding: utf-8

"""
DiscreteTimeSeriesDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DiscreteTimeSeriesDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DiscreteTimeSeriesDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'object_ref': 'ObjectReference',  # (required parameter)
            'stream_type': 'str',  # (required parameter)
            'duration': 'int'
        }

        self.attribute_map = {
            'object_ref': 'objectRef',  # (required parameter)
            'stream_type': 'streamType',  # (required parameter)
            'duration': 'duration'
        }

        self._object_ref = None
        self._stream_type = None
        self._duration = None

    @property
    def object_ref(self):
        """
        Gets the object_ref of this DiscreteTimeSeriesDescriptor.
        A reference to the storage array object (e.g., volume, drive, ets.) to observe.

        :return: The object_ref of this DiscreteTimeSeriesDescriptor.
        :rtype: ObjectReference
        :required/optional: required
        """
        return self._object_ref

    @object_ref.setter
    def object_ref(self, object_ref):
        """
        Sets the object_ref of this DiscreteTimeSeriesDescriptor.
        A reference to the storage array object (e.g., volume, drive, ets.) to observe.

        :param object_ref: The object_ref of this DiscreteTimeSeriesDescriptor.
        :type: ObjectReference
        """
        self._object_ref = object_ref

    @property
    def stream_type(self):
        """
        Gets the stream_type of this DiscreteTimeSeriesDescriptor.
        The type of statistic to observe in the activated stream.

        :return: The stream_type of this DiscreteTimeSeriesDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._stream_type

    @stream_type.setter
    def stream_type(self, stream_type):
        """
        Sets the stream_type of this DiscreteTimeSeriesDescriptor.
        The type of statistic to observe in the activated stream.

        :param stream_type: The stream_type of this DiscreteTimeSeriesDescriptor.
        :type: str
        """
        allowed_values = ["acpu0", "acpu1", "ciqr", "diqr", "dirt", "hirt", "__UNDEFINED"]
        if stream_type not in allowed_values:
            raise ValueError(
                "Invalid value for `stream_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._stream_type = stream_type

    @property
    def duration(self):
        """
        Gets the duration of this DiscreteTimeSeriesDescriptor.
        The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten.

        :return: The duration of this DiscreteTimeSeriesDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """
        Sets the duration of this DiscreteTimeSeriesDescriptor.
        The amount of time, expressed in seconds, to spend recording observations. If the discrete time series is not retrieved by the client before the end of the duration, the stream wraps around, i.e., observations will be overwritten.

        :param duration: The duration of this DiscreteTimeSeriesDescriptor.
        :type: int
        """
        self._duration = duration

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

