# coding: utf-8

"""
DPLCoreDumpDetail.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DPLCoreDumpDetail(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DPLCoreDumpDetail - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'reason': 'str',  # (required parameter)
            'fw_location': 'DPLCoreDumpFWLocation',  
            'panic_reason': 'str'
        }

        self.attribute_map = {
            'reason': 'reason',  # (required parameter)
            'fw_location': 'fwLocation',  
            'panic_reason': 'panicReason'
        }

        self._reason = None
        self._fw_location = None
        self._panic_reason = None

    @property
    def reason(self):
        """
        Gets the reason of this DPLCoreDumpDetail.
        This enumeration identifies the reason for a DPL core dump.

        :return: The reason of this DPLCoreDumpDetail.
        :rtype: str
        :required/optional: required
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """
        Sets the reason of this DPLCoreDumpDetail.
        This enumeration identifies the reason for a DPL core dump.

        :param reason: The reason of this DPLCoreDumpDetail.
        :type: str
        """
        allowed_values = ["reasonUnknown", "reasonAssert", "reasonPanic", "reasonOther", "__UNDEFINED"]
        if reason not in allowed_values:
            raise ValueError(
                "Invalid value for `reason`, must be one of {0}"
                .format(allowed_values)
            )
        self._reason = reason

    @property
    def fw_location(self):
        """
        Gets the fw_location of this DPLCoreDumpDetail.
        This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_ASSERT. In the case of an assertion this structure will contain the firmware location.

        :return: The fw_location of this DPLCoreDumpDetail.
        :rtype: DPLCoreDumpFWLocation
        :required/optional: optional
        """
        return self._fw_location

    @fw_location.setter
    def fw_location(self, fw_location):
        """
        Sets the fw_location of this DPLCoreDumpDetail.
        This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_ASSERT. In the case of an assertion this structure will contain the firmware location.

        :param fw_location: The fw_location of this DPLCoreDumpDetail.
        :type: DPLCoreDumpFWLocation
        """
        self._fw_location = fw_location

    @property
    def panic_reason(self):
        """
        Gets the panic_reason of this DPLCoreDumpDetail.
        This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_PANIC. It contains a string with the panic message.

        :return: The panic_reason of this DPLCoreDumpDetail.
        :rtype: str
        :required/optional: optional
        """
        return self._panic_reason

    @panic_reason.setter
    def panic_reason(self, panic_reason):
        """
        Sets the panic_reason of this DPLCoreDumpDetail.
        This field is present only if the value of reason is equal to DPL_CORE_DUMP_REASON_PANIC. It contains a string with the panic message.

        :param panic_reason: The panic_reason of this DPLCoreDumpDetail.
        :type: str
        """
        self._panic_reason = panic_reason

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

