# coding: utf-8

"""
DqRetrieveStartDetails.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DqRetrieveStartDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DqRetrieveStartDetails - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'compress': 'bool',  # (required parameter)
            'trace_id': 'str',  # (required parameter)
            'flush_current': 'bool'
        }

        self.attribute_map = {
            'compress': 'compress',  # (required parameter)
            'trace_id': 'traceID',  # (required parameter)
            'flush_current': 'flushCurrent'
        }

        self._compress = None
        self._trace_id = None
        self._flush_current = None

    @property
    def compress(self):
        """
        Gets the compress of this DqRetrieveStartDetails.
        When set to true, the data is compressed for the retrieval.

        :return: The compress of this DqRetrieveStartDetails.
        :rtype: bool
        :required/optional: required
        """
        return self._compress

    @compress.setter
    def compress(self, compress):
        """
        Sets the compress of this DqRetrieveStartDetails.
        When set to true, the data is compressed for the retrieval.

        :param compress: The compress of this DqRetrieveStartDetails.
        :type: bool
        """
        self._compress = compress

    @property
    def trace_id(self):
        """
        Gets the trace_id of this DqRetrieveStartDetails.
        set to the type of trace buffers to retrieve

        :return: The trace_id of this DqRetrieveStartDetails.
        :rtype: str
        :required/optional: required
        """
        return self._trace_id

    @trace_id.setter
    def trace_id(self, trace_id):
        """
        Sets the trace_id of this DqRetrieveStartDetails.
        set to the type of trace buffers to retrieve

        :param trace_id: The trace_id of this DqRetrieveStartDetails.
        :type: str
        """
        allowed_values = ["dqtraceCurrent", "rawdataFlushed", "rawdataAll", "rawdataAllIncludePlatform", "__UNDEFINED"]
        if trace_id not in allowed_values:
            raise ValueError(
                "Invalid value for `trace_id`, must be one of {0}"
                .format(allowed_values)
            )
        self._trace_id = trace_id

    @property
    def flush_current(self):
        """
        Gets the flush_current of this DqRetrieveStartDetails.
        indicates whether the retrieved buffer is to be flushed

        :return: The flush_current of this DqRetrieveStartDetails.
        :rtype: bool
        :required/optional: required
        """
        return self._flush_current

    @flush_current.setter
    def flush_current(self, flush_current):
        """
        Sets the flush_current of this DqRetrieveStartDetails.
        indicates whether the retrieved buffer is to be flushed

        :param flush_current: The flush_current of this DqRetrieveStartDetails.
        :type: bool
        """
        self._flush_current = flush_current

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

