# coding: utf-8

"""
EnhEthTLV.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class EnhEthTLV(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EnhEthTLV - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'enh_eth_tlv_type': 'str',  # (required parameter)
            'chassis_idtlv': 'ChassisIDTLV',  
            'port_idtlv': 'PortIDTLV',  
            'time_to_live_tlv': 'TimeToLiveTLV'
        }

        self.attribute_map = {
            'enh_eth_tlv_type': 'enhEthTLVType',  # (required parameter)
            'chassis_idtlv': 'chassisIDTLV',  
            'port_idtlv': 'portIDTLV',  
            'time_to_live_tlv': 'timeToLiveTLV'
        }

        self._enh_eth_tlv_type = None
        self._chassis_idtlv = None
        self._port_idtlv = None
        self._time_to_live_tlv = None

    @property
    def enh_eth_tlv_type(self):
        """
        Gets the enh_eth_tlv_type of this EnhEthTLV.
        An enumeration that includes Time Length Value (TLV)Types for Enhanced Ethernet. Refer to the IEEE Std 802.1AB-2005

        :return: The enh_eth_tlv_type of this EnhEthTLV.
        :rtype: str
        :required/optional: required
        """
        return self._enh_eth_tlv_type

    @enh_eth_tlv_type.setter
    def enh_eth_tlv_type(self, enh_eth_tlv_type):
        """
        Sets the enh_eth_tlv_type of this EnhEthTLV.
        An enumeration that includes Time Length Value (TLV)Types for Enhanced Ethernet. Refer to the IEEE Std 802.1AB-2005

        :param enh_eth_tlv_type: The enh_eth_tlv_type of this EnhEthTLV.
        :type: str
        """
        allowed_values = ["unknown", "chassisid", "portid", "timetolive", "__UNDEFINED"]
        if enh_eth_tlv_type not in allowed_values:
            raise ValueError(
                "Invalid value for `enh_eth_tlv_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._enh_eth_tlv_type = enh_eth_tlv_type

    @property
    def chassis_idtlv(self):
        """
        Gets the chassis_idtlv of this EnhEthTLV.
        This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_CHASSISID.

        :return: The chassis_idtlv of this EnhEthTLV.
        :rtype: ChassisIDTLV
        :required/optional: optional
        """
        return self._chassis_idtlv

    @chassis_idtlv.setter
    def chassis_idtlv(self, chassis_idtlv):
        """
        Sets the chassis_idtlv of this EnhEthTLV.
        This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_CHASSISID.

        :param chassis_idtlv: The chassis_idtlv of this EnhEthTLV.
        :type: ChassisIDTLV
        """
        self._chassis_idtlv = chassis_idtlv

    @property
    def port_idtlv(self):
        """
        Gets the port_idtlv of this EnhEthTLV.
        This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_PORTID.

        :return: The port_idtlv of this EnhEthTLV.
        :rtype: PortIDTLV
        :required/optional: optional
        """
        return self._port_idtlv

    @port_idtlv.setter
    def port_idtlv(self, port_idtlv):
        """
        Sets the port_idtlv of this EnhEthTLV.
        This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_PORTID.

        :param port_idtlv: The port_idtlv of this EnhEthTLV.
        :type: PortIDTLV
        """
        self._port_idtlv = port_idtlv

    @property
    def time_to_live_tlv(self):
        """
        Gets the time_to_live_tlv of this EnhEthTLV.
        This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_TIMETOLIVE.

        :return: The time_to_live_tlv of this EnhEthTLV.
        :rtype: TimeToLiveTLV
        :required/optional: optional
        """
        return self._time_to_live_tlv

    @time_to_live_tlv.setter
    def time_to_live_tlv(self, time_to_live_tlv):
        """
        Sets the time_to_live_tlv of this EnhEthTLV.
        This field is mandatory and conveys its information when the enhEthTLVType is equal to ENH_ETH_TLV_TIMETOLIVE.

        :param time_to_live_tlv: The time_to_live_tlv of this EnhEthTLV.
        :type: TimeToLiveTLV
        """
        self._time_to_live_tlv = time_to_live_tlv

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

