# coding: utf-8

"""
EsmInterfaceAttributes.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class EsmInterfaceAttributes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EsmInterfaceAttributes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'io_interface_type': 'str',  # (required parameter)
            'fibre_esm_attributes': 'FibreEsmAttributes',  
            'sas_esm_attributes': 'SasEsmAttributes'
        }

        self.attribute_map = {
            'io_interface_type': 'ioInterfaceType',  # (required parameter)
            'fibre_esm_attributes': 'fibreEsmAttributes',  
            'sas_esm_attributes': 'sasEsmAttributes'
        }

        self._io_interface_type = None
        self._fibre_esm_attributes = None
        self._sas_esm_attributes = None

    @property
    def io_interface_type(self):
        """
        Gets the io_interface_type of this EsmInterfaceAttributes.
        This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller.

        :return: The io_interface_type of this EsmInterfaceAttributes.
        :rtype: str
        :required/optional: required
        """
        return self._io_interface_type

    @io_interface_type.setter
    def io_interface_type(self, io_interface_type):
        """
        Sets the io_interface_type of this EsmInterfaceAttributes.
        This enumeration defines the different I/O interface types that may be reported as part of the configuration information associated with a controller.

        :param io_interface_type: The io_interface_type of this EsmInterfaceAttributes.
        :type: str
        """
        allowed_values = ["notImplemented", "scsi", "fc", "sata", "sas", "iscsi", "ib", "fcoe", "__UNDEFINED"]
        if io_interface_type not in allowed_values:
            raise ValueError(
                "Invalid value for `io_interface_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._io_interface_type = io_interface_type

    @property
    def fibre_esm_attributes(self):
        """
        Gets the fibre_esm_attributes of this EsmInterfaceAttributes.
        This field is only present if the ioInterfaceType value is IO_IF_FC. It contains attributes that are specific to fibre channel ESMs.

        :return: The fibre_esm_attributes of this EsmInterfaceAttributes.
        :rtype: FibreEsmAttributes
        :required/optional: optional
        """
        return self._fibre_esm_attributes

    @fibre_esm_attributes.setter
    def fibre_esm_attributes(self, fibre_esm_attributes):
        """
        Sets the fibre_esm_attributes of this EsmInterfaceAttributes.
        This field is only present if the ioInterfaceType value is IO_IF_FC. It contains attributes that are specific to fibre channel ESMs.

        :param fibre_esm_attributes: The fibre_esm_attributes of this EsmInterfaceAttributes.
        :type: FibreEsmAttributes
        """
        self._fibre_esm_attributes = fibre_esm_attributes

    @property
    def sas_esm_attributes(self):
        """
        Gets the sas_esm_attributes of this EsmInterfaceAttributes.
        This field is only present if the ioInterfaceType value is IO_IF_SAS. It contains attributes that are specific serial-attached SCSI ESMs.

        :return: The sas_esm_attributes of this EsmInterfaceAttributes.
        :rtype: SasEsmAttributes
        :required/optional: optional
        """
        return self._sas_esm_attributes

    @sas_esm_attributes.setter
    def sas_esm_attributes(self, sas_esm_attributes):
        """
        Sets the sas_esm_attributes of this EsmInterfaceAttributes.
        This field is only present if the ioInterfaceType value is IO_IF_SAS. It contains attributes that are specific serial-attached SCSI ESMs.

        :param sas_esm_attributes: The sas_esm_attributes of this EsmInterfaceAttributes.
        :type: SasEsmAttributes
        """
        self._sas_esm_attributes = sas_esm_attributes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

