# coding: utf-8

"""
EthernetParamsUpdateDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class EthernetParamsUpdateDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EthernetParamsUpdateDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'controller_ref': 'str',  # (required parameter)
            'interface_name': 'str',  # (required parameter)
            'channel': 'int',  # (required parameter)
            'ip': 'int',  # (required parameter)
            'gateway_ip': 'int',  # (required parameter)
            'subnet_mask': 'int'
        }

        self.attribute_map = {
            'controller_ref': 'controllerRef',  # (required parameter)
            'interface_name': 'interfaceName',  # (required parameter)
            'channel': 'channel',  # (required parameter)
            'ip': 'ip',  # (required parameter)
            'gateway_ip': 'gatewayIp',  # (required parameter)
            'subnet_mask': 'subnetMask'
        }

        self._controller_ref = None
        self._interface_name = None
        self._channel = None
        self._ip = None
        self._gateway_ip = None
        self._subnet_mask = None

    @property
    def controller_ref(self):
        """
        Gets the controller_ref of this EthernetParamsUpdateDescriptor.
        The intended target of this command.

        :return: The controller_ref of this EthernetParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._controller_ref

    @controller_ref.setter
    def controller_ref(self, controller_ref):
        """
        Sets the controller_ref of this EthernetParamsUpdateDescriptor.
        The intended target of this command.

        :param controller_ref: The controller_ref of this EthernetParamsUpdateDescriptor.
        :type: str
        """
        self._controller_ref = controller_ref

    @property
    def interface_name(self):
        """
        Gets the interface_name of this EthernetParamsUpdateDescriptor.
        Name of Ethernet port, as reported by bootWare.

        :return: The interface_name of this EthernetParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._interface_name

    @interface_name.setter
    def interface_name(self, interface_name):
        """
        Sets the interface_name of this EthernetParamsUpdateDescriptor.
        Name of Ethernet port, as reported by bootWare.

        :param interface_name: The interface_name of this EthernetParamsUpdateDescriptor.
        :type: str
        """
        self._interface_name = interface_name

    @property
    def channel(self):
        """
        Gets the channel of this EthernetParamsUpdateDescriptor.
        The channel number of this interface.

        :return: The channel of this EthernetParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """
        Sets the channel of this EthernetParamsUpdateDescriptor.
        The channel number of this interface.

        :param channel: The channel of this EthernetParamsUpdateDescriptor.
        :type: int
        """
        self._channel = channel

    @property
    def ip(self):
        """
        Gets the ip of this EthernetParamsUpdateDescriptor.
        IP address of the controller. 0 - use bootp.

        :return: The ip of this EthernetParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._ip

    @ip.setter
    def ip(self, ip):
        """
        Sets the ip of this EthernetParamsUpdateDescriptor.
        IP address of the controller. 0 - use bootp.

        :param ip: The ip of this EthernetParamsUpdateDescriptor.
        :type: int
        """
        self._ip = ip

    @property
    def gateway_ip(self):
        """
        Gets the gateway_ip of this EthernetParamsUpdateDescriptor.
        IP address of the gateway.

        :return: The gateway_ip of this EthernetParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._gateway_ip

    @gateway_ip.setter
    def gateway_ip(self, gateway_ip):
        """
        Sets the gateway_ip of this EthernetParamsUpdateDescriptor.
        IP address of the gateway.

        :param gateway_ip: The gateway_ip of this EthernetParamsUpdateDescriptor.
        :type: int
        """
        self._gateway_ip = gateway_ip

    @property
    def subnet_mask(self):
        """
        Gets the subnet_mask of this EthernetParamsUpdateDescriptor.
        Network subnet mask.

        :return: The subnet_mask of this EthernetParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._subnet_mask

    @subnet_mask.setter
    def subnet_mask(self, subnet_mask):
        """
        Sets the subnet_mask of this EthernetParamsUpdateDescriptor.
        Network subnet mask.

        :param subnet_mask: The subnet_mask of this EthernetParamsUpdateDescriptor.
        :type: int
        """
        self._subnet_mask = subnet_mask

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

