# coding: utf-8

"""
HostPortCreationDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HostPortCreationDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HostPortCreationDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host_port_name': 'str',  # (required parameter)
            'label': 'str',  # (required parameter)
            'host_port_type_index': 'int',  # (required parameter)
            'host_ref': 'str',  # (required parameter)
            'settings': 'HostPortChangeableProperties'
        }

        self.attribute_map = {
            'host_port_name': 'hostPortName',  # (required parameter)
            'label': 'label',  # (required parameter)
            'host_port_type_index': 'hostPortTypeIndex',  # (required parameter)
            'host_ref': 'hostRef',  # (required parameter)
            'settings': 'settings'
        }

        self._host_port_name = None
        self._label = None
        self._host_port_type_index = None
        self._host_ref = None
        self._settings = None

    @property
    def host_port_name(self):
        """
        Gets the host_port_name of this HostPortCreationDescriptor.
        The unique, externally-defined identifier for this object. For example, for a Fibre Channel host port, this field contains the value of the Fibre Channel world-wide name for the port.

        :return: The host_port_name of this HostPortCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._host_port_name

    @host_port_name.setter
    def host_port_name(self, host_port_name):
        """
        Sets the host_port_name of this HostPortCreationDescriptor.
        The unique, externally-defined identifier for this object. For example, for a Fibre Channel host port, this field contains the value of the Fibre Channel world-wide name for the port.

        :param host_port_name: The host_port_name of this HostPortCreationDescriptor.
        :type: str
        """
        self._host_port_name = host_port_name

    @property
    def label(self):
        """
        Gets the label of this HostPortCreationDescriptor.
        The user-assigned, descriptive label string for the host port.

        :return: The label of this HostPortCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this HostPortCreationDescriptor.
        The user-assigned, descriptive label string for the host port.

        :param label: The label of this HostPortCreationDescriptor.
        :type: str
        """
        self._label = label

    @property
    def host_port_type_index(self):
        """
        Gets the host_port_type_index of this HostPortCreationDescriptor.
        An index value that indicates the type of host port. This value is used to reference the appropriate entry in the hostPortType field of the associated StorageArray object.

        :return: The host_port_type_index of this HostPortCreationDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._host_port_type_index

    @host_port_type_index.setter
    def host_port_type_index(self, host_port_type_index):
        """
        Sets the host_port_type_index of this HostPortCreationDescriptor.
        An index value that indicates the type of host port. This value is used to reference the appropriate entry in the hostPortType field of the associated StorageArray object.

        :param host_port_type_index: The host_port_type_index of this HostPortCreationDescriptor.
        :type: int
        """
        self._host_port_type_index = host_port_type_index

    @property
    def host_ref(self):
        """
        Gets the host_ref of this HostPortCreationDescriptor.
        The host reference value of the host in which this port resides.

        :return: The host_ref of this HostPortCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._host_ref

    @host_ref.setter
    def host_ref(self, host_ref):
        """
        Sets the host_ref of this HostPortCreationDescriptor.
        The host reference value of the host in which this port resides.

        :param host_ref: The host_ref of this HostPortCreationDescriptor.
        :type: str
        """
        self._host_ref = host_ref

    @property
    def settings(self):
        """
        Gets the settings of this HostPortCreationDescriptor.
        The settings to apply to the new host port. This field is in place of the above deprecated fields.

        :return: The settings of this HostPortCreationDescriptor.
        :rtype: HostPortChangeableProperties
        :required/optional: required
        """
        return self._settings

    @settings.setter
    def settings(self, settings):
        """
        Sets the settings of this HostPortCreationDescriptor.
        The settings to apply to the new host port. This field is in place of the above deprecated fields.

        :param settings: The settings of this HostPortCreationDescriptor.
        :type: HostPortChangeableProperties
        """
        self._settings = settings

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

