# coding: utf-8

"""
HostPortMutableProperties.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HostPortMutableProperties(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HostPortMutableProperties - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'label': 'list[str]',  # (required parameter)
            'host_ref': 'list[str]',  # (required parameter)
            'port_id': 'list[SCSIInitiatorPortId]'
        }

        self.attribute_map = {
            'label': 'label',  # (required parameter)
            'host_ref': 'hostRef',  # (required parameter)
            'port_id': 'portId'
        }

        self._label = None
        self._host_ref = None
        self._port_id = None

    @property
    def label(self):
        """
        Gets the label of this HostPortMutableProperties.
        Either an empty field (length indicator = 0) signifying no change, or the new value of the user-assigned label for the port.r

        :return: The label of this HostPortMutableProperties.
        :rtype: list[str]
        :required/optional: required
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this HostPortMutableProperties.
        Either an empty field (length indicator = 0) signifying no change, or the new value of the user-assigned label for the port.r

        :param label: The label of this HostPortMutableProperties.
        :type: list[str]
        """
        self._label = label

    @property
    def host_ref(self):
        """
        Gets the host_ref of this HostPortMutableProperties.
        Either an empty field (length indicator = 0) signifying no change, or the new value of the hostRef field used to associate the port with a host.

        :return: The host_ref of this HostPortMutableProperties.
        :rtype: list[str]
        :required/optional: required
        """
        return self._host_ref

    @host_ref.setter
    def host_ref(self, host_ref):
        """
        Sets the host_ref of this HostPortMutableProperties.
        Either an empty field (length indicator = 0) signifying no change, or the new value of the hostRef field used to associate the port with a host.

        :param host_ref: The host_ref of this HostPortMutableProperties.
        :type: list[str]
        """
        self._host_ref = host_ref

    @property
    def port_id(self):
        """
        Gets the port_id of this HostPortMutableProperties.
        Either an empty field (length indicator = 0) signifying no change, or the new value of the I/O-protocol-based unique port identifier

        :return: The port_id of this HostPortMutableProperties.
        :rtype: list[SCSIInitiatorPortId]
        :required/optional: required
        """
        return self._port_id

    @port_id.setter
    def port_id(self, port_id):
        """
        Sets the port_id of this HostPortMutableProperties.
        Either an empty field (length indicator = 0) signifying no change, or the new value of the I/O-protocol-based unique port identifier

        :param port_id: The port_id of this HostPortMutableProperties.
        :type: list[SCSIInitiatorPortId]
        """
        self._port_id = port_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

