# coding: utf-8

"""
IbBaselinedStatistics.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IbBaselinedStatistics(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IbBaselinedStatistics - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'time_data': 'StatisticalTimeData',  # (required parameter)
            'ib_interface_statistics_raw': 'list[IbInterfaceStatistics]',  # (required parameter)
            'ib_interface_statistics_rel': 'list[IbInterfaceStatistics]'
        }

        self.attribute_map = {
            'time_data': 'timeData',  # (required parameter)
            'ib_interface_statistics_raw': 'ibInterfaceStatisticsRaw',  # (required parameter)
            'ib_interface_statistics_rel': 'ibInterfaceStatisticsRel'
        }

        self._time_data = None
        self._ib_interface_statistics_raw = None
        self._ib_interface_statistics_rel = None

    @property
    def time_data(self):
        """
        Gets the time_data of this IbBaselinedStatistics.
        The time data associated with this set of statistics.

        :return: The time_data of this IbBaselinedStatistics.
        :rtype: StatisticalTimeData
        :required/optional: required
        """
        return self._time_data

    @time_data.setter
    def time_data(self, time_data):
        """
        Sets the time_data of this IbBaselinedStatistics.
        The time data associated with this set of statistics.

        :param time_data: The time_data of this IbBaselinedStatistics.
        :type: StatisticalTimeData
        """
        self._time_data = time_data

    @property
    def ib_interface_statistics_raw(self):
        """
        Gets the ib_interface_statistics_raw of this IbBaselinedStatistics.
        An array of structures containing \"raw\" (i.e., baseline = controller start-of-day) InfiniBand host interface statistics, one structure per InfiniBand interface.

        :return: The ib_interface_statistics_raw of this IbBaselinedStatistics.
        :rtype: list[IbInterfaceStatistics]
        :required/optional: required
        """
        return self._ib_interface_statistics_raw

    @ib_interface_statistics_raw.setter
    def ib_interface_statistics_raw(self, ib_interface_statistics_raw):
        """
        Sets the ib_interface_statistics_raw of this IbBaselinedStatistics.
        An array of structures containing \"raw\" (i.e., baseline = controller start-of-day) InfiniBand host interface statistics, one structure per InfiniBand interface.

        :param ib_interface_statistics_raw: The ib_interface_statistics_raw of this IbBaselinedStatistics.
        :type: list[IbInterfaceStatistics]
        """
        self._ib_interface_statistics_raw = ib_interface_statistics_raw

    @property
    def ib_interface_statistics_rel(self):
        """
        Gets the ib_interface_statistics_rel of this IbBaselinedStatistics.
        An array of structures containing \"relative\" (i.e., baseline = user pre-set baseline) InfiniBand host interface statistics, one structure per InfiniBand interface.

        :return: The ib_interface_statistics_rel of this IbBaselinedStatistics.
        :rtype: list[IbInterfaceStatistics]
        :required/optional: required
        """
        return self._ib_interface_statistics_rel

    @ib_interface_statistics_rel.setter
    def ib_interface_statistics_rel(self, ib_interface_statistics_rel):
        """
        Sets the ib_interface_statistics_rel of this IbBaselinedStatistics.
        An array of structures containing \"relative\" (i.e., baseline = user pre-set baseline) InfiniBand host interface statistics, one structure per InfiniBand interface.

        :param ib_interface_statistics_rel: The ib_interface_statistics_rel of this IbBaselinedStatistics.
        :type: list[IbInterfaceStatistics]
        """
        self._ib_interface_statistics_rel = ib_interface_statistics_rel

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

