# coding: utf-8

"""
IbIocAttributes.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IbIocAttributes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IbIocAttributes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host_board_ref': 'str',  # (required parameter)
            'ioc_profile': 'IbIocProfile',  # (required parameter)
            'service_entries': 'list[IbServiceEntry]'
        }

        self.attribute_map = {
            'host_board_ref': 'hostBoardRef',  # (required parameter)
            'ioc_profile': 'iocProfile',  # (required parameter)
            'service_entries': 'serviceEntries'
        }

        self._host_board_ref = None
        self._ioc_profile = None
        self._service_entries = None

    @property
    def host_board_ref(self):
        """
        Gets the host_board_ref of this IbIocAttributes.
        A reference to the host board (a.k.a., InfiniBand Target Channel Adapter) with which the I/O controller is associated.

        :return: The host_board_ref of this IbIocAttributes.
        :rtype: str
        :required/optional: required
        """
        return self._host_board_ref

    @host_board_ref.setter
    def host_board_ref(self, host_board_ref):
        """
        Sets the host_board_ref of this IbIocAttributes.
        A reference to the host board (a.k.a., InfiniBand Target Channel Adapter) with which the I/O controller is associated.

        :param host_board_ref: The host_board_ref of this IbIocAttributes.
        :type: str
        """
        self._host_board_ref = host_board_ref

    @property
    def ioc_profile(self):
        """
        Gets the ioc_profile of this IbIocAttributes.
        The I/O controller profile for the storage array controller.

        :return: The ioc_profile of this IbIocAttributes.
        :rtype: IbIocProfile
        :required/optional: required
        """
        return self._ioc_profile

    @ioc_profile.setter
    def ioc_profile(self, ioc_profile):
        """
        Sets the ioc_profile of this IbIocAttributes.
        The I/O controller profile for the storage array controller.

        :param ioc_profile: The ioc_profile of this IbIocAttributes.
        :type: IbIocProfile
        """
        self._ioc_profile = ioc_profile

    @property
    def service_entries(self):
        """
        Gets the service_entries of this IbIocAttributes.
        An array of structures indicating the services that are provided by the InfiniBand I/O controller.

        :return: The service_entries of this IbIocAttributes.
        :rtype: list[IbServiceEntry]
        :required/optional: required
        """
        return self._service_entries

    @service_entries.setter
    def service_entries(self, service_entries):
        """
        Sets the service_entries of this IbIocAttributes.
        An array of structures indicating the services that are provided by the InfiniBand I/O controller.

        :param service_entries: The service_entries of this IbIocAttributes.
        :type: list[IbServiceEntry]
        """
        self._service_entries = service_entries

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

