# coding: utf-8

"""
IbPortPartitionTable.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IbPortPartitionTable(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IbPortPartitionTable - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'controller_ref': 'str',  # (required parameter)
            'port_number': 'int',  # (required parameter)
            'port_guid': 'str',  # (required parameter)
            'tca_guid': 'str',  # (required parameter)
            'pkeys': 'list[int]'
        }

        self.attribute_map = {
            'controller_ref': 'controllerRef',  # (required parameter)
            'port_number': 'portNumber',  # (required parameter)
            'port_guid': 'portGuid',  # (required parameter)
            'tca_guid': 'tcaGuid',  # (required parameter)
            'pkeys': 'pkeys'
        }

        self._controller_ref = None
        self._port_number = None
        self._port_guid = None
        self._tca_guid = None
        self._pkeys = None

    @property
    def controller_ref(self):
        """
        Gets the controller_ref of this IbPortPartitionTable.
        A reference to the controller that is associated with the port described by this structure.

        :return: The controller_ref of this IbPortPartitionTable.
        :rtype: str
        :required/optional: required
        """
        return self._controller_ref

    @controller_ref.setter
    def controller_ref(self, controller_ref):
        """
        Sets the controller_ref of this IbPortPartitionTable.
        A reference to the controller that is associated with the port described by this structure.

        :param controller_ref: The controller_ref of this IbPortPartitionTable.
        :type: str
        """
        self._controller_ref = controller_ref

    @property
    def port_number(self):
        """
        Gets the port_number of this IbPortPartitionTable.
        The controller-relative number of the port for which the table applies.

        :return: The port_number of this IbPortPartitionTable.
        :rtype: int
        :required/optional: required
        """
        return self._port_number

    @port_number.setter
    def port_number(self, port_number):
        """
        Sets the port_number of this IbPortPartitionTable.
        The controller-relative number of the port for which the table applies.

        :param port_number: The port_number of this IbPortPartitionTable.
        :type: int
        """
        self._port_number = port_number

    @property
    def port_guid(self):
        """
        Gets the port_guid of this IbPortPartitionTable.
        The globally-unique identifier associated with the port.

        :return: The port_guid of this IbPortPartitionTable.
        :rtype: str
        :required/optional: required
        """
        return self._port_guid

    @port_guid.setter
    def port_guid(self, port_guid):
        """
        Sets the port_guid of this IbPortPartitionTable.
        The globally-unique identifier associated with the port.

        :param port_guid: The port_guid of this IbPortPartitionTable.
        :type: str
        """
        self._port_guid = port_guid

    @property
    def tca_guid(self):
        """
        Gets the tca_guid of this IbPortPartitionTable.
        The globally-unique identifier of the Target Channel Adapter that controls the port.

        :return: The tca_guid of this IbPortPartitionTable.
        :rtype: str
        :required/optional: required
        """
        return self._tca_guid

    @tca_guid.setter
    def tca_guid(self, tca_guid):
        """
        Sets the tca_guid of this IbPortPartitionTable.
        The globally-unique identifier of the Target Channel Adapter that controls the port.

        :param tca_guid: The tca_guid of this IbPortPartitionTable.
        :type: str
        """
        self._tca_guid = tca_guid

    @property
    def pkeys(self):
        """
        Gets the pkeys of this IbPortPartitionTable.
        An array containing the partition keys for the port.

        :return: The pkeys of this IbPortPartitionTable.
        :rtype: list[int]
        :required/optional: required
        """
        return self._pkeys

    @pkeys.setter
    def pkeys(self, pkeys):
        """
        Sets the pkeys of this IbPortPartitionTable.
        An array containing the partition keys for the port.

        :param pkeys: The pkeys of this IbPortPartitionTable.
        :type: list[int]
        """
        self._pkeys = pkeys

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

