# coding: utf-8

"""
InterposerTypeData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class InterposerTypeData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        InterposerTypeData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'interposer_type': 'str',  # (required parameter)
            'fc_sas_interposer': 'InterposerData',  
            'reserved': 'str'
        }

        self.attribute_map = {
            'interposer_type': 'interposerType',  # (required parameter)
            'fc_sas_interposer': 'fcSasInterposer',  
            'reserved': 'reserved'
        }

        self._interposer_type = None
        self._fc_sas_interposer = None
        self._reserved = None

    @property
    def interposer_type(self):
        """
        Gets the interposer_type of this InterposerTypeData.
        This enumeration defines the different interposer types.

        :return: The interposer_type of this InterposerTypeData.
        :rtype: str
        :required/optional: required
        """
        return self._interposer_type

    @interposer_type.setter
    def interposer_type(self, interposer_type):
        """
        Sets the interposer_type of this InterposerTypeData.
        This enumeration defines the different interposer types.

        :param interposer_type: The interposer_type of this InterposerTypeData.
        :type: str
        """
        allowed_values = ["unknown", "fcToSas", "__UNDEFINED"]
        if interposer_type not in allowed_values:
            raise ValueError(
                "Invalid value for `interposer_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._interposer_type = interposer_type

    @property
    def fc_sas_interposer(self):
        """
        Gets the fc_sas_interposer of this InterposerTypeData.
        This field is available when the interfaceTypeData is equal to INTERPOSER_TYPE_FC_TO_SAS

        :return: The fc_sas_interposer of this InterposerTypeData.
        :rtype: InterposerData
        :required/optional: optional
        """
        return self._fc_sas_interposer

    @fc_sas_interposer.setter
    def fc_sas_interposer(self, fc_sas_interposer):
        """
        Sets the fc_sas_interposer of this InterposerTypeData.
        This field is available when the interfaceTypeData is equal to INTERPOSER_TYPE_FC_TO_SAS

        :param fc_sas_interposer: The fc_sas_interposer of this InterposerTypeData.
        :type: InterposerData
        """
        self._fc_sas_interposer = fc_sas_interposer

    @property
    def reserved(self):
        """
        Gets the reserved of this InterposerTypeData.
        Reserved.

        :return: The reserved of this InterposerTypeData.
        :rtype: str
        :required/optional: optional
        """
        return self._reserved

    @reserved.setter
    def reserved(self, reserved):
        """
        Sets the reserved of this InterposerTypeData.
        Reserved.

        :param reserved: The reserved of this InterposerTypeData.
        :type: str
        """
        self._reserved = reserved

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

