# coding: utf-8

"""
IpV4AddressData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IpV4AddressData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IpV4AddressData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'config_state': 'str',  # (required parameter)
            'ipv4_address': 'str',  # (required parameter)
            'ipv4_subnet_mask': 'str',  # (required parameter)
            'ipv4_gateway_address': 'str'
        }

        self.attribute_map = {
            'config_state': 'configState',  # (required parameter)
            'ipv4_address': 'ipv4Address',  # (required parameter)
            'ipv4_subnet_mask': 'ipv4SubnetMask',  # (required parameter)
            'ipv4_gateway_address': 'ipv4GatewayAddress'
        }

        self._config_state = None
        self._ipv4_address = None
        self._ipv4_subnet_mask = None
        self._ipv4_gateway_address = None

    @property
    def config_state(self):
        """
        Gets the config_state of this IpV4AddressData.
        Configuration state for the various address elements; always IP_CONFIG_STATE_CONFIGURED for iSER interfaces.

        :return: The config_state of this IpV4AddressData.
        :rtype: str
        :required/optional: required
        """
        return self._config_state

    @config_state.setter
    def config_state(self, config_state):
        """
        Sets the config_state of this IpV4AddressData.
        Configuration state for the various address elements; always IP_CONFIG_STATE_CONFIGURED for iSER interfaces.

        :param config_state: The config_state of this IpV4AddressData.
        :type: str
        """
        allowed_values = ["unconfigured", "acquiring", "configured", "invalid", "__UNDEFINED"]
        if config_state not in allowed_values:
            raise ValueError(
                "Invalid value for `config_state`, must be one of {0}"
                .format(allowed_values)
            )
        self._config_state = config_state

    @property
    def ipv4_address(self):
        """
        Gets the ipv4_address of this IpV4AddressData.
        The IPV4 address associated with the endpoint.

        :return: The ipv4_address of this IpV4AddressData.
        :rtype: str
        :required/optional: required
        """
        return self._ipv4_address

    @ipv4_address.setter
    def ipv4_address(self, ipv4_address):
        """
        Sets the ipv4_address of this IpV4AddressData.
        The IPV4 address associated with the endpoint.

        :param ipv4_address: The ipv4_address of this IpV4AddressData.
        :type: str
        """
        self._ipv4_address = ipv4_address

    @property
    def ipv4_subnet_mask(self):
        """
        Gets the ipv4_subnet_mask of this IpV4AddressData.
        IPV4 subnet mask associated w/ the endpoint; used for iSER interfaces.

        :return: The ipv4_subnet_mask of this IpV4AddressData.
        :rtype: str
        :required/optional: required
        """
        return self._ipv4_subnet_mask

    @ipv4_subnet_mask.setter
    def ipv4_subnet_mask(self, ipv4_subnet_mask):
        """
        Sets the ipv4_subnet_mask of this IpV4AddressData.
        IPV4 subnet mask associated w/ the endpoint; used for iSER interfaces.

        :param ipv4_subnet_mask: The ipv4_subnet_mask of this IpV4AddressData.
        :type: str
        """
        self._ipv4_subnet_mask = ipv4_subnet_mask

    @property
    def ipv4_gateway_address(self):
        """
        Gets the ipv4_gateway_address of this IpV4AddressData.
        IPV4 gateway address associated w/ the endpoint; used for iSER interfaces.

        :return: The ipv4_gateway_address of this IpV4AddressData.
        :rtype: str
        :required/optional: required
        """
        return self._ipv4_gateway_address

    @ipv4_gateway_address.setter
    def ipv4_gateway_address(self, ipv4_gateway_address):
        """
        Sets the ipv4_gateway_address of this IpV4AddressData.
        IPV4 gateway address associated w/ the endpoint; used for iSER interfaces.

        :param ipv4_gateway_address: The ipv4_gateway_address of this IpV4AddressData.
        :type: str
        """
        self._ipv4_gateway_address = ipv4_gateway_address

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

