# coding: utf-8

"""
IscsiCableDiagResults.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class IscsiCableDiagResults(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        IscsiCableDiagResults - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'time_stamp': 'int',  # (required parameter)
            'interface_ref': 'str',  # (required parameter)
            'completion_status': 'str',  # (required parameter)
            'channel_results': 'list[IscsiCableDiagChannelResults]'
        }

        self.attribute_map = {
            'time_stamp': 'timeStamp',  # (required parameter)
            'interface_ref': 'interfaceRef',  # (required parameter)
            'completion_status': 'completionStatus',  # (required parameter)
            'channel_results': 'channelResults'
        }

        self._time_stamp = None
        self._interface_ref = None
        self._completion_status = None
        self._channel_results = None

    @property
    def time_stamp(self):
        """
        Gets the time_stamp of this IscsiCableDiagResults.
        The time the diagnostics were performed, represented in seconds since midnight GMT on January 1, 1970.

        :return: The time_stamp of this IscsiCableDiagResults.
        :rtype: int
        :required/optional: required
        """
        return self._time_stamp

    @time_stamp.setter
    def time_stamp(self, time_stamp):
        """
        Sets the time_stamp of this IscsiCableDiagResults.
        The time the diagnostics were performed, represented in seconds since midnight GMT on January 1, 1970.

        :param time_stamp: The time_stamp of this IscsiCableDiagResults.
        :type: int
        """
        self._time_stamp = time_stamp

    @property
    def interface_ref(self):
        """
        Gets the interface_ref of this IscsiCableDiagResults.
        A reference to the interface on which the diagnostics were performed.

        :return: The interface_ref of this IscsiCableDiagResults.
        :rtype: str
        :required/optional: required
        """
        return self._interface_ref

    @interface_ref.setter
    def interface_ref(self, interface_ref):
        """
        Sets the interface_ref of this IscsiCableDiagResults.
        A reference to the interface on which the diagnostics were performed.

        :param interface_ref: The interface_ref of this IscsiCableDiagResults.
        :type: str
        """
        self._interface_ref = interface_ref

    @property
    def completion_status(self):
        """
        Gets the completion_status of this IscsiCableDiagResults.
        The completion status for the diagnostics.

        :return: The completion_status of this IscsiCableDiagResults.
        :rtype: str
        :required/optional: required
        """
        return self._completion_status

    @completion_status.setter
    def completion_status(self, completion_status):
        """
        Sets the completion_status of this IscsiCableDiagResults.
        The completion status for the diagnostics.

        :param completion_status: The completion_status of this IscsiCableDiagResults.
        :type: str
        """
        allowed_values = ["unknown", "complete", "startFailed", "unsupported", "timeout", "__UNDEFINED"]
        if completion_status not in allowed_values:
            raise ValueError(
                "Invalid value for `completion_status`, must be one of {0}"
                .format(allowed_values)
            )
        self._completion_status = completion_status

    @property
    def channel_results(self):
        """
        Gets the channel_results of this IscsiCableDiagResults.
        The diagnostic results for each channel. This array will be empty unless the diagnostics completed, i.e., completionStatus is equal to ISCSI_DIAG_STATUS_COMPLETE.

        :return: The channel_results of this IscsiCableDiagResults.
        :rtype: list[IscsiCableDiagChannelResults]
        :required/optional: required
        """
        return self._channel_results

    @channel_results.setter
    def channel_results(self, channel_results):
        """
        Sets the channel_results of this IscsiCableDiagResults.
        The diagnostic results for each channel. This array will be empty unless the diagnostics completed, i.e., completionStatus is equal to ISCSI_DIAG_STATUS_COMPLETE.

        :param channel_results: The channel_results of this IscsiCableDiagResults.
        :type: list[IscsiCableDiagChannelResults]
        """
        self._channel_results = channel_results

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

