# coding: utf-8

"""
MelExtent.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class MelExtent(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MelExtent - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'starting_seq_num': 'int',  # (required parameter)
            'ending_seq_num': 'int'
        }

        self.attribute_map = {
            'starting_seq_num': 'startingSeqNum',  # (required parameter)
            'ending_seq_num': 'endingSeqNum'
        }

        self._starting_seq_num = None
        self._ending_seq_num = None

    @property
    def starting_seq_num(self):
        """
        Gets the starting_seq_num of this MelExtent.
        This is the sequence number of the entry at the low end of the extent. So, when this value is returned in getMelExtents, it is the sequence number of the first MEL event that can be returned in getMelEntries. When specified as an input to getMelEntries, it is the sequence number of the first MEL event to be returned.

        :return: The starting_seq_num of this MelExtent.
        :rtype: int
        :required/optional: required
        """
        return self._starting_seq_num

    @starting_seq_num.setter
    def starting_seq_num(self, starting_seq_num):
        """
        Sets the starting_seq_num of this MelExtent.
        This is the sequence number of the entry at the low end of the extent. So, when this value is returned in getMelExtents, it is the sequence number of the first MEL event that can be returned in getMelEntries. When specified as an input to getMelEntries, it is the sequence number of the first MEL event to be returned.

        :param starting_seq_num: The starting_seq_num of this MelExtent.
        :type: int
        """
        self._starting_seq_num = starting_seq_num

    @property
    def ending_seq_num(self):
        """
        Gets the ending_seq_num of this MelExtent.
        When this value is returned by getMelExtents, it is the sequence number that is one beyond the entry at the high end of the extent. For example, if the ending sequence number is 3232, then MEL entries up to sequence 3231 are retrievable. When this value is input to getMelEntries, it is the sequence number of the last MEL event to be returned.

        :return: The ending_seq_num of this MelExtent.
        :rtype: int
        :required/optional: required
        """
        return self._ending_seq_num

    @ending_seq_num.setter
    def ending_seq_num(self, ending_seq_num):
        """
        Sets the ending_seq_num of this MelExtent.
        When this value is returned by getMelExtents, it is the sequence number that is one beyond the entry at the high end of the extent. For example, if the ending sequence number is 3232, then MEL entries up to sequence 3231 are retrievable. When this value is input to getMelEntries, it is the sequence number of the last MEL event to be returned.

        :param ending_seq_num: The ending_seq_num of this MelExtent.
        :type: int
        """
        self._ending_seq_num = ending_seq_num

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

