# coding: utf-8

"""
MirrorCreationDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class MirrorCreationDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MirrorCreationDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'base_volume': 'str',  # (required parameter)
            'remote_node_wwn': 'str',  # (required parameter)
            'remote_vol_wwn': 'str',  # (required parameter)
            'sync_priority': 'str',  # (required parameter)
            'remote_password': 'RemoteMirrorAuthenticator',  # (required parameter)
            'write_mode': 'str',  # (required parameter)
            'auto_resync_flag': 'bool',  # (required parameter)
            'consistency_group_ref': 'str',  # (required parameter)
            'remote_node_name': 'ScsiNodeName'
        }

        self.attribute_map = {
            'base_volume': 'baseVolume',  # (required parameter)
            'remote_node_wwn': 'remoteNodeWWN',  # (required parameter)
            'remote_vol_wwn': 'remoteVolWWN',  # (required parameter)
            'sync_priority': 'syncPriority',  # (required parameter)
            'remote_password': 'remotePassword',  # (required parameter)
            'write_mode': 'writeMode',  # (required parameter)
            'auto_resync_flag': 'autoResyncFlag',  # (required parameter)
            'consistency_group_ref': 'consistencyGroupRef',  # (required parameter)
            'remote_node_name': 'remoteNodeName'
        }

        self._base_volume = None
        self._remote_node_wwn = None
        self._remote_vol_wwn = None
        self._sync_priority = None
        self._remote_password = None
        self._write_mode = None
        self._auto_resync_flag = None
        self._consistency_group_ref = None
        self._remote_node_name = None

    @property
    def base_volume(self):
        """
        Gets the base_volume of this MirrorCreationDescriptor.
        The local base volume to mirror from.

        :return: The base_volume of this MirrorCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._base_volume

    @base_volume.setter
    def base_volume(self, base_volume):
        """
        Sets the base_volume of this MirrorCreationDescriptor.
        The local base volume to mirror from.

        :param base_volume: The base_volume of this MirrorCreationDescriptor.
        :type: str
        """
        self._base_volume = base_volume

    @property
    def remote_node_wwn(self):
        """
        Gets the remote_node_wwn of this MirrorCreationDescriptor.
        This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field.

        :return: The remote_node_wwn of this MirrorCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._remote_node_wwn

    @remote_node_wwn.setter
    def remote_node_wwn(self, remote_node_wwn):
        """
        Sets the remote_node_wwn of this MirrorCreationDescriptor.
        This field is deprecated. It will continue to be supported if remoteNodeName is NULL (IOInterfaceType == IO_IF_NOT_IMPLEMENTED). This will allow continued compatibility with clients still using this field.

        :param remote_node_wwn: The remote_node_wwn of this MirrorCreationDescriptor.
        :type: str
        """
        self._remote_node_wwn = remote_node_wwn

    @property
    def remote_vol_wwn(self):
        """
        Gets the remote_vol_wwn of this MirrorCreationDescriptor.
        Remote volume WWN.

        :return: The remote_vol_wwn of this MirrorCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._remote_vol_wwn

    @remote_vol_wwn.setter
    def remote_vol_wwn(self, remote_vol_wwn):
        """
        Sets the remote_vol_wwn of this MirrorCreationDescriptor.
        Remote volume WWN.

        :param remote_vol_wwn: The remote_vol_wwn of this MirrorCreationDescriptor.
        :type: str
        """
        self._remote_vol_wwn = remote_vol_wwn

    @property
    def sync_priority(self):
        """
        Gets the sync_priority of this MirrorCreationDescriptor.
        Synchronization priority for mirrors.

        :return: The sync_priority of this MirrorCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._sync_priority

    @sync_priority.setter
    def sync_priority(self, sync_priority):
        """
        Sets the sync_priority of this MirrorCreationDescriptor.
        Synchronization priority for mirrors.

        :param sync_priority: The sync_priority of this MirrorCreationDescriptor.
        :type: str
        """
        allowed_values = ["priority0", "priority1", "priority2", "priority3", "priority4", "unknown", "__UNDEFINED"]
        if sync_priority not in allowed_values:
            raise ValueError(
                "Invalid value for `sync_priority`, must be one of {0}"
                .format(allowed_values)
            )
        self._sync_priority = sync_priority

    @property
    def remote_password(self):
        """
        Gets the remote_password of this MirrorCreationDescriptor.
        The password of the remote array.

        :return: The remote_password of this MirrorCreationDescriptor.
        :rtype: RemoteMirrorAuthenticator
        :required/optional: required
        """
        return self._remote_password

    @remote_password.setter
    def remote_password(self, remote_password):
        """
        Sets the remote_password of this MirrorCreationDescriptor.
        The password of the remote array.

        :param remote_password: The remote_password of this MirrorCreationDescriptor.
        :type: RemoteMirrorAuthenticator
        """
        self._remote_password = remote_password

    @property
    def write_mode(self):
        """
        Gets the write_mode of this MirrorCreationDescriptor.
        Mirror write mode for the pair.

        :return: The write_mode of this MirrorCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._write_mode

    @write_mode.setter
    def write_mode(self, write_mode):
        """
        Sets the write_mode of this MirrorCreationDescriptor.
        Mirror write mode for the pair.

        :param write_mode: The write_mode of this MirrorCreationDescriptor.
        :type: str
        """
        allowed_values = ["synchronousMode", "asynchronousMode", "consistentAsyncMode", "__UNDEFINED"]
        if write_mode not in allowed_values:
            raise ValueError(
                "Invalid value for `write_mode`, must be one of {0}"
                .format(allowed_values)
            )
        self._write_mode = write_mode

    @property
    def auto_resync_flag(self):
        """
        Gets the auto_resync_flag of this MirrorCreationDescriptor.
        Indicator for whether automatic resynchronization is allowed for this mirror.

        :return: The auto_resync_flag of this MirrorCreationDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._auto_resync_flag

    @auto_resync_flag.setter
    def auto_resync_flag(self, auto_resync_flag):
        """
        Sets the auto_resync_flag of this MirrorCreationDescriptor.
        Indicator for whether automatic resynchronization is allowed for this mirror.

        :param auto_resync_flag: The auto_resync_flag of this MirrorCreationDescriptor.
        :type: bool
        """
        self._auto_resync_flag = auto_resync_flag

    @property
    def consistency_group_ref(self):
        """
        Gets the consistency_group_ref of this MirrorCreationDescriptor.
        Write consistency group reference. NULL = not in group.

        :return: The consistency_group_ref of this MirrorCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._consistency_group_ref

    @consistency_group_ref.setter
    def consistency_group_ref(self, consistency_group_ref):
        """
        Sets the consistency_group_ref of this MirrorCreationDescriptor.
        Write consistency group reference. NULL = not in group.

        :param consistency_group_ref: The consistency_group_ref of this MirrorCreationDescriptor.
        :type: str
        """
        self._consistency_group_ref = consistency_group_ref

    @property
    def remote_node_name(self):
        """
        Gets the remote_node_name of this MirrorCreationDescriptor.
        The name of the RemoteVolume.

        :return: The remote_node_name of this MirrorCreationDescriptor.
        :rtype: ScsiNodeName
        :required/optional: required
        """
        return self._remote_node_name

    @remote_node_name.setter
    def remote_node_name(self, remote_node_name):
        """
        Sets the remote_node_name of this MirrorCreationDescriptor.
        The name of the RemoteVolume.

        :param remote_node_name: The remote_node_name of this MirrorCreationDescriptor.
        :type: ScsiNodeName
        """
        self._remote_node_name = remote_node_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

