# coding: utf-8

"""
MirrorVolumeCandidate.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class MirrorVolumeCandidate(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MirrorVolumeCandidate - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'remote_vol_wwn': 'str',  # (required parameter)
            'remote_vol_label': 'str',  # (required parameter)
            'capacity': 'int',  # (required parameter)
            'raid_level': 'str',  # (required parameter)
            'protection_type': 'str'
        }

        self.attribute_map = {
            'remote_vol_wwn': 'remoteVolWWN',  # (required parameter)
            'remote_vol_label': 'remoteVolLabel',  # (required parameter)
            'capacity': 'capacity',  # (required parameter)
            'raid_level': 'raidLevel',  # (required parameter)
            'protection_type': 'protectionType'
        }

        self._remote_vol_wwn = None
        self._remote_vol_label = None
        self._capacity = None
        self._raid_level = None
        self._protection_type = None

    @property
    def remote_vol_wwn(self):
        """
        Gets the remote_vol_wwn of this MirrorVolumeCandidate.
        The WWN of the remote volume.

        :return: The remote_vol_wwn of this MirrorVolumeCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._remote_vol_wwn

    @remote_vol_wwn.setter
    def remote_vol_wwn(self, remote_vol_wwn):
        """
        Sets the remote_vol_wwn of this MirrorVolumeCandidate.
        The WWN of the remote volume.

        :param remote_vol_wwn: The remote_vol_wwn of this MirrorVolumeCandidate.
        :type: str
        """
        self._remote_vol_wwn = remote_vol_wwn

    @property
    def remote_vol_label(self):
        """
        Gets the remote_vol_label of this MirrorVolumeCandidate.
        The user assigned label of the remote volume.

        :return: The remote_vol_label of this MirrorVolumeCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._remote_vol_label

    @remote_vol_label.setter
    def remote_vol_label(self, remote_vol_label):
        """
        Sets the remote_vol_label of this MirrorVolumeCandidate.
        The user assigned label of the remote volume.

        :param remote_vol_label: The remote_vol_label of this MirrorVolumeCandidate.
        :type: str
        """
        self._remote_vol_label = remote_vol_label

    @property
    def capacity(self):
        """
        Gets the capacity of this MirrorVolumeCandidate.
        The capacity of the remote volume.

        :return: The capacity of this MirrorVolumeCandidate.
        :rtype: int
        :required/optional: required
        """
        return self._capacity

    @capacity.setter
    def capacity(self, capacity):
        """
        Sets the capacity of this MirrorVolumeCandidate.
        The capacity of the remote volume.

        :param capacity: The capacity of this MirrorVolumeCandidate.
        :type: int
        """
        self._capacity = capacity

    @property
    def raid_level(self):
        """
        Gets the raid_level of this MirrorVolumeCandidate.
        The RAID level of the remote volume.

        :return: The raid_level of this MirrorVolumeCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._raid_level

    @raid_level.setter
    def raid_level(self, raid_level):
        """
        Sets the raid_level of this MirrorVolumeCandidate.
        The RAID level of the remote volume.

        :param raid_level: The raid_level of this MirrorVolumeCandidate.
        :type: str
        """
        allowed_values = ["raidUnsupported", "raidAll", "raid0", "raid1", "raid3", "raid5", "raid6", "raidDiskPool", "__UNDEFINED"]
        if raid_level not in allowed_values:
            raise ValueError(
                "Invalid value for `raid_level`, must be one of {0}"
                .format(allowed_values)
            )
        self._raid_level = raid_level

    @property
    def protection_type(self):
        """
        Gets the protection_type of this MirrorVolumeCandidate.
        The protection type of the mirror volume candidate.

        :return: The protection_type of this MirrorVolumeCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._protection_type

    @protection_type.setter
    def protection_type(self, protection_type):
        """
        Sets the protection_type of this MirrorVolumeCandidate.
        The protection type of the mirror volume candidate.

        :param protection_type: The protection_type of this MirrorVolumeCandidate.
        :type: str
        """
        allowed_values = ["type0Protection", "type1Protection", "type2Protection", "type3Protection", "__UNDEFINED"]
        if protection_type not in allowed_values:
            raise ValueError(
                "Invalid value for `protection_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._protection_type = protection_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

