# coding: utf-8

"""
MirrorWriteModeDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class MirrorWriteModeDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        MirrorWriteModeDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'mirror_proxy': 'str',  # (required parameter)
            'write_mode': 'str',  # (required parameter)
            'consistency_group_ref': 'str'
        }

        self.attribute_map = {
            'mirror_proxy': 'mirrorProxy',  # (required parameter)
            'write_mode': 'writeMode',  # (required parameter)
            'consistency_group_ref': 'consistencyGroupRef'
        }

        self._mirror_proxy = None
        self._write_mode = None
        self._consistency_group_ref = None

    @property
    def mirror_proxy(self):
        """
        Gets the mirror_proxy of this MirrorWriteModeDescriptor.
        The mirror proxy.

        :return: The mirror_proxy of this MirrorWriteModeDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._mirror_proxy

    @mirror_proxy.setter
    def mirror_proxy(self, mirror_proxy):
        """
        Sets the mirror_proxy of this MirrorWriteModeDescriptor.
        The mirror proxy.

        :param mirror_proxy: The mirror_proxy of this MirrorWriteModeDescriptor.
        :type: str
        """
        self._mirror_proxy = mirror_proxy

    @property
    def write_mode(self):
        """
        Gets the write_mode of this MirrorWriteModeDescriptor.
        The write mode.

        :return: The write_mode of this MirrorWriteModeDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._write_mode

    @write_mode.setter
    def write_mode(self, write_mode):
        """
        Sets the write_mode of this MirrorWriteModeDescriptor.
        The write mode.

        :param write_mode: The write_mode of this MirrorWriteModeDescriptor.
        :type: str
        """
        allowed_values = ["synchronousMode", "asynchronousMode", "consistentAsyncMode", "__UNDEFINED"]
        if write_mode not in allowed_values:
            raise ValueError(
                "Invalid value for `write_mode`, must be one of {0}"
                .format(allowed_values)
            )
        self._write_mode = write_mode

    @property
    def consistency_group_ref(self):
        """
        Gets the consistency_group_ref of this MirrorWriteModeDescriptor.
        The reference for the consistency group.

        :return: The consistency_group_ref of this MirrorWriteModeDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._consistency_group_ref

    @consistency_group_ref.setter
    def consistency_group_ref(self, consistency_group_ref):
        """
        Sets the consistency_group_ref of this MirrorWriteModeDescriptor.
        The reference for the consistency group.

        :param consistency_group_ref: The consistency_group_ref of this MirrorWriteModeDescriptor.
        :type: str
        """
        self._consistency_group_ref = consistency_group_ref

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

