# coding: utf-8

"""
NetworkAddress.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class NetworkAddress(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        NetworkAddress - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'addr_type': 'str',  # (required parameter)
            'domain_name': 'str',  
            'ipvx_address': 'IpVxAddress'
        }

        self.attribute_map = {
            'addr_type': 'addrType',  # (required parameter)
            'domain_name': 'domainName',  
            'ipvx_address': 'ipvxAddress'
        }

        self._addr_type = None
        self._domain_name = None
        self._ipvx_address = None

    @property
    def addr_type(self):
        """
        Gets the addr_type of this NetworkAddress.
        This enum defines the possible network address types.

        :return: The addr_type of this NetworkAddress.
        :rtype: str
        :required/optional: required
        """
        return self._addr_type

    @addr_type.setter
    def addr_type(self, addr_type):
        """
        Sets the addr_type of this NetworkAddress.
        This enum defines the possible network address types.

        :param addr_type: The addr_type of this NetworkAddress.
        :type: str
        """
        allowed_values = ["none", "domainName", "ipvx", "__UNDEFINED"]
        if addr_type not in allowed_values:
            raise ValueError(
                "Invalid value for `addr_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._addr_type = addr_type

    @property
    def domain_name(self):
        """
        Gets the domain_name of this NetworkAddress.
        Fully qualified domain name. This should be considered an IDN-unaware domain name slot as per RFC3490.

        :return: The domain_name of this NetworkAddress.
        :rtype: str
        :required/optional: optional
        """
        return self._domain_name

    @domain_name.setter
    def domain_name(self, domain_name):
        """
        Sets the domain_name of this NetworkAddress.
        Fully qualified domain name. This should be considered an IDN-unaware domain name slot as per RFC3490.

        :param domain_name: The domain_name of this NetworkAddress.
        :type: str
        """
        self._domain_name = domain_name

    @property
    def ipvx_address(self):
        """
        Gets the ipvx_address of this NetworkAddress.
        IPv4 or IPv6 address

        :return: The ipvx_address of this NetworkAddress.
        :rtype: IpVxAddress
        :required/optional: optional
        """
        return self._ipvx_address

    @ipvx_address.setter
    def ipvx_address(self, ipvx_address):
        """
        Sets the ipvx_address of this NetworkAddress.
        IPv4 or IPv6 address

        :param ipvx_address: The ipvx_address of this NetworkAddress.
        :type: IpVxAddress
        """
        self._ipvx_address = ipvx_address

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

