# coding: utf-8

"""
PITConsistencyGroupViewCreationDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class PITConsistencyGroupViewCreationDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PITConsistencyGroupViewCreationDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'cg_ref': 'str',  # (required parameter)
            'pit_sequence_number': 'int',  # (required parameter)
            'view_creation_descriptor': 'list[PITViewCreationDescriptor]',  # (required parameter)
            'label': 'str'
        }

        self.attribute_map = {
            'cg_ref': 'cgRef',  # (required parameter)
            'pit_sequence_number': 'pitSequenceNumber',  # (required parameter)
            'view_creation_descriptor': 'viewCreationDescriptor',  # (required parameter)
            'label': 'label'
        }

        self._cg_ref = None
        self._pit_sequence_number = None
        self._view_creation_descriptor = None
        self._label = None

    @property
    def cg_ref(self):
        """
        Gets the cg_ref of this PITConsistencyGroupViewCreationDescriptor.
        The Consistency Group on which views are to be created. All PiTs referenced in the view creation descriptors must be part of this consistency group.

        :return: The cg_ref of this PITConsistencyGroupViewCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._cg_ref

    @cg_ref.setter
    def cg_ref(self, cg_ref):
        """
        Sets the cg_ref of this PITConsistencyGroupViewCreationDescriptor.
        The Consistency Group on which views are to be created. All PiTs referenced in the view creation descriptors must be part of this consistency group.

        :param cg_ref: The cg_ref of this PITConsistencyGroupViewCreationDescriptor.
        :type: str
        """
        self._cg_ref = cg_ref

    @property
    def pit_sequence_number(self):
        """
        Gets the pit_sequence_number of this PITConsistencyGroupViewCreationDescriptor.
        The sequence number of PiTs for which views are to be created. PITRefs in the view creation descriptors provided must have this sequence number (this is just for cross-checking the list of PiTs).

        :return: The pit_sequence_number of this PITConsistencyGroupViewCreationDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._pit_sequence_number

    @pit_sequence_number.setter
    def pit_sequence_number(self, pit_sequence_number):
        """
        Sets the pit_sequence_number of this PITConsistencyGroupViewCreationDescriptor.
        The sequence number of PiTs for which views are to be created. PITRefs in the view creation descriptors provided must have this sequence number (this is just for cross-checking the list of PiTs).

        :param pit_sequence_number: The pit_sequence_number of this PITConsistencyGroupViewCreationDescriptor.
        :type: int
        """
        self._pit_sequence_number = pit_sequence_number

    @property
    def view_creation_descriptor(self):
        """
        Gets the view_creation_descriptor of this PITConsistencyGroupViewCreationDescriptor.
        A list of creation descriptors for the views to be created.

        :return: The view_creation_descriptor of this PITConsistencyGroupViewCreationDescriptor.
        :rtype: list[PITViewCreationDescriptor]
        :required/optional: required
        """
        return self._view_creation_descriptor

    @view_creation_descriptor.setter
    def view_creation_descriptor(self, view_creation_descriptor):
        """
        Sets the view_creation_descriptor of this PITConsistencyGroupViewCreationDescriptor.
        A list of creation descriptors for the views to be created.

        :param view_creation_descriptor: The view_creation_descriptor of this PITConsistencyGroupViewCreationDescriptor.
        :type: list[PITViewCreationDescriptor]
        """
        self._view_creation_descriptor = view_creation_descriptor

    @property
    def label(self):
        """
        Gets the label of this PITConsistencyGroupViewCreationDescriptor.
        The name of the new Consistency Group View.

        :return: The label of this PITConsistencyGroupViewCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._label

    @label.setter
    def label(self, label):
        """
        Sets the label of this PITConsistencyGroupViewCreationDescriptor.
        The name of the new Consistency Group View.

        :param label: The label of this PITConsistencyGroupViewCreationDescriptor.
        :type: str
        """
        self._label = label

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

