# coding: utf-8

"""
PKCS5EncryptionData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class PKCS5EncryptionData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PKCS5EncryptionData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'iterations': 'int',  # (required parameter)
            'salt': 'str',  # (required parameter)
            'cipher_text': 'str'
        }

        self.attribute_map = {
            'iterations': 'iterations',  # (required parameter)
            'salt': 'salt',  # (required parameter)
            'cipher_text': 'cipherText'
        }

        self._iterations = None
        self._salt = None
        self._cipher_text = None

    @property
    def iterations(self):
        """
        Gets the iterations of this PKCS5EncryptionData.
        The number of message digest iterations to be performed when generating the encryption key and initialization vector from the passphrase and salt values.

        :return: The iterations of this PKCS5EncryptionData.
        :rtype: int
        :required/optional: required
        """
        return self._iterations

    @iterations.setter
    def iterations(self, iterations):
        """
        Sets the iterations of this PKCS5EncryptionData.
        The number of message digest iterations to be performed when generating the encryption key and initialization vector from the passphrase and salt values.

        :param iterations: The iterations of this PKCS5EncryptionData.
        :type: int
        """
        self._iterations = iterations

    @property
    def salt(self):
        """
        Gets the salt of this PKCS5EncryptionData.
        A byte array containing the salt, or random data, selected by the encryption code for this particular encryption operation.

        :return: The salt of this PKCS5EncryptionData.
        :rtype: str
        :required/optional: required
        """
        return self._salt

    @salt.setter
    def salt(self, salt):
        """
        Sets the salt of this PKCS5EncryptionData.
        A byte array containing the salt, or random data, selected by the encryption code for this particular encryption operation.

        :param salt: The salt of this PKCS5EncryptionData.
        :type: str
        """
        self._salt = salt

    @property
    def cipher_text(self):
        """
        Gets the cipher_text of this PKCS5EncryptionData.
        A variable-length array containing the encrypted data, or cipher text. The length of this array must be a multiple of 8 in order to conform to the PKCS #5 standard. The standard specifies the appropriate technique for adding pad bytes to ensure that this constraint is met.

        :return: The cipher_text of this PKCS5EncryptionData.
        :rtype: str
        :required/optional: required
        """
        return self._cipher_text

    @cipher_text.setter
    def cipher_text(self, cipher_text):
        """
        Sets the cipher_text of this PKCS5EncryptionData.
        A variable-length array containing the encrypted data, or cipher text. The length of this array must be a multiple of 8 in order to conform to the PKCS #5 standard. The standard specifies the appropriate technique for adding pad bytes to ensure that this constraint is met.

        :param cipher_text: The cipher_text of this PKCS5EncryptionData.
        :type: str
        """
        self._cipher_text = cipher_text

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

