# coding: utf-8

"""
RawDataRestoreStartDetails.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RawDataRestoreStartDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RawDataRestoreStartDetails - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'raw_data_transfer_type': 'str',  # (required parameter)
            'dbm_blk': 'DbmBlkRestoreStartDetails',  
            'dbm_rec': 'DbmRecRestoreStartDetails'
        }

        self.attribute_map = {
            'raw_data_transfer_type': 'rawDataTransferType',  # (required parameter)
            'dbm_blk': 'dbmBlk',  
            'dbm_rec': 'dbmRec'
        }

        self._raw_data_transfer_type = None
        self._dbm_blk = None
        self._dbm_rec = None

    @property
    def raw_data_transfer_type(self):
        """
        Gets the raw_data_transfer_type of this RawDataRestoreStartDetails.
        This enumeration lists the raw data transfer types.

        :return: The raw_data_transfer_type of this RawDataRestoreStartDetails.
        :rtype: str
        :required/optional: required
        """
        return self._raw_data_transfer_type

    @raw_data_transfer_type.setter
    def raw_data_transfer_type(self, raw_data_transfer_type):
        """
        Sets the raw_data_transfer_type of this RawDataRestoreStartDetails.
        This enumeration lists the raw data transfer types.

        :param raw_data_transfer_type: The raw_data_transfer_type of this RawDataRestoreStartDetails.
        :type: str
        """
        allowed_values = ["unknown", "dq", "dbmblk", "dbmrec", "dbmCheck", "enclosureStateCapture", "dplCoreDumpBundle", "ioStatistics", "fdiDemsLogs", "drivePerformanceHistory", "iocDump", "driveHealthLogs", "ctrlPerfLogs", "dom0SupportData", "retrieveWlcAnalytics", "autoLoadBalanceStatisticsLog", "__UNDEFINED"]
        if raw_data_transfer_type not in allowed_values:
            raise ValueError(
                "Invalid value for `raw_data_transfer_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._raw_data_transfer_type = raw_data_transfer_type

    @property
    def dbm_blk(self):
        """
        Gets the dbm_blk of this RawDataRestoreStartDetails.
        This field is present only if the type value is equal to RAWDATA_DBMBLK.

        :return: The dbm_blk of this RawDataRestoreStartDetails.
        :rtype: DbmBlkRestoreStartDetails
        :required/optional: optional
        """
        return self._dbm_blk

    @dbm_blk.setter
    def dbm_blk(self, dbm_blk):
        """
        Sets the dbm_blk of this RawDataRestoreStartDetails.
        This field is present only if the type value is equal to RAWDATA_DBMBLK.

        :param dbm_blk: The dbm_blk of this RawDataRestoreStartDetails.
        :type: DbmBlkRestoreStartDetails
        """
        self._dbm_blk = dbm_blk

    @property
    def dbm_rec(self):
        """
        Gets the dbm_rec of this RawDataRestoreStartDetails.
        This field is present only if the type value is equal to RAWDATA_DBMREC.

        :return: The dbm_rec of this RawDataRestoreStartDetails.
        :rtype: DbmRecRestoreStartDetails
        :required/optional: optional
        """
        return self._dbm_rec

    @dbm_rec.setter
    def dbm_rec(self, dbm_rec):
        """
        Sets the dbm_rec of this RawDataRestoreStartDetails.
        This field is present only if the type value is equal to RAWDATA_DBMREC.

        :param dbm_rec: The dbm_rec of this RawDataRestoreStartDetails.
        :type: DbmRecRestoreStartDetails
        """
        self._dbm_rec = dbm_rec

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

