# coding: utf-8

"""
Registrant.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Registrant(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Registrant - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'host_port_ref': 'str',  # (required parameter)
            'host_port_name': 'str',  # (required parameter)
            'reserved_port': 'str',  # (required parameter)
            'registered_ports': 'RegisteredPorts'
        }

        self.attribute_map = {
            'host_port_ref': 'hostPortRef',  # (required parameter)
            'host_port_name': 'hostPortName',  # (required parameter)
            'reserved_port': 'reservedPort',  # (required parameter)
            'registered_ports': 'registeredPorts'
        }

        self._host_port_ref = None
        self._host_port_name = None
        self._reserved_port = None
        self._registered_ports = None

    @property
    def host_port_ref(self):
        """
        Gets the host_port_ref of this Registrant.
        The associated host port if mapped.

        :return: The host_port_ref of this Registrant.
        :rtype: str
        :required/optional: required
        """
        return self._host_port_ref

    @host_port_ref.setter
    def host_port_ref(self, host_port_ref):
        """
        Sets the host_port_ref of this Registrant.
        The associated host port if mapped.

        :param host_port_ref: The host_port_ref of this Registrant.
        :type: str
        """
        self._host_port_ref = host_port_ref

    @property
    def host_port_name(self):
        """
        Gets the host_port_name of this Registrant.
        The host port name if not mapped.

        :return: The host_port_name of this Registrant.
        :rtype: str
        :required/optional: required
        """
        return self._host_port_name

    @host_port_name.setter
    def host_port_name(self, host_port_name):
        """
        Sets the host_port_name of this Registrant.
        The host port name if not mapped.

        :param host_port_name: The host_port_name of this Registrant.
        :type: str
        """
        self._host_port_name = host_port_name

    @property
    def reserved_port(self):
        """
        Gets the reserved_port of this Registrant.
        Host port reserved for this target.

        :return: The reserved_port of this Registrant.
        :rtype: str
        :required/optional: required
        """
        return self._reserved_port

    @reserved_port.setter
    def reserved_port(self, reserved_port):
        """
        Sets the reserved_port of this Registrant.
        Host port reserved for this target.

        :param reserved_port: The reserved_port of this Registrant.
        :type: str
        """
        allowed_values = ["none", "all", "a0", "a1", "b0", "b1", "__UNDEFINED"]
        if reserved_port not in allowed_values:
            raise ValueError(
                "Invalid value for `reserved_port`, must be one of {0}"
                .format(allowed_values)
            )
        self._reserved_port = reserved_port

    @property
    def registered_ports(self):
        """
        Gets the registered_ports of this Registrant.
        Host port registered with these targets.

        :return: The registered_ports of this Registrant.
        :rtype: RegisteredPorts
        :required/optional: required
        """
        return self._registered_ports

    @registered_ports.setter
    def registered_ports(self, registered_ports):
        """
        Sets the registered_ports of this Registrant.
        Host port registered with these targets.

        :param registered_ports: The registered_ports of this Registrant.
        :type: RegisteredPorts
        """
        self._registered_ports = registered_ports

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

