# coding: utf-8

"""
RemoteArray.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RemoteArray(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RemoteArray - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'remote_array_ref': 'str',  # (required parameter)
            'sa_id': 'SAIdentifier',  # (required parameter)
            'remote_targets': 'list[str]'
        }

        self.attribute_map = {
            'remote_array_ref': 'remoteArrayRef',  # (required parameter)
            'sa_id': 'saId',  # (required parameter)
            'remote_targets': 'remoteTargets'
        }

        self._remote_array_ref = None
        self._sa_id = None
        self._remote_targets = None

    @property
    def remote_array_ref(self):
        """
        Gets the remote_array_ref of this RemoteArray.
        A unique identifier for this RemoteArray object.

        :return: The remote_array_ref of this RemoteArray.
        :rtype: str
        :required/optional: required
        """
        return self._remote_array_ref

    @remote_array_ref.setter
    def remote_array_ref(self, remote_array_ref):
        """
        Sets the remote_array_ref of this RemoteArray.
        A unique identifier for this RemoteArray object.

        :param remote_array_ref: The remote_array_ref of this RemoteArray.
        :type: str
        """
        self._remote_array_ref = remote_array_ref

    @property
    def sa_id(self):
        """
        Gets the sa_id of this RemoteArray.
        The storage array ID of the remote array.

        :return: The sa_id of this RemoteArray.
        :rtype: SAIdentifier
        :required/optional: required
        """
        return self._sa_id

    @sa_id.setter
    def sa_id(self, sa_id):
        """
        Sets the sa_id of this RemoteArray.
        The storage array ID of the remote array.

        :param sa_id: The sa_id of this RemoteArray.
        :type: SAIdentifier
        """
        self._sa_id = sa_id

    @property
    def remote_targets(self):
        """
        Gets the remote_targets of this RemoteArray.
        One or more paths to the remote array. Note these could be differing protocols.

        :return: The remote_targets of this RemoteArray.
        :rtype: list[str]
        :required/optional: required
        """
        return self._remote_targets

    @remote_targets.setter
    def remote_targets(self, remote_targets):
        """
        Sets the remote_targets of this RemoteArray.
        One or more paths to the remote array. Note these could be differing protocols.

        :param remote_targets: The remote_targets of this RemoteArray.
        :type: list[str]
        """
        self._remote_targets = remote_targets

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

