# coding: utf-8

"""
RLSCount.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RLSCount(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RLSCount - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'link_failure_count': 'int',  # (required parameter)
            'loss_of_sync_count': 'int',  # (required parameter)
            'loss_of_signal_count': 'int',  # (required parameter)
            'prim_seq_protocol_err': 'int',  # (required parameter)
            'invalid_xmit_word': 'int',  # (required parameter)
            'invalid_crc_count': 'int'
        }

        self.attribute_map = {
            'link_failure_count': 'linkFailureCount',  # (required parameter)
            'loss_of_sync_count': 'lossOfSyncCount',  # (required parameter)
            'loss_of_signal_count': 'lossOfSignalCount',  # (required parameter)
            'prim_seq_protocol_err': 'primSeqProtocolErr',  # (required parameter)
            'invalid_xmit_word': 'invalidXmitWord',  # (required parameter)
            'invalid_crc_count': 'invalidCRCCount'
        }

        self._link_failure_count = None
        self._loss_of_sync_count = None
        self._loss_of_signal_count = None
        self._prim_seq_protocol_err = None
        self._invalid_xmit_word = None
        self._invalid_crc_count = None

    @property
    def link_failure_count(self):
        """
        Gets the link_failure_count of this RLSCount.
        The number of link failures.

        :return: The link_failure_count of this RLSCount.
        :rtype: int
        :required/optional: required
        """
        return self._link_failure_count

    @link_failure_count.setter
    def link_failure_count(self, link_failure_count):
        """
        Sets the link_failure_count of this RLSCount.
        The number of link failures.

        :param link_failure_count: The link_failure_count of this RLSCount.
        :type: int
        """
        self._link_failure_count = link_failure_count

    @property
    def loss_of_sync_count(self):
        """
        Gets the loss_of_sync_count of this RLSCount.
        The number of synchronization losses.

        :return: The loss_of_sync_count of this RLSCount.
        :rtype: int
        :required/optional: required
        """
        return self._loss_of_sync_count

    @loss_of_sync_count.setter
    def loss_of_sync_count(self, loss_of_sync_count):
        """
        Sets the loss_of_sync_count of this RLSCount.
        The number of synchronization losses.

        :param loss_of_sync_count: The loss_of_sync_count of this RLSCount.
        :type: int
        """
        self._loss_of_sync_count = loss_of_sync_count

    @property
    def loss_of_signal_count(self):
        """
        Gets the loss_of_signal_count of this RLSCount.
        The number of signal losses.

        :return: The loss_of_signal_count of this RLSCount.
        :rtype: int
        :required/optional: required
        """
        return self._loss_of_signal_count

    @loss_of_signal_count.setter
    def loss_of_signal_count(self, loss_of_signal_count):
        """
        Sets the loss_of_signal_count of this RLSCount.
        The number of signal losses.

        :param loss_of_signal_count: The loss_of_signal_count of this RLSCount.
        :type: int
        """
        self._loss_of_signal_count = loss_of_signal_count

    @property
    def prim_seq_protocol_err(self):
        """
        Gets the prim_seq_protocol_err of this RLSCount.
        The number of primary sequence protocol failures.

        :return: The prim_seq_protocol_err of this RLSCount.
        :rtype: int
        :required/optional: required
        """
        return self._prim_seq_protocol_err

    @prim_seq_protocol_err.setter
    def prim_seq_protocol_err(self, prim_seq_protocol_err):
        """
        Sets the prim_seq_protocol_err of this RLSCount.
        The number of primary sequence protocol failures.

        :param prim_seq_protocol_err: The prim_seq_protocol_err of this RLSCount.
        :type: int
        """
        self._prim_seq_protocol_err = prim_seq_protocol_err

    @property
    def invalid_xmit_word(self):
        """
        Gets the invalid_xmit_word of this RLSCount.
        The number of invalid transmit word failures.

        :return: The invalid_xmit_word of this RLSCount.
        :rtype: int
        :required/optional: required
        """
        return self._invalid_xmit_word

    @invalid_xmit_word.setter
    def invalid_xmit_word(self, invalid_xmit_word):
        """
        Sets the invalid_xmit_word of this RLSCount.
        The number of invalid transmit word failures.

        :param invalid_xmit_word: The invalid_xmit_word of this RLSCount.
        :type: int
        """
        self._invalid_xmit_word = invalid_xmit_word

    @property
    def invalid_crc_count(self):
        """
        Gets the invalid_crc_count of this RLSCount.
        The number of invalid CRC failures.

        :return: The invalid_crc_count of this RLSCount.
        :rtype: int
        :required/optional: required
        """
        return self._invalid_crc_count

    @invalid_crc_count.setter
    def invalid_crc_count(self, invalid_crc_count):
        """
        Sets the invalid_crc_count of this RLSCount.
        The number of invalid CRC failures.

        :param invalid_crc_count: The invalid_crc_count of this RLSCount.
        :type: int
        """
        self._invalid_crc_count = invalid_crc_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

