# coding: utf-8

"""
RLSData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RLSData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RLSData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'device': 'RLSDevice',  # (required parameter)
            'channel': 'int',  # (required parameter)
            'loop_map_index': 'int',  # (required parameter)
            'rls_count': 'RLSCount',  # (required parameter)
            'baseline_time': 'int',  # (required parameter)
            'valid': 'bool'
        }

        self.attribute_map = {
            'device': 'device',  # (required parameter)
            'channel': 'channel',  # (required parameter)
            'loop_map_index': 'loopMapIndex',  # (required parameter)
            'rls_count': 'rlsCount',  # (required parameter)
            'baseline_time': 'baselineTime',  # (required parameter)
            'valid': 'valid'
        }

        self._device = None
        self._channel = None
        self._loop_map_index = None
        self._rls_count = None
        self._baseline_time = None
        self._valid = None

    @property
    def device(self):
        """
        Gets the device of this RLSData.
        The SYMbol reference value that uniquely identifies this device.

        :return: The device of this RLSData.
        :rtype: RLSDevice
        :required/optional: required
        """
        return self._device

    @device.setter
    def device(self, device):
        """
        Sets the device of this RLSData.
        The SYMbol reference value that uniquely identifies this device.

        :param device: The device of this RLSData.
        :type: RLSDevice
        """
        self._device = device

    @property
    def channel(self):
        """
        Gets the channel of this RLSData.
        The channel the device is on.

        :return: The channel of this RLSData.
        :rtype: int
        :required/optional: required
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """
        Sets the channel of this RLSData.
        The channel the device is on.

        :param channel: The channel of this RLSData.
        :type: int
        """
        self._channel = channel

    @property
    def loop_map_index(self):
        """
        Gets the loop_map_index of this RLSData.
        The position in the fibre loop map the device is located at.

        :return: The loop_map_index of this RLSData.
        :rtype: int
        :required/optional: required
        """
        return self._loop_map_index

    @loop_map_index.setter
    def loop_map_index(self, loop_map_index):
        """
        Sets the loop_map_index of this RLSData.
        The position in the fibre loop map the device is located at.

        :param loop_map_index: The loop_map_index of this RLSData.
        :type: int
        """
        self._loop_map_index = loop_map_index

    @property
    def rls_count(self):
        """
        Gets the rls_count of this RLSData.
        The RLS count for this device.

        :return: The rls_count of this RLSData.
        :rtype: RLSCount
        :required/optional: required
        """
        return self._rls_count

    @rls_count.setter
    def rls_count(self, rls_count):
        """
        Sets the rls_count of this RLSData.
        The RLS count for this device.

        :param rls_count: The rls_count of this RLSData.
        :type: RLSCount
        """
        self._rls_count = rls_count

    @property
    def baseline_time(self):
        """
        Gets the baseline_time of this RLSData.
        The baseline time for this device, expressed as seconds since midnight GMT on January 1, 1970.

        :return: The baseline_time of this RLSData.
        :rtype: int
        :required/optional: required
        """
        return self._baseline_time

    @baseline_time.setter
    def baseline_time(self, baseline_time):
        """
        Sets the baseline_time of this RLSData.
        The baseline time for this device, expressed as seconds since midnight GMT on January 1, 1970.

        :param baseline_time: The baseline_time of this RLSData.
        :type: int
        """
        self._baseline_time = baseline_time

    @property
    def valid(self):
        """
        Gets the valid of this RLSData.
        Set to true if the RSL Data is valid for the device.

        :return: The valid of this RLSData.
        :rtype: bool
        :required/optional: required
        """
        return self._valid

    @valid.setter
    def valid(self, valid):
        """
        Sets the valid of this RLSData.
        Set to true if the RSL Data is valid for the device.

        :param valid: The valid of this RLSData.
        :type: bool
        """
        self._valid = valid

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

