# coding: utf-8

"""
RTRAttributes.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RTRAttributes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RTRAttributes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'cru_type': 'str',  # (required parameter)
            'parent_cru': 'ParentCru',  
            'rtr_attribute_data': 'RTRAttributeData'
        }

        self.attribute_map = {
            'cru_type': 'cruType',  # (required parameter)
            'parent_cru': 'parentCru',  
            'rtr_attribute_data': 'rtrAttributeData'
        }

        self._cru_type = None
        self._parent_cru = None
        self._rtr_attribute_data = None

    @property
    def cru_type(self):
        """
        Gets the cru_type of this RTRAttributes.
        This enumeration identifies the type of CRU a component has.

        :return: The cru_type of this RTRAttributes.
        :rtype: str
        :required/optional: required
        """
        return self._cru_type

    @cru_type.setter
    def cru_type(self, cru_type):
        """
        Sets the cru_type of this RTRAttributes.
        This enumeration identifies the type of CRU a component has.

        :param cru_type: The cru_type of this RTRAttributes.
        :type: str
        """
        allowed_values = ["unknown", "dedicated", "shared", "aggregate", "__UNDEFINED"]
        if cru_type not in allowed_values:
            raise ValueError(
                "Invalid value for `cru_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._cru_type = cru_type

    @property
    def parent_cru(self):
        """
        Gets the parent_cru of this RTRAttributes.
        This field identifies the CRU that is the parent of this component, i.e., the CRU that it is sharing with other components. It is only present when the cruType field is set to CRU_TYPE_AGGREGATE.

        :return: The parent_cru of this RTRAttributes.
        :rtype: ParentCru
        :required/optional: optional
        """
        return self._parent_cru

    @parent_cru.setter
    def parent_cru(self, parent_cru):
        """
        Sets the parent_cru of this RTRAttributes.
        This field identifies the CRU that is the parent of this component, i.e., the CRU that it is sharing with other components. It is only present when the cruType field is set to CRU_TYPE_AGGREGATE.

        :param parent_cru: The parent_cru of this RTRAttributes.
        :type: ParentCru
        """
        self._parent_cru = parent_cru

    @property
    def rtr_attribute_data(self):
        """
        Gets the rtr_attribute_data of this RTRAttributes.
        This field contains the actual settings for the ready-to-remove data. It is only present when the cruType field is set to CRU_TYPE_DEDICATED.

        :return: The rtr_attribute_data of this RTRAttributes.
        :rtype: RTRAttributeData
        :required/optional: optional
        """
        return self._rtr_attribute_data

    @rtr_attribute_data.setter
    def rtr_attribute_data(self, rtr_attribute_data):
        """
        Sets the rtr_attribute_data of this RTRAttributes.
        This field contains the actual settings for the ready-to-remove data. It is only present when the cruType field is set to CRU_TYPE_DEDICATED.

        :param rtr_attribute_data: The rtr_attribute_data of this RTRAttributes.
        :type: RTRAttributeData
        """
        self._rtr_attribute_data = rtr_attribute_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

