# coding: utf-8

"""
RuntimeDiagDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RuntimeDiagDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RuntimeDiagDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'controller_ref': 'str',  # (required parameter)
            'runtime_diag_test_id': 'str',  # (required parameter)
            'channel': 'int',  # (required parameter)
            'use_pattern': 'bool',  # (required parameter)
            'pattern': 'str'
        }

        self.attribute_map = {
            'controller_ref': 'controllerRef',  # (required parameter)
            'runtime_diag_test_id': 'runtimeDiagTestID',  # (required parameter)
            'channel': 'channel',  # (required parameter)
            'use_pattern': 'usePattern',  # (required parameter)
            'pattern': 'pattern'
        }

        self._controller_ref = None
        self._runtime_diag_test_id = None
        self._channel = None
        self._use_pattern = None
        self._pattern = None

    @property
    def controller_ref(self):
        """
        Gets the controller_ref of this RuntimeDiagDescriptor.
        The initiating (alternate) controller to the controller being tested. If the controller to be tested receives the request to run diagnostics, it will return a RETCODE_TRY_ALTERNATE error.

        :return: The controller_ref of this RuntimeDiagDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._controller_ref

    @controller_ref.setter
    def controller_ref(self, controller_ref):
        """
        Sets the controller_ref of this RuntimeDiagDescriptor.
        The initiating (alternate) controller to the controller being tested. If the controller to be tested receives the request to run diagnostics, it will return a RETCODE_TRY_ALTERNATE error.

        :param controller_ref: The controller_ref of this RuntimeDiagDescriptor.
        :type: str
        """
        self._controller_ref = controller_ref

    @property
    def runtime_diag_test_id(self):
        """
        Gets the runtime_diag_test_id of this RuntimeDiagDescriptor.
        The test or tests to run.

        :return: The runtime_diag_test_id of this RuntimeDiagDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._runtime_diag_test_id

    @runtime_diag_test_id.setter
    def runtime_diag_test_id(self, runtime_diag_test_id):
        """
        Sets the runtime_diag_test_id of this RuntimeDiagDescriptor.
        The test or tests to run.

        :param runtime_diag_test_id: The runtime_diag_test_id of this RuntimeDiagDescriptor.
        :type: str
        """
        allowed_values = ["all", "read", "loopbackData", "write", "__UNDEFINED"]
        if runtime_diag_test_id not in allowed_values:
            raise ValueError(
                "Invalid value for `runtime_diag_test_id`, must be one of {0}"
                .format(allowed_values)
            )
        self._runtime_diag_test_id = runtime_diag_test_id

    @property
    def channel(self):
        """
        Gets the channel of this RuntimeDiagDescriptor.
        The channel to use for the loopback data test.

        :return: The channel of this RuntimeDiagDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """
        Sets the channel of this RuntimeDiagDescriptor.
        The channel to use for the loopback data test.

        :param channel: The channel of this RuntimeDiagDescriptor.
        :type: int
        """
        self._channel = channel

    @property
    def use_pattern(self):
        """
        Gets the use_pattern of this RuntimeDiagDescriptor.
        TRUE, if pattern should be used on loopback data test.

        :return: The use_pattern of this RuntimeDiagDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._use_pattern

    @use_pattern.setter
    def use_pattern(self, use_pattern):
        """
        Sets the use_pattern of this RuntimeDiagDescriptor.
        TRUE, if pattern should be used on loopback data test.

        :param use_pattern: The use_pattern of this RuntimeDiagDescriptor.
        :type: bool
        """
        self._use_pattern = use_pattern

    @property
    def pattern(self):
        """
        Gets the pattern of this RuntimeDiagDescriptor.
        The loopback data test pattern.

        :return: The pattern of this RuntimeDiagDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._pattern

    @pattern.setter
    def pattern(self, pattern):
        """
        Sets the pattern of this RuntimeDiagDescriptor.
        The loopback data test pattern.

        :param pattern: The pattern of this RuntimeDiagDescriptor.
        :type: str
        """
        self._pattern = pattern

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

