# coding: utf-8

"""
SAPort.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SAPort(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SAPort - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'sa_port_ref': 'str',  # (required parameter)
            'sa_port_group_ref': 'str',  # (required parameter)
            'controller_ref': 'str',  # (required parameter)
            'port_id': 'int'
        }

        self.attribute_map = {
            'sa_port_ref': 'saPortRef',  # (required parameter)
            'sa_port_group_ref': 'saPortGroupRef',  # (required parameter)
            'controller_ref': 'controllerRef',  # (required parameter)
            'port_id': 'portId'
        }

        self._sa_port_ref = None
        self._sa_port_group_ref = None
        self._controller_ref = None
        self._port_id = None

    @property
    def sa_port_ref(self):
        """
        Gets the sa_port_ref of this SAPort.
        This object uniquely identifies an SAPort.

        :return: The sa_port_ref of this SAPort.
        :rtype: str
        :required/optional: required
        """
        return self._sa_port_ref

    @sa_port_ref.setter
    def sa_port_ref(self, sa_port_ref):
        """
        Sets the sa_port_ref of this SAPort.
        This object uniquely identifies an SAPort.

        :param sa_port_ref: The sa_port_ref of this SAPort.
        :type: str
        """
        self._sa_port_ref = sa_port_ref

    @property
    def sa_port_group_ref(self):
        """
        Gets the sa_port_group_ref of this SAPort.
        This object uniquely identifies an SAPortGroup.

        :return: The sa_port_group_ref of this SAPort.
        :rtype: str
        :required/optional: required
        """
        return self._sa_port_group_ref

    @sa_port_group_ref.setter
    def sa_port_group_ref(self, sa_port_group_ref):
        """
        Sets the sa_port_group_ref of this SAPort.
        This object uniquely identifies an SAPortGroup.

        :param sa_port_group_ref: The sa_port_group_ref of this SAPort.
        :type: str
        """
        self._sa_port_group_ref = sa_port_group_ref

    @property
    def controller_ref(self):
        """
        Gets the controller_ref of this SAPort.
        The reference value of the controller.

        :return: The controller_ref of this SAPort.
        :rtype: str
        :required/optional: required
        """
        return self._controller_ref

    @controller_ref.setter
    def controller_ref(self, controller_ref):
        """
        Sets the controller_ref of this SAPort.
        The reference value of the controller.

        :param controller_ref: The controller_ref of this SAPort.
        :type: str
        """
        self._controller_ref = controller_ref

    @property
    def port_id(self):
        """
        Gets the port_id of this SAPort.
        The host-side I/O port identifier of the port on the controller.

        :return: The port_id of this SAPort.
        :rtype: int
        :required/optional: required
        """
        return self._port_id

    @port_id.setter
    def port_id(self, port_id):
        """
        Sets the port_id of this SAPort.
        The host-side I/O port identifier of the port on the controller.

        :param port_id: The port_id of this SAPort.
        :type: int
        """
        self._port_id = port_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

