# coding: utf-8

"""
ScheduleCalendar.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ScheduleCalendar(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ScheduleCalendar - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'schedule_method': 'str',  # (required parameter)
            'daily': 'ScheduleDaily',  
            'weekly': 'ScheduleWeekly',  
            'monthly_by_date': 'ScheduleMonthlyByDate',  
            'monthly_by_day': 'ScheduleMonthlyByDay'
        }

        self.attribute_map = {
            'schedule_method': 'scheduleMethod',  # (required parameter)
            'daily': 'daily',  
            'weekly': 'weekly',  
            'monthly_by_date': 'monthlyByDate',  
            'monthly_by_day': 'monthlyByDay'
        }

        self._schedule_method = None
        self._daily = None
        self._weekly = None
        self._monthly_by_date = None
        self._monthly_by_day = None

    @property
    def schedule_method(self):
        """
        Gets the schedule_method of this ScheduleCalendar.
        This enumeration specifies the different types of scheduling methods.

        :return: The schedule_method of this ScheduleCalendar.
        :rtype: str
        :required/optional: required
        """
        return self._schedule_method

    @schedule_method.setter
    def schedule_method(self, schedule_method):
        """
        Sets the schedule_method of this ScheduleCalendar.
        This enumeration specifies the different types of scheduling methods.

        :param schedule_method: The schedule_method of this ScheduleCalendar.
        :type: str
        """
        allowed_values = ["unknown", "daily", "weekly", "monthlyDate", "monthlyDay", "__UNDEFINED"]
        if schedule_method not in allowed_values:
            raise ValueError(
                "Invalid value for `schedule_method`, must be one of {0}"
                .format(allowed_values)
            )
        self._schedule_method = schedule_method

    @property
    def daily(self):
        """
        Gets the daily of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_DAILY.

        :return: The daily of this ScheduleCalendar.
        :rtype: ScheduleDaily
        :required/optional: optional
        """
        return self._daily

    @daily.setter
    def daily(self, daily):
        """
        Sets the daily of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_DAILY.

        :param daily: The daily of this ScheduleCalendar.
        :type: ScheduleDaily
        """
        self._daily = daily

    @property
    def weekly(self):
        """
        Gets the weekly of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_WEEKLY.

        :return: The weekly of this ScheduleCalendar.
        :rtype: ScheduleWeekly
        :required/optional: optional
        """
        return self._weekly

    @weekly.setter
    def weekly(self, weekly):
        """
        Sets the weekly of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_WEEKLY.

        :param weekly: The weekly of this ScheduleCalendar.
        :type: ScheduleWeekly
        """
        self._weekly = weekly

    @property
    def monthly_by_date(self):
        """
        Gets the monthly_by_date of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DATE.

        :return: The monthly_by_date of this ScheduleCalendar.
        :rtype: ScheduleMonthlyByDate
        :required/optional: optional
        """
        return self._monthly_by_date

    @monthly_by_date.setter
    def monthly_by_date(self, monthly_by_date):
        """
        Sets the monthly_by_date of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DATE.

        :param monthly_by_date: The monthly_by_date of this ScheduleCalendar.
        :type: ScheduleMonthlyByDate
        """
        self._monthly_by_date = monthly_by_date

    @property
    def monthly_by_day(self):
        """
        Gets the monthly_by_day of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DAY.

        :return: The monthly_by_day of this ScheduleCalendar.
        :rtype: ScheduleMonthlyByDay
        :required/optional: optional
        """
        return self._monthly_by_day

    @monthly_by_day.setter
    def monthly_by_day(self, monthly_by_day):
        """
        Sets the monthly_by_day of this ScheduleCalendar.
        This field is present only if scheduleMethod is equal to SCHEDULE_METHOD_MONTHLY_DAY.

        :param monthly_by_day: The monthly_by_day of this ScheduleCalendar.
        :type: ScheduleMonthlyByDay
        """
        self._monthly_by_day = monthly_by_day

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

