# coding: utf-8

"""
ScheduleCreationDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ScheduleCreationDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ScheduleCreationDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'action': 'str',  # (required parameter)
            'target_object': 'OptionalTargetObject',  # (required parameter)
            'schedule': 'Schedule',  # (required parameter)
            'enabled': 'bool'
        }

        self.attribute_map = {
            'action': 'action',  # (required parameter)
            'target_object': 'targetObject',  # (required parameter)
            'schedule': 'schedule',  # (required parameter)
            'enabled': 'enabled'
        }

        self._action = None
        self._target_object = None
        self._schedule = None
        self._enabled = None

    @property
    def action(self):
        """
        Gets the action of this ScheduleCreationDescriptor.
        The type of action to be taken.

        :return: The action of this ScheduleCreationDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._action

    @action.setter
    def action(self, action):
        """
        Sets the action of this ScheduleCreationDescriptor.
        The type of action to be taken.

        :param action: The action of this ScheduleCreationDescriptor.
        :type: str
        """
        allowed_values = ["unknown", "resnap", "newpit", "newcgpit", "__UNDEFINED"]
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action`, must be one of {0}"
                .format(allowed_values)
            )
        self._action = action

    @property
    def target_object(self):
        """
        Gets the target_object of this ScheduleCreationDescriptor.
        The object associated with schedule.

        :return: The target_object of this ScheduleCreationDescriptor.
        :rtype: OptionalTargetObject
        :required/optional: required
        """
        return self._target_object

    @target_object.setter
    def target_object(self, target_object):
        """
        Sets the target_object of this ScheduleCreationDescriptor.
        The object associated with schedule.

        :param target_object: The target_object of this ScheduleCreationDescriptor.
        :type: OptionalTargetObject
        """
        self._target_object = target_object

    @property
    def schedule(self):
        """
        Gets the schedule of this ScheduleCreationDescriptor.
        All schedule-related information.

        :return: The schedule of this ScheduleCreationDescriptor.
        :rtype: Schedule
        :required/optional: required
        """
        return self._schedule

    @schedule.setter
    def schedule(self, schedule):
        """
        Sets the schedule of this ScheduleCreationDescriptor.
        All schedule-related information.

        :param schedule: The schedule of this ScheduleCreationDescriptor.
        :type: Schedule
        """
        self._schedule = schedule

    @property
    def enabled(self):
        """
        Gets the enabled of this ScheduleCreationDescriptor.
        If true, the schedule will be enabled, otherwise it will be disabled.

        :return: The enabled of this ScheduleCreationDescriptor.
        :rtype: bool
        :required/optional: required
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """
        Sets the enabled of this ScheduleCreationDescriptor.
        If true, the schedule will be enabled, otherwise it will be disabled.

        :param enabled: The enabled of this ScheduleCreationDescriptor.
        :type: bool
        """
        self._enabled = enabled

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

