# coding: utf-8

"""
SnapshotConversionLabel.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SnapshotConversionLabel(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SnapshotConversionLabel - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'snap_repository_ref': 'str',  # (required parameter)
            'new_repository_label': 'str',  # (required parameter)
            'new_pit_group_label': 'str'
        }

        self.attribute_map = {
            'snap_repository_ref': 'snapRepositoryRef',  # (required parameter)
            'new_repository_label': 'newRepositoryLabel',  # (required parameter)
            'new_pit_group_label': 'newPITGroupLabel'
        }

        self._snap_repository_ref = None
        self._new_repository_label = None
        self._new_pit_group_label = None

    @property
    def snap_repository_ref(self):
        """
        Gets the snap_repository_ref of this SnapshotConversionLabel.
        Reference to repository of snapshot being converted. This volume (old snapshot Repository, new PiT group repository) will be renamed using 'newRepositoryLabel' contained in this structure, and the associated PiT group created will be named using the \"newPITGroupLabel\" also contained in this structure. Note: The old snapshot label will be used for the read-only view that is created as part of the conversion process.

        :return: The snap_repository_ref of this SnapshotConversionLabel.
        :rtype: str
        :required/optional: required
        """
        return self._snap_repository_ref

    @snap_repository_ref.setter
    def snap_repository_ref(self, snap_repository_ref):
        """
        Sets the snap_repository_ref of this SnapshotConversionLabel.
        Reference to repository of snapshot being converted. This volume (old snapshot Repository, new PiT group repository) will be renamed using 'newRepositoryLabel' contained in this structure, and the associated PiT group created will be named using the \"newPITGroupLabel\" also contained in this structure. Note: The old snapshot label will be used for the read-only view that is created as part of the conversion process.

        :param snap_repository_ref: The snap_repository_ref of this SnapshotConversionLabel.
        :type: str
        """
        self._snap_repository_ref = snap_repository_ref

    @property
    def new_repository_label(self):
        """
        Gets the new_repository_label of this SnapshotConversionLabel.
        New label for repository volume being converted from a snapshot repository to a PiT group repository.

        :return: The new_repository_label of this SnapshotConversionLabel.
        :rtype: str
        :required/optional: required
        """
        return self._new_repository_label

    @new_repository_label.setter
    def new_repository_label(self, new_repository_label):
        """
        Sets the new_repository_label of this SnapshotConversionLabel.
        New label for repository volume being converted from a snapshot repository to a PiT group repository.

        :param new_repository_label: The new_repository_label of this SnapshotConversionLabel.
        :type: str
        """
        self._new_repository_label = new_repository_label

    @property
    def new_pit_group_label(self):
        """
        Gets the new_pit_group_label of this SnapshotConversionLabel.
        Label for new PiT group being created.

        :return: The new_pit_group_label of this SnapshotConversionLabel.
        :rtype: str
        :required/optional: required
        """
        return self._new_pit_group_label

    @new_pit_group_label.setter
    def new_pit_group_label(self, new_pit_group_label):
        """
        Sets the new_pit_group_label of this SnapshotConversionLabel.
        Label for new PiT group being created.

        :param new_pit_group_label: The new_pit_group_label of this SnapshotConversionLabel.
        :type: str
        """
        self._new_pit_group_label = new_pit_group_label

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

