# coding: utf-8

"""
SnapshotFailure.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SnapshotFailure(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SnapshotFailure - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'repository_volume': 'str',  # (required parameter)
            'snapshot_volume': 'str',  # (required parameter)
            'repository_full': 'bool'
        }

        self.attribute_map = {
            'repository_volume': 'repositoryVolume',  # (required parameter)
            'snapshot_volume': 'snapshotVolume',  # (required parameter)
            'repository_full': 'repositoryFull'
        }

        self._repository_volume = None
        self._snapshot_volume = None
        self._repository_full = None

    @property
    def repository_volume(self):
        """
        Gets the repository_volume of this SnapshotFailure.
        The repository volume that failed.

        :return: The repository_volume of this SnapshotFailure.
        :rtype: str
        :required/optional: required
        """
        return self._repository_volume

    @repository_volume.setter
    def repository_volume(self, repository_volume):
        """
        Sets the repository_volume of this SnapshotFailure.
        The repository volume that failed.

        :param repository_volume: The repository_volume of this SnapshotFailure.
        :type: str
        """
        self._repository_volume = repository_volume

    @property
    def snapshot_volume(self):
        """
        Gets the snapshot_volume of this SnapshotFailure.
        The snapshot volume that failed.

        :return: The snapshot_volume of this SnapshotFailure.
        :rtype: str
        :required/optional: required
        """
        return self._snapshot_volume

    @snapshot_volume.setter
    def snapshot_volume(self, snapshot_volume):
        """
        Sets the snapshot_volume of this SnapshotFailure.
        The snapshot volume that failed.

        :param snapshot_volume: The snapshot_volume of this SnapshotFailure.
        :type: str
        """
        self._snapshot_volume = snapshot_volume

    @property
    def repository_full(self):
        """
        Gets the repository_full of this SnapshotFailure.
        The policy explaining the behavior when the repository is full.

        :return: The repository_full of this SnapshotFailure.
        :rtype: bool
        :required/optional: required
        """
        return self._repository_full

    @repository_full.setter
    def repository_full(self, repository_full):
        """
        Sets the repository_full of this SnapshotFailure.
        The policy explaining the behavior when the repository is full.

        :param repository_full: The repository_full of this SnapshotFailure.
        :type: bool
        """
        self._repository_full = repository_full

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

