# coding: utf-8

"""
SnapshotParamsUpdateDescriptor.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SnapshotParamsUpdateDescriptor(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SnapshotParamsUpdateDescriptor - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'snap_ref': 'str',  # (required parameter)
            'warn_threshold': 'int',  # (required parameter)
            'extent_start': 'int',  # (required parameter)
            'extent_size': 'int',  # (required parameter)
            'rep_full_policy': 'str',  # (required parameter)
            'rollback_priority': 'int'
        }

        self.attribute_map = {
            'snap_ref': 'snapRef',  # (required parameter)
            'warn_threshold': 'warnThreshold',  # (required parameter)
            'extent_start': 'extentStart',  # (required parameter)
            'extent_size': 'extentSize',  # (required parameter)
            'rep_full_policy': 'repFullPolicy',  # (required parameter)
            'rollback_priority': 'rollbackPriority'
        }

        self._snap_ref = None
        self._warn_threshold = None
        self._extent_start = None
        self._extent_size = None
        self._rep_full_policy = None
        self._rollback_priority = None

    @property
    def snap_ref(self):
        """
        Gets the snap_ref of this SnapshotParamsUpdateDescriptor.
        The snapshot volume to be updated.

        :return: The snap_ref of this SnapshotParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._snap_ref

    @snap_ref.setter
    def snap_ref(self, snap_ref):
        """
        Sets the snap_ref of this SnapshotParamsUpdateDescriptor.
        The snapshot volume to be updated.

        :param snap_ref: The snap_ref of this SnapshotParamsUpdateDescriptor.
        :type: str
        """
        self._snap_ref = snap_ref

    @property
    def warn_threshold(self):
        """
        Gets the warn_threshold of this SnapshotParamsUpdateDescriptor.
        The repository utilization warning threshold.

        :return: The warn_threshold of this SnapshotParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._warn_threshold

    @warn_threshold.setter
    def warn_threshold(self, warn_threshold):
        """
        Sets the warn_threshold of this SnapshotParamsUpdateDescriptor.
        The repository utilization warning threshold.

        :param warn_threshold: The warn_threshold of this SnapshotParamsUpdateDescriptor.
        :type: int
        """
        self._warn_threshold = warn_threshold

    @property
    def extent_start(self):
        """
        Gets the extent_start of this SnapshotParamsUpdateDescriptor.
        The start position of the extent in the base volume (bytes). Not used in this release of software.

        :return: The extent_start of this SnapshotParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._extent_start

    @extent_start.setter
    def extent_start(self, extent_start):
        """
        Sets the extent_start of this SnapshotParamsUpdateDescriptor.
        The start position of the extent in the base volume (bytes). Not used in this release of software.

        :param extent_start: The extent_start of this SnapshotParamsUpdateDescriptor.
        :type: int
        """
        self._extent_start = extent_start

    @property
    def extent_size(self):
        """
        Gets the extent_size of this SnapshotParamsUpdateDescriptor.
        The size of the extent in bytes. Not used in this release of software.

        :return: The extent_size of this SnapshotParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._extent_size

    @extent_size.setter
    def extent_size(self, extent_size):
        """
        Sets the extent_size of this SnapshotParamsUpdateDescriptor.
        The size of the extent in bytes. Not used in this release of software.

        :param extent_size: The extent_size of this SnapshotParamsUpdateDescriptor.
        :type: int
        """
        self._extent_size = extent_size

    @property
    def rep_full_policy(self):
        """
        Gets the rep_full_policy of this SnapshotParamsUpdateDescriptor.
        The policy concerning what will happen when the repository is full.

        :return: The rep_full_policy of this SnapshotParamsUpdateDescriptor.
        :rtype: str
        :required/optional: required
        """
        return self._rep_full_policy

    @rep_full_policy.setter
    def rep_full_policy(self, rep_full_policy):
        """
        Sets the rep_full_policy of this SnapshotParamsUpdateDescriptor.
        The policy concerning what will happen when the repository is full.

        :param rep_full_policy: The rep_full_policy of this SnapshotParamsUpdateDescriptor.
        :type: str
        """
        allowed_values = ["failwrites", "failsnap", "__UNDEFINED"]
        if rep_full_policy not in allowed_values:
            raise ValueError(
                "Invalid value for `rep_full_policy`, must be one of {0}"
                .format(allowed_values)
            )
        self._rep_full_policy = rep_full_policy

    @property
    def rollback_priority(self):
        """
        Gets the rollback_priority of this SnapshotParamsUpdateDescriptor.
        The importance of the rollback operation.

        :return: The rollback_priority of this SnapshotParamsUpdateDescriptor.
        :rtype: int
        :required/optional: required
        """
        return self._rollback_priority

    @rollback_priority.setter
    def rollback_priority(self, rollback_priority):
        """
        Sets the rollback_priority of this SnapshotParamsUpdateDescriptor.
        The importance of the rollback operation.

        :param rollback_priority: The rollback_priority of this SnapshotParamsUpdateDescriptor.
        :type: int
        """
        self._rollback_priority = rollback_priority

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

