# coding: utf-8

"""
SNMPTrapDestination.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SNMPTrapDestination(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SNMPTrapDestination - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'trap_destination_ref': 'str',  # (required parameter)
            'trap_receiver_ip_address': 'IpVxAddress',  # (required parameter)
            'community_ref': 'str',  # (required parameter)
            'send_authentication_failure_traps': 'bool'
        }

        self.attribute_map = {
            'trap_destination_ref': 'trapDestinationRef',  # (required parameter)
            'trap_receiver_ip_address': 'trapReceiverIpAddress',  # (required parameter)
            'community_ref': 'communityRef',  # (required parameter)
            'send_authentication_failure_traps': 'sendAuthenticationFailureTraps'
        }

        self._trap_destination_ref = None
        self._trap_receiver_ip_address = None
        self._community_ref = None
        self._send_authentication_failure_traps = None

    @property
    def trap_destination_ref(self):
        """
        Gets the trap_destination_ref of this SNMPTrapDestination.
        SNMP trap destination reference.

        :return: The trap_destination_ref of this SNMPTrapDestination.
        :rtype: str
        :required/optional: required
        """
        return self._trap_destination_ref

    @trap_destination_ref.setter
    def trap_destination_ref(self, trap_destination_ref):
        """
        Sets the trap_destination_ref of this SNMPTrapDestination.
        SNMP trap destination reference.

        :param trap_destination_ref: The trap_destination_ref of this SNMPTrapDestination.
        :type: str
        """
        self._trap_destination_ref = trap_destination_ref

    @property
    def trap_receiver_ip_address(self):
        """
        Gets the trap_receiver_ip_address of this SNMPTrapDestination.
        IPVx address of the trap receiver

        :return: The trap_receiver_ip_address of this SNMPTrapDestination.
        :rtype: IpVxAddress
        :required/optional: required
        """
        return self._trap_receiver_ip_address

    @trap_receiver_ip_address.setter
    def trap_receiver_ip_address(self, trap_receiver_ip_address):
        """
        Sets the trap_receiver_ip_address of this SNMPTrapDestination.
        IPVx address of the trap receiver

        :param trap_receiver_ip_address: The trap_receiver_ip_address of this SNMPTrapDestination.
        :type: IpVxAddress
        """
        self._trap_receiver_ip_address = trap_receiver_ip_address

    @property
    def community_ref(self):
        """
        Gets the community_ref of this SNMPTrapDestination.
        Community associated with the trap destination

        :return: The community_ref of this SNMPTrapDestination.
        :rtype: str
        :required/optional: required
        """
        return self._community_ref

    @community_ref.setter
    def community_ref(self, community_ref):
        """
        Sets the community_ref of this SNMPTrapDestination.
        Community associated with the trap destination

        :param community_ref: The community_ref of this SNMPTrapDestination.
        :type: str
        """
        self._community_ref = community_ref

    @property
    def send_authentication_failure_traps(self):
        """
        Gets the send_authentication_failure_traps of this SNMPTrapDestination.
        Send authentication failure traps to this destination.

        :return: The send_authentication_failure_traps of this SNMPTrapDestination.
        :rtype: bool
        :required/optional: required
        """
        return self._send_authentication_failure_traps

    @send_authentication_failure_traps.setter
    def send_authentication_failure_traps(self, send_authentication_failure_traps):
        """
        Sets the send_authentication_failure_traps of this SNMPTrapDestination.
        Send authentication failure traps to this destination.

        :param send_authentication_failure_traps: The send_authentication_failure_traps of this SNMPTrapDestination.
        :type: bool
        """
        self._send_authentication_failure_traps = send_authentication_failure_traps

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

