# coding: utf-8

"""
SocData.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SocData(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SocData - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'valid': 'bool',  # (required parameter)
            'soc_device_data': 'SocDeviceData',  # (required parameter)
            'soc_port_data': 'list[SocPortData]'
        }

        self.attribute_map = {
            'valid': 'valid',  # (required parameter)
            'soc_device_data': 'socDeviceData',  # (required parameter)
            'soc_port_data': 'socPortData'
        }

        self._valid = None
        self._soc_device_data = None
        self._soc_port_data = None

    @property
    def valid(self):
        """
        Gets the valid of this SocData.
        Set to true if the information in this structure is valid.

        :return: The valid of this SocData.
        :rtype: bool
        :required/optional: required
        """
        return self._valid

    @valid.setter
    def valid(self, valid):
        """
        Sets the valid of this SocData.
        Set to true if the information in this structure is valid.

        :param valid: The valid of this SocData.
        :type: bool
        """
        self._valid = valid

    @property
    def soc_device_data(self):
        """
        Gets the soc_device_data of this SocData.
        Port-independent data about the SOC device.

        :return: The soc_device_data of this SocData.
        :rtype: SocDeviceData
        :required/optional: required
        """
        return self._soc_device_data

    @soc_device_data.setter
    def soc_device_data(self, soc_device_data):
        """
        Sets the soc_device_data of this SocData.
        Port-independent data about the SOC device.

        :param soc_device_data: The soc_device_data of this SocData.
        :type: SocDeviceData
        """
        self._soc_device_data = soc_device_data

    @property
    def soc_port_data(self):
        """
        Gets the soc_port_data of this SocData.
        An array in which each element (one per port) contains port-dependent SOC device data.

        :return: The soc_port_data of this SocData.
        :rtype: list[SocPortData]
        :required/optional: required
        """
        return self._soc_port_data

    @soc_port_data.setter
    def soc_port_data(self, soc_port_data):
        """
        Sets the soc_port_data of this SocData.
        An array in which each element (one per port) contains port-dependent SOC device data.

        :param soc_port_data: The soc_port_data of this SocData.
        :type: list[SocPortData]
        """
        self._soc_port_data = soc_port_data

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

