# coding: utf-8

"""
SSDWearLife.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SSDWearLife(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SSDWearLife - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'average_erase_count_percent': 'int',  # (required parameter)
            'spare_blocks_remaining_percent': 'int',  # (required parameter)
            'is_wear_life_monitoring_supported': 'bool'
        }

        self.attribute_map = {
            'average_erase_count_percent': 'averageEraseCountPercent',  # (required parameter)
            'spare_blocks_remaining_percent': 'spareBlocksRemainingPercent',  # (required parameter)
            'is_wear_life_monitoring_supported': 'isWearLifeMonitoringSupported'
        }

        self._average_erase_count_percent = None
        self._spare_blocks_remaining_percent = None
        self._is_wear_life_monitoring_supported = None

    @property
    def average_erase_count_percent(self):
        """
        Gets the average_erase_count_percent of this SSDWearLife.
        The percentage of average erase count.

        :return: The average_erase_count_percent of this SSDWearLife.
        :rtype: int
        :required/optional: required
        """
        return self._average_erase_count_percent

    @average_erase_count_percent.setter
    def average_erase_count_percent(self, average_erase_count_percent):
        """
        Sets the average_erase_count_percent of this SSDWearLife.
        The percentage of average erase count.

        :param average_erase_count_percent: The average_erase_count_percent of this SSDWearLife.
        :type: int
        """
        self._average_erase_count_percent = average_erase_count_percent

    @property
    def spare_blocks_remaining_percent(self):
        """
        Gets the spare_blocks_remaining_percent of this SSDWearLife.
        The percentage of spare blocks remaining in the solid state drive. Controller firmware checks and updates this percentage approximately once per hour.

        :return: The spare_blocks_remaining_percent of this SSDWearLife.
        :rtype: int
        :required/optional: required
        """
        return self._spare_blocks_remaining_percent

    @spare_blocks_remaining_percent.setter
    def spare_blocks_remaining_percent(self, spare_blocks_remaining_percent):
        """
        Sets the spare_blocks_remaining_percent of this SSDWearLife.
        The percentage of spare blocks remaining in the solid state drive. Controller firmware checks and updates this percentage approximately once per hour.

        :param spare_blocks_remaining_percent: The spare_blocks_remaining_percent of this SSDWearLife.
        :type: int
        """
        self._spare_blocks_remaining_percent = spare_blocks_remaining_percent

    @property
    def is_wear_life_monitoring_supported(self):
        """
        Gets the is_wear_life_monitoring_supported of this SSDWearLife.
        This field is set to true if wear life monitoring is supported on the drive. If true then the values in the other fields in this structure are valid, otherwise they are not valid.

        :return: The is_wear_life_monitoring_supported of this SSDWearLife.
        :rtype: bool
        :required/optional: required
        """
        return self._is_wear_life_monitoring_supported

    @is_wear_life_monitoring_supported.setter
    def is_wear_life_monitoring_supported(self, is_wear_life_monitoring_supported):
        """
        Sets the is_wear_life_monitoring_supported of this SSDWearLife.
        This field is set to true if wear life monitoring is supported on the drive. If true then the values in the other fields in this structure are valid, otherwise they are not valid.

        :param is_wear_life_monitoring_supported: The is_wear_life_monitoring_supported of this SSDWearLife.
        :type: bool
        """
        self._is_wear_life_monitoring_supported = is_wear_life_monitoring_supported

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

