# coding: utf-8

"""
SyslogConfiguration.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SyslogConfiguration(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SyslogConfiguration - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'syslog_enabled': 'bool',  # (required parameter)
            'syslog_server_port_number': 'int',  # (required parameter)
            'syslog_server_ip_address': 'IpVxAddress'
        }

        self.attribute_map = {
            'syslog_enabled': 'syslogEnabled',  # (required parameter)
            'syslog_server_port_number': 'syslogServerPortNumber',  # (required parameter)
            'syslog_server_ip_address': 'syslogServerIpAddress'
        }

        self._syslog_enabled = None
        self._syslog_server_port_number = None
        self._syslog_server_ip_address = None

    @property
    def syslog_enabled(self):
        """
        Gets the syslog_enabled of this SyslogConfiguration.
        This field is set to true if the writing of MEL events to a syslog server is enabled; otherwise it is false.

        :return: The syslog_enabled of this SyslogConfiguration.
        :rtype: bool
        :required/optional: required
        """
        return self._syslog_enabled

    @syslog_enabled.setter
    def syslog_enabled(self, syslog_enabled):
        """
        Sets the syslog_enabled of this SyslogConfiguration.
        This field is set to true if the writing of MEL events to a syslog server is enabled; otherwise it is false.

        :param syslog_enabled: The syslog_enabled of this SyslogConfiguration.
        :type: bool
        """
        self._syslog_enabled = syslog_enabled

    @property
    def syslog_server_port_number(self):
        """
        Gets the syslog_server_port_number of this SyslogConfiguration.
        This field holds the UDP port number of the syslog server. The default value of this field is SYSLOG_DEFAULT_UDP_PORT.

        :return: The syslog_server_port_number of this SyslogConfiguration.
        :rtype: int
        :required/optional: required
        """
        return self._syslog_server_port_number

    @syslog_server_port_number.setter
    def syslog_server_port_number(self, syslog_server_port_number):
        """
        Sets the syslog_server_port_number of this SyslogConfiguration.
        This field holds the UDP port number of the syslog server. The default value of this field is SYSLOG_DEFAULT_UDP_PORT.

        :param syslog_server_port_number: The syslog_server_port_number of this SyslogConfiguration.
        :type: int
        """
        self._syslog_server_port_number = syslog_server_port_number

    @property
    def syslog_server_ip_address(self):
        """
        Gets the syslog_server_ip_address of this SyslogConfiguration.
        This field holds the IPVx address of the syslog server. The default value of this field is zero (0.0.0.0).

        :return: The syslog_server_ip_address of this SyslogConfiguration.
        :rtype: IpVxAddress
        :required/optional: required
        """
        return self._syslog_server_ip_address

    @syslog_server_ip_address.setter
    def syslog_server_ip_address(self, syslog_server_ip_address):
        """
        Sets the syslog_server_ip_address of this SyslogConfiguration.
        This field holds the IPVx address of the syslog server. The default value of this field is zero (0.0.0.0).

        :param syslog_server_ip_address: The syslog_server_ip_address of this SyslogConfiguration.
        :type: IpVxAddress
        """
        self._syslog_server_ip_address = syslog_server_ip_address

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

