# coding: utf-8

"""
ThinVolumeCapacityProvisioningDetails.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ThinVolumeCapacityProvisioningDetails(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ThinVolumeCapacityProvisioningDetails - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'capacity_quota': 'int',  # (required parameter)
            'growth_alert_threshold': 'int',  # (required parameter)
            'repository_expansion_policy': 'str'
        }

        self.attribute_map = {
            'capacity_quota': 'capacityQuota',  # (required parameter)
            'growth_alert_threshold': 'growthAlertThreshold',  # (required parameter)
            'repository_expansion_policy': 'repositoryExpansionPolicy'
        }

        self._capacity_quota = None
        self._growth_alert_threshold = None
        self._repository_expansion_policy = None

    @property
    def capacity_quota(self):
        """
        Gets the capacity_quota of this ThinVolumeCapacityProvisioningDetails.
        The maximum capacity to which the Expandable Repository Volume can grow (in bytes).

        :return: The capacity_quota of this ThinVolumeCapacityProvisioningDetails.
        :rtype: int
        :required/optional: required
        """
        return self._capacity_quota

    @capacity_quota.setter
    def capacity_quota(self, capacity_quota):
        """
        Sets the capacity_quota of this ThinVolumeCapacityProvisioningDetails.
        The maximum capacity to which the Expandable Repository Volume can grow (in bytes).

        :param capacity_quota: The capacity_quota of this ThinVolumeCapacityProvisioningDetails.
        :type: int
        """
        self._capacity_quota = capacity_quota

    @property
    def growth_alert_threshold(self):
        """
        Gets the growth_alert_threshold of this ThinVolumeCapacityProvisioningDetails.
        The alert threshold percent value for the Expandable Repository Volume.

        :return: The growth_alert_threshold of this ThinVolumeCapacityProvisioningDetails.
        :rtype: int
        :required/optional: required
        """
        return self._growth_alert_threshold

    @growth_alert_threshold.setter
    def growth_alert_threshold(self, growth_alert_threshold):
        """
        Sets the growth_alert_threshold of this ThinVolumeCapacityProvisioningDetails.
        The alert threshold percent value for the Expandable Repository Volume.

        :param growth_alert_threshold: The growth_alert_threshold of this ThinVolumeCapacityProvisioningDetails.
        :type: int
        """
        self._growth_alert_threshold = growth_alert_threshold

    @property
    def repository_expansion_policy(self):
        """
        Gets the repository_expansion_policy of this ThinVolumeCapacityProvisioningDetails.
        The expansion policy for the Expandable Repository Volume.

        :return: The repository_expansion_policy of this ThinVolumeCapacityProvisioningDetails.
        :rtype: str
        :required/optional: required
        """
        return self._repository_expansion_policy

    @repository_expansion_policy.setter
    def repository_expansion_policy(self, repository_expansion_policy):
        """
        Sets the repository_expansion_policy of this ThinVolumeCapacityProvisioningDetails.
        The expansion policy for the Expandable Repository Volume.

        :param repository_expansion_policy: The repository_expansion_policy of this ThinVolumeCapacityProvisioningDetails.
        :type: str
        """
        allowed_values = ["unknown", "manual", "automatic", "__UNDEFINED"]
        if repository_expansion_policy not in allowed_values:
            raise ValueError(
                "Invalid value for `repository_expansion_policy`, must be one of {0}"
                .format(allowed_values)
            )
        self._repository_expansion_policy = repository_expansion_policy

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

