# coding: utf-8

"""
ThinVolumeDefaultAttributes.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ThinVolumeDefaultAttributes(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ThinVolumeDefaultAttributes - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'min_provisioned_capacity': 'int',  # (required parameter)
            'max_provisioned_capacity': 'int',  # (required parameter)
            'min_virtual_capacity': 'int',  # (required parameter)
            'max_virtual_capacity': 'int',  # (required parameter)
            'min_alert_threshold': 'int',  # (required parameter)
            'default_alert_threshold': 'int'
        }

        self.attribute_map = {
            'min_provisioned_capacity': 'minProvisionedCapacity',  # (required parameter)
            'max_provisioned_capacity': 'maxProvisionedCapacity',  # (required parameter)
            'min_virtual_capacity': 'minVirtualCapacity',  # (required parameter)
            'max_virtual_capacity': 'maxVirtualCapacity',  # (required parameter)
            'min_alert_threshold': 'minAlertThreshold',  # (required parameter)
            'default_alert_threshold': 'defaultAlertThreshold'
        }

        self._min_provisioned_capacity = None
        self._max_provisioned_capacity = None
        self._min_virtual_capacity = None
        self._max_virtual_capacity = None
        self._min_alert_threshold = None
        self._default_alert_threshold = None

    @property
    def min_provisioned_capacity(self):
        """
        Gets the min_provisioned_capacity of this ThinVolumeDefaultAttributes.
        The minimum provisioned capacity in bytes.

        :return: The min_provisioned_capacity of this ThinVolumeDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._min_provisioned_capacity

    @min_provisioned_capacity.setter
    def min_provisioned_capacity(self, min_provisioned_capacity):
        """
        Sets the min_provisioned_capacity of this ThinVolumeDefaultAttributes.
        The minimum provisioned capacity in bytes.

        :param min_provisioned_capacity: The min_provisioned_capacity of this ThinVolumeDefaultAttributes.
        :type: int
        """
        self._min_provisioned_capacity = min_provisioned_capacity

    @property
    def max_provisioned_capacity(self):
        """
        Gets the max_provisioned_capacity of this ThinVolumeDefaultAttributes.
        The maximum provisioned capacity in bytes.

        :return: The max_provisioned_capacity of this ThinVolumeDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._max_provisioned_capacity

    @max_provisioned_capacity.setter
    def max_provisioned_capacity(self, max_provisioned_capacity):
        """
        Sets the max_provisioned_capacity of this ThinVolumeDefaultAttributes.
        The maximum provisioned capacity in bytes.

        :param max_provisioned_capacity: The max_provisioned_capacity of this ThinVolumeDefaultAttributes.
        :type: int
        """
        self._max_provisioned_capacity = max_provisioned_capacity

    @property
    def min_virtual_capacity(self):
        """
        Gets the min_virtual_capacity of this ThinVolumeDefaultAttributes.
        The minimum virtual capacity in bytes.

        :return: The min_virtual_capacity of this ThinVolumeDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._min_virtual_capacity

    @min_virtual_capacity.setter
    def min_virtual_capacity(self, min_virtual_capacity):
        """
        Sets the min_virtual_capacity of this ThinVolumeDefaultAttributes.
        The minimum virtual capacity in bytes.

        :param min_virtual_capacity: The min_virtual_capacity of this ThinVolumeDefaultAttributes.
        :type: int
        """
        self._min_virtual_capacity = min_virtual_capacity

    @property
    def max_virtual_capacity(self):
        """
        Gets the max_virtual_capacity of this ThinVolumeDefaultAttributes.
        The maximum virtual capacity in bytes.

        :return: The max_virtual_capacity of this ThinVolumeDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._max_virtual_capacity

    @max_virtual_capacity.setter
    def max_virtual_capacity(self, max_virtual_capacity):
        """
        Sets the max_virtual_capacity of this ThinVolumeDefaultAttributes.
        The maximum virtual capacity in bytes.

        :param max_virtual_capacity: The max_virtual_capacity of this ThinVolumeDefaultAttributes.
        :type: int
        """
        self._max_virtual_capacity = max_virtual_capacity

    @property
    def min_alert_threshold(self):
        """
        Gets the min_alert_threshold of this ThinVolumeDefaultAttributes.
        The minimum alert threshold as a percentage.

        :return: The min_alert_threshold of this ThinVolumeDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._min_alert_threshold

    @min_alert_threshold.setter
    def min_alert_threshold(self, min_alert_threshold):
        """
        Sets the min_alert_threshold of this ThinVolumeDefaultAttributes.
        The minimum alert threshold as a percentage.

        :param min_alert_threshold: The min_alert_threshold of this ThinVolumeDefaultAttributes.
        :type: int
        """
        self._min_alert_threshold = min_alert_threshold

    @property
    def default_alert_threshold(self):
        """
        Gets the default_alert_threshold of this ThinVolumeDefaultAttributes.
        The default alert threshold as a percentage.

        :return: The default_alert_threshold of this ThinVolumeDefaultAttributes.
        :rtype: int
        :required/optional: required
        """
        return self._default_alert_threshold

    @default_alert_threshold.setter
    def default_alert_threshold(self, default_alert_threshold):
        """
        Sets the default_alert_threshold of this ThinVolumeDefaultAttributes.
        The default alert threshold as a percentage.

        :param default_alert_threshold: The default_alert_threshold of this ThinVolumeDefaultAttributes.
        :type: int
        """
        self._default_alert_threshold = default_alert_threshold

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

