# coding: utf-8

"""
TimeZoneDescription.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class TimeZoneDescription(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        TimeZoneDescription - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'tz_label': 'str',  # (required parameter)
            'tz_offset': 'int',  # (required parameter)
            'dst_start': 'DaylightSavingsTime',  # (required parameter)
            'dst_end': 'DaylightSavingsTime',  # (required parameter)
            'dst_adjust': 'int'
        }

        self.attribute_map = {
            'tz_label': 'tzLabel',  # (required parameter)
            'tz_offset': 'tzOffset',  # (required parameter)
            'dst_start': 'dstStart',  # (required parameter)
            'dst_end': 'dstEnd',  # (required parameter)
            'dst_adjust': 'dstAdjust'
        }

        self._tz_label = None
        self._tz_offset = None
        self._dst_start = None
        self._dst_end = None
        self._dst_adjust = None

    @property
    def tz_label(self):
        """
        Gets the tz_label of this TimeZoneDescription.
        The time zone identifier (ASCII).

        :return: The tz_label of this TimeZoneDescription.
        :rtype: str
        :required/optional: required
        """
        return self._tz_label

    @tz_label.setter
    def tz_label(self, tz_label):
        """
        Sets the tz_label of this TimeZoneDescription.
        The time zone identifier (ASCII).

        :param tz_label: The tz_label of this TimeZoneDescription.
        :type: str
        """
        self._tz_label = tz_label

    @property
    def tz_offset(self):
        """
        Gets the tz_offset of this TimeZoneDescription.
        The time zone offset measured in seconds +/- from GMT.

        :return: The tz_offset of this TimeZoneDescription.
        :rtype: int
        :required/optional: required
        """
        return self._tz_offset

    @tz_offset.setter
    def tz_offset(self, tz_offset):
        """
        Sets the tz_offset of this TimeZoneDescription.
        The time zone offset measured in seconds +/- from GMT.

        :param tz_offset: The tz_offset of this TimeZoneDescription.
        :type: int
        """
        self._tz_offset = tz_offset

    @property
    def dst_start(self):
        """
        Gets the dst_start of this TimeZoneDescription.
        The DST start date and time.

        :return: The dst_start of this TimeZoneDescription.
        :rtype: DaylightSavingsTime
        :required/optional: required
        """
        return self._dst_start

    @dst_start.setter
    def dst_start(self, dst_start):
        """
        Sets the dst_start of this TimeZoneDescription.
        The DST start date and time.

        :param dst_start: The dst_start of this TimeZoneDescription.
        :type: DaylightSavingsTime
        """
        self._dst_start = dst_start

    @property
    def dst_end(self):
        """
        Gets the dst_end of this TimeZoneDescription.
        The DST end date and time.

        :return: The dst_end of this TimeZoneDescription.
        :rtype: DaylightSavingsTime
        :required/optional: required
        """
        return self._dst_end

    @dst_end.setter
    def dst_end(self, dst_end):
        """
        Sets the dst_end of this TimeZoneDescription.
        The DST end date and time.

        :param dst_end: The dst_end of this TimeZoneDescription.
        :type: DaylightSavingsTime
        """
        self._dst_end = dst_end

    @property
    def dst_adjust(self):
        """
        Gets the dst_adjust of this TimeZoneDescription.
        The number of seconds to adjust the clock during DST

        :return: The dst_adjust of this TimeZoneDescription.
        :rtype: int
        :required/optional: required
        """
        return self._dst_adjust

    @dst_adjust.setter
    def dst_adjust(self, dst_adjust):
        """
        Sets the dst_adjust of this TimeZoneDescription.
        The number of seconds to adjust the clock during DST

        :param dst_adjust: The dst_adjust of this TimeZoneDescription.
        :type: int
        """
        self._dst_adjust = dst_adjust

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

