# coding: utf-8

"""
AboutResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AboutResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AboutResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'running_as_proxy': 'bool',  # (required parameter)
            'version': 'str',  # (required parameter)
            'system_id': 'str',  # (required parameter)
            'controller_position': 'int'
        }

        self.attribute_map = {
            'running_as_proxy': 'runningAsProxy',  # (required parameter)
            'version': 'version',  # (required parameter)
            'system_id': 'systemId',  # (required parameter)
            'controller_position': 'controllerPosition'
        }

        self._running_as_proxy = None
        self._version = None
        self._system_id = None
        self._controller_position = None

    @property
    def running_as_proxy(self):
        """
        Gets the running_as_proxy of this AboutResponse.
        True if the REST API is running as a proxy, false if it is embedded on a storage system

        :return: The running_as_proxy of this AboutResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._running_as_proxy

    @running_as_proxy.setter
    def running_as_proxy(self, running_as_proxy):
        """
        Sets the running_as_proxy of this AboutResponse.
        True if the REST API is running as a proxy, false if it is embedded on a storage system

        :param running_as_proxy: The running_as_proxy of this AboutResponse.
        :type: bool
        """
        self._running_as_proxy = running_as_proxy

    @property
    def version(self):
        """
        Gets the version of this AboutResponse.
        Product Version

        :return: The version of this AboutResponse.
        :rtype: str
        :required/optional: required
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this AboutResponse.
        Product Version

        :param version: The version of this AboutResponse.
        :type: str
        """
        self._version = version

    @property
    def system_id(self):
        """
        Gets the system_id of this AboutResponse.
        A unique id of this REST API install

        :return: The system_id of this AboutResponse.
        :rtype: str
        :required/optional: required
        """
        return self._system_id

    @system_id.setter
    def system_id(self, system_id):
        """
        Sets the system_id of this AboutResponse.
        A unique id of this REST API install

        :param system_id: The system_id of this AboutResponse.
        :type: str
        """
        self._system_id = system_id

    @property
    def controller_position(self):
        """
        Gets the controller_position of this AboutResponse.
        Managing controller position

        :return: The controller_position of this AboutResponse.
        :rtype: int
        :required/optional: required
        """
        return self._controller_position

    @controller_position.setter
    def controller_position(self, controller_position):
        """
        Sets the controller_position of this AboutResponse.
        Managing controller position

        :param controller_position: The controller_position of this AboutResponse.
        :type: int
        """
        self._controller_position = controller_position

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

