# coding: utf-8

"""
AsupRegistrationRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsupRegistrationRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsupRegistrationRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'entries': 'list[AsupEntry]',  # (required parameter)
            'id': 'str',  
            'model_name': 'str',  # (required parameter)
            'subject_name': 'str'
        }

        self.attribute_map = {
            'entries': 'entries',  # (required parameter)
            'id': 'id',  
            'model_name': 'modelName',  # (required parameter)
            'subject_name': 'subjectName'
        }

        self._entries = None
        self._id = None
        self._model_name = None
        self._subject_name = None

    @property
    def entries(self):
        """
        Gets the entries of this AsupRegistrationRequest.
        The bundle entries

        :return: The entries of this AsupRegistrationRequest.
        :rtype: list[AsupEntry]
        :required/optional: required
        """
        return self._entries

    @entries.setter
    def entries(self, entries):
        """
        Sets the entries of this AsupRegistrationRequest.
        The bundle entries

        :param entries: The entries of this AsupRegistrationRequest.
        :type: list[AsupEntry]
        """
        self._entries = entries

    @property
    def id(self):
        """
        Gets the id of this AsupRegistrationRequest.
        Id of bundle to be registered

        :return: The id of this AsupRegistrationRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this AsupRegistrationRequest.
        Id of bundle to be registered

        :param id: The id of this AsupRegistrationRequest.
        :type: str
        """
        self._id = id

    @property
    def model_name(self):
        """
        Gets the model_name of this AsupRegistrationRequest.
        Model name of bundle to be registered

        :return: The model_name of this AsupRegistrationRequest.
        :rtype: str
        :required/optional: required
        """
        return self._model_name

    @model_name.setter
    def model_name(self, model_name):
        """
        Sets the model_name of this AsupRegistrationRequest.
        Model name of bundle to be registered

        :param model_name: The model_name of this AsupRegistrationRequest.
        :type: str
        """
        self._model_name = model_name

    @property
    def subject_name(self):
        """
        Gets the subject_name of this AsupRegistrationRequest.
        Subject name of bundle to be registered

        :return: The subject_name of this AsupRegistrationRequest.
        :rtype: str
        :required/optional: required
        """
        return self._subject_name

    @subject_name.setter
    def subject_name(self, subject_name):
        """
        Sets the subject_name of this AsupRegistrationRequest.
        Subject name of bundle to be registered

        :param subject_name: The subject_name of this AsupRegistrationRequest.
        :type: str
        """
        self._subject_name = subject_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

