# coding: utf-8

"""
AsyncMirrorGroupCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class AsyncMirrorGroupCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AsyncMirrorGroupCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',  # (required parameter)
            'secondary_array_id': 'str',  # (required parameter)
            'sync_interval_minutes': 'int',  
            'manual_sync': 'bool',  
            'recovery_warn_threshold_minutes': 'int',  
            'repo_utilization_warn_threshold': 'int',  
            'interface_type': 'str',  
            'sync_warn_threshold_minutes': 'int'
        }

        self.attribute_map = {
            'name': 'name',  # (required parameter)
            'secondary_array_id': 'secondaryArrayId',  # (required parameter)
            'sync_interval_minutes': 'syncIntervalMinutes',  
            'manual_sync': 'manualSync',  
            'recovery_warn_threshold_minutes': 'recoveryWarnThresholdMinutes',  
            'repo_utilization_warn_threshold': 'repoUtilizationWarnThreshold',  
            'interface_type': 'interfaceType',  
            'sync_warn_threshold_minutes': 'syncWarnThresholdMinutes'
        }

        self._name = None
        self._secondary_array_id = None
        self._sync_interval_minutes = None
        self._manual_sync = None
        self._recovery_warn_threshold_minutes = None
        self._repo_utilization_warn_threshold = None
        self._interface_type = None
        self._sync_warn_threshold_minutes = None

    @property
    def name(self):
        """
        Gets the name of this AsyncMirrorGroupCreateRequest.
        The user-label to assign to the new async mirror group.

        :return: The name of this AsyncMirrorGroupCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this AsyncMirrorGroupCreateRequest.
        The user-label to assign to the new async mirror group.

        :param name: The name of this AsyncMirrorGroupCreateRequest.
        :type: str
        """
        self._name = name

    @property
    def secondary_array_id(self):
        """
        Gets the secondary_array_id of this AsyncMirrorGroupCreateRequest.
        The id of the secondary array.

        :return: The secondary_array_id of this AsyncMirrorGroupCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._secondary_array_id

    @secondary_array_id.setter
    def secondary_array_id(self, secondary_array_id):
        """
        Sets the secondary_array_id of this AsyncMirrorGroupCreateRequest.
        The id of the secondary array.

        :param secondary_array_id: The secondary_array_id of this AsyncMirrorGroupCreateRequest.
        :type: str
        """
        self._secondary_array_id = secondary_array_id

    @property
    def sync_interval_minutes(self):
        """
        Gets the sync_interval_minutes of this AsyncMirrorGroupCreateRequest.
        Sync interval in (minutes)

        :return: The sync_interval_minutes of this AsyncMirrorGroupCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._sync_interval_minutes

    @sync_interval_minutes.setter
    def sync_interval_minutes(self, sync_interval_minutes):
        """
        Sets the sync_interval_minutes of this AsyncMirrorGroupCreateRequest.
        Sync interval in (minutes)

        :param sync_interval_minutes: The sync_interval_minutes of this AsyncMirrorGroupCreateRequest.
        :type: int
        """
        self._sync_interval_minutes = sync_interval_minutes

    @property
    def manual_sync(self):
        """
        Gets the manual_sync of this AsyncMirrorGroupCreateRequest.
        Set the synchronization method to manual, causing other synchronization values to be ignored.

        :return: The manual_sync of this AsyncMirrorGroupCreateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._manual_sync

    @manual_sync.setter
    def manual_sync(self, manual_sync):
        """
        Sets the manual_sync of this AsyncMirrorGroupCreateRequest.
        Set the synchronization method to manual, causing other synchronization values to be ignored.

        :param manual_sync: The manual_sync of this AsyncMirrorGroupCreateRequest.
        :type: bool
        """
        self._manual_sync = manual_sync

    @property
    def recovery_warn_threshold_minutes(self):
        """
        Gets the recovery_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        Recovery point warning threshold (minutes). The user will be warned when the age of the last good failures point exceeds this value

        :return: The recovery_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._recovery_warn_threshold_minutes

    @recovery_warn_threshold_minutes.setter
    def recovery_warn_threshold_minutes(self, recovery_warn_threshold_minutes):
        """
        Sets the recovery_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        Recovery point warning threshold (minutes). The user will be warned when the age of the last good failures point exceeds this value

        :param recovery_warn_threshold_minutes: The recovery_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        :type: int
        """
        self._recovery_warn_threshold_minutes = recovery_warn_threshold_minutes

    @property
    def repo_utilization_warn_threshold(self):
        """
        Gets the repo_utilization_warn_threshold of this AsyncMirrorGroupCreateRequest.
        Recovery point warning threshold (percentage)

        :return: The repo_utilization_warn_threshold of this AsyncMirrorGroupCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._repo_utilization_warn_threshold

    @repo_utilization_warn_threshold.setter
    def repo_utilization_warn_threshold(self, repo_utilization_warn_threshold):
        """
        Sets the repo_utilization_warn_threshold of this AsyncMirrorGroupCreateRequest.
        Recovery point warning threshold (percentage)

        :param repo_utilization_warn_threshold: The repo_utilization_warn_threshold of this AsyncMirrorGroupCreateRequest.
        :type: int
        """
        self._repo_utilization_warn_threshold = repo_utilization_warn_threshold

    @property
    def interface_type(self):
        """
        Gets the interface_type of this AsyncMirrorGroupCreateRequest.
        The intended protocol to use if both Fibre and iSCSI are available.

        :return: The interface_type of this AsyncMirrorGroupCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._interface_type

    @interface_type.setter
    def interface_type(self, interface_type):
        """
        Sets the interface_type of this AsyncMirrorGroupCreateRequest.
        The intended protocol to use if both Fibre and iSCSI are available.

        :param interface_type: The interface_type of this AsyncMirrorGroupCreateRequest.
        :type: str
        """
        allowed_values = ["fibre", "iscsi"]
        if interface_type not in allowed_values:
            raise ValueError(
                "Invalid value for `interface_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._interface_type = interface_type

    @property
    def sync_warn_threshold_minutes(self):
        """
        Gets the sync_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        The threshold (in minutes) for notifying the user that periodic synchronization has taken too long to complete.

        :return: The sync_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._sync_warn_threshold_minutes

    @sync_warn_threshold_minutes.setter
    def sync_warn_threshold_minutes(self, sync_warn_threshold_minutes):
        """
        Sets the sync_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        The threshold (in minutes) for notifying the user that periodic synchronization has taken too long to complete.

        :param sync_warn_threshold_minutes: The sync_warn_threshold_minutes of this AsyncMirrorGroupCreateRequest.
        :type: int
        """
        self._sync_warn_threshold_minutes = sync_warn_threshold_minutes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

