# coding: utf-8

"""
CapabilitiesResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class CapabilitiesResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CapabilitiesResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'feature_bundle': 'FeatureBundle',  # (required parameter)
            'capabilities': 'list[str]',  # (required parameter)
            'product_capabilities': 'list[str]',  # (required parameter)
            'feature_states': 'list[FeatureState]',  # (required parameter)
            'feature_parameters': 'FeatureParams'
        }

        self.attribute_map = {
            'feature_bundle': 'featureBundle',  # (required parameter)
            'capabilities': 'capabilities',  # (required parameter)
            'product_capabilities': 'productCapabilities',  # (required parameter)
            'feature_states': 'featureStates',  # (required parameter)
            'feature_parameters': 'featureParameters'
        }

        self._feature_bundle = None
        self._capabilities = None
        self._product_capabilities = None
        self._feature_states = None
        self._feature_parameters = None

    @property
    def feature_bundle(self):
        """
        Gets the feature_bundle of this CapabilitiesResponse.


        :return: The feature_bundle of this CapabilitiesResponse.
        :rtype: FeatureBundle
        :required/optional: required
        """
        return self._feature_bundle

    @feature_bundle.setter
    def feature_bundle(self, feature_bundle):
        """
        Sets the feature_bundle of this CapabilitiesResponse.


        :param feature_bundle: The feature_bundle of this CapabilitiesResponse.
        :type: FeatureBundle
        """
        self._feature_bundle = feature_bundle

    @property
    def capabilities(self):
        """
        Gets the capabilities of this CapabilitiesResponse.


        :return: The capabilities of this CapabilitiesResponse.
        :rtype: list[str]
        :required/optional: required
        """
        return self._capabilities

    @capabilities.setter
    def capabilities(self, capabilities):
        """
        Sets the capabilities of this CapabilitiesResponse.


        :param capabilities: The capabilities of this CapabilitiesResponse.
        :type: list[str]
        """
        self._capabilities = capabilities

    @property
    def product_capabilities(self):
        """
        Gets the product_capabilities of this CapabilitiesResponse.


        :return: The product_capabilities of this CapabilitiesResponse.
        :rtype: list[str]
        :required/optional: required
        """
        return self._product_capabilities

    @product_capabilities.setter
    def product_capabilities(self, product_capabilities):
        """
        Sets the product_capabilities of this CapabilitiesResponse.


        :param product_capabilities: The product_capabilities of this CapabilitiesResponse.
        :type: list[str]
        """
        self._product_capabilities = product_capabilities

    @property
    def feature_states(self):
        """
        Gets the feature_states of this CapabilitiesResponse.


        :return: The feature_states of this CapabilitiesResponse.
        :rtype: list[FeatureState]
        :required/optional: required
        """
        return self._feature_states

    @feature_states.setter
    def feature_states(self, feature_states):
        """
        Sets the feature_states of this CapabilitiesResponse.


        :param feature_states: The feature_states of this CapabilitiesResponse.
        :type: list[FeatureState]
        """
        self._feature_states = feature_states

    @property
    def feature_parameters(self):
        """
        Gets the feature_parameters of this CapabilitiesResponse.


        :return: The feature_parameters of this CapabilitiesResponse.
        :rtype: FeatureParams
        :required/optional: required
        """
        return self._feature_parameters

    @feature_parameters.setter
    def feature_parameters(self, feature_parameters):
        """
        Sets the feature_parameters of this CapabilitiesResponse.


        :param feature_parameters: The feature_parameters of this CapabilitiesResponse.
        :type: FeatureParams
        """
        self._feature_parameters = feature_parameters

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

