# coding: utf-8

"""
DeviceAsupResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DeviceAsupResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DeviceAsupResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'asup_capable': 'bool',  # (required parameter)
            'on_demand_capable': 'bool',  # (required parameter)
            'asup_enabled': 'bool',  # (required parameter)
            'on_demand_enabled': 'bool',  # (required parameter)
            'remote_diags_enabled': 'bool',  # (required parameter)
            'delivery': 'DeviceAsupDelivery',  # (required parameter)
            'destination_address': 'str',  # (required parameter)
            'schedule': 'DeviceAsupSchedule'
        }

        self.attribute_map = {
            'asup_capable': 'asupCapable',  # (required parameter)
            'on_demand_capable': 'onDemandCapable',  # (required parameter)
            'asup_enabled': 'asupEnabled',  # (required parameter)
            'on_demand_enabled': 'onDemandEnabled',  # (required parameter)
            'remote_diags_enabled': 'remoteDiagsEnabled',  # (required parameter)
            'delivery': 'delivery',  # (required parameter)
            'destination_address': 'destinationAddress',  # (required parameter)
            'schedule': 'schedule'
        }

        self._asup_capable = None
        self._on_demand_capable = None
        self._asup_enabled = None
        self._on_demand_enabled = None
        self._remote_diags_enabled = None
        self._delivery = None
        self._destination_address = None
        self._schedule = None

    @property
    def asup_capable(self):
        """
        Gets the asup_capable of this DeviceAsupResponse.
        AutoSupport is supported

        :return: The asup_capable of this DeviceAsupResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._asup_capable

    @asup_capable.setter
    def asup_capable(self, asup_capable):
        """
        Sets the asup_capable of this DeviceAsupResponse.
        AutoSupport is supported

        :param asup_capable: The asup_capable of this DeviceAsupResponse.
        :type: bool
        """
        self._asup_capable = asup_capable

    @property
    def on_demand_capable(self):
        """
        Gets the on_demand_capable of this DeviceAsupResponse.
        AutoSupport OnDemand is supported

        :return: The on_demand_capable of this DeviceAsupResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._on_demand_capable

    @on_demand_capable.setter
    def on_demand_capable(self, on_demand_capable):
        """
        Sets the on_demand_capable of this DeviceAsupResponse.
        AutoSupport OnDemand is supported

        :param on_demand_capable: The on_demand_capable of this DeviceAsupResponse.
        :type: bool
        """
        self._on_demand_capable = on_demand_capable

    @property
    def asup_enabled(self):
        """
        Gets the asup_enabled of this DeviceAsupResponse.
        AutoSupport is enabled or disabled

        :return: The asup_enabled of this DeviceAsupResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._asup_enabled

    @asup_enabled.setter
    def asup_enabled(self, asup_enabled):
        """
        Sets the asup_enabled of this DeviceAsupResponse.
        AutoSupport is enabled or disabled

        :param asup_enabled: The asup_enabled of this DeviceAsupResponse.
        :type: bool
        """
        self._asup_enabled = asup_enabled

    @property
    def on_demand_enabled(self):
        """
        Gets the on_demand_enabled of this DeviceAsupResponse.
        ASUP OnDemand is enabled or disabled

        :return: The on_demand_enabled of this DeviceAsupResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._on_demand_enabled

    @on_demand_enabled.setter
    def on_demand_enabled(self, on_demand_enabled):
        """
        Sets the on_demand_enabled of this DeviceAsupResponse.
        ASUP OnDemand is enabled or disabled

        :param on_demand_enabled: The on_demand_enabled of this DeviceAsupResponse.
        :type: bool
        """
        self._on_demand_enabled = on_demand_enabled

    @property
    def remote_diags_enabled(self):
        """
        Gets the remote_diags_enabled of this DeviceAsupResponse.
        ASUP RemoteDiags is enabled or disabled

        :return: The remote_diags_enabled of this DeviceAsupResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._remote_diags_enabled

    @remote_diags_enabled.setter
    def remote_diags_enabled(self, remote_diags_enabled):
        """
        Sets the remote_diags_enabled of this DeviceAsupResponse.
        ASUP RemoteDiags is enabled or disabled

        :param remote_diags_enabled: The remote_diags_enabled of this DeviceAsupResponse.
        :type: bool
        """
        self._remote_diags_enabled = remote_diags_enabled

    @property
    def delivery(self):
        """
        Gets the delivery of this DeviceAsupResponse.
        ASUP delivery configuration

        :return: The delivery of this DeviceAsupResponse.
        :rtype: DeviceAsupDelivery
        :required/optional: required
        """
        return self._delivery

    @delivery.setter
    def delivery(self, delivery):
        """
        Sets the delivery of this DeviceAsupResponse.
        ASUP delivery configuration

        :param delivery: The delivery of this DeviceAsupResponse.
        :type: DeviceAsupDelivery
        """
        self._delivery = delivery

    @property
    def destination_address(self):
        """
        Gets the destination_address of this DeviceAsupResponse.
        ASUP destination address

        :return: The destination_address of this DeviceAsupResponse.
        :rtype: str
        :required/optional: required
        """
        return self._destination_address

    @destination_address.setter
    def destination_address(self, destination_address):
        """
        Sets the destination_address of this DeviceAsupResponse.
        ASUP destination address

        :param destination_address: The destination_address of this DeviceAsupResponse.
        :type: str
        """
        self._destination_address = destination_address

    @property
    def schedule(self):
        """
        Gets the schedule of this DeviceAsupResponse.
        ASUP schedule configuration

        :return: The schedule of this DeviceAsupResponse.
        :rtype: DeviceAsupSchedule
        :required/optional: required
        """
        return self._schedule

    @schedule.setter
    def schedule(self, schedule):
        """
        Sets the schedule of this DeviceAsupResponse.
        ASUP schedule configuration

        :param schedule: The schedule of this DeviceAsupResponse.
        :type: DeviceAsupSchedule
        """
        self._schedule = schedule

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

