# coding: utf-8

"""
DeviceAsupSchedule.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DeviceAsupSchedule(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DeviceAsupSchedule - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'daily_min_time': 'int',  # (required parameter)
            'daily_max_time': 'int',  # (required parameter)
            'weekly_min_time': 'int',  # (required parameter)
            'weekly_max_time': 'int',  # (required parameter)
            'days_of_week': 'list[str]'
        }

        self.attribute_map = {
            'daily_min_time': 'dailyMinTime',  # (required parameter)
            'daily_max_time': 'dailyMaxTime',  # (required parameter)
            'weekly_min_time': 'weeklyMinTime',  # (required parameter)
            'weekly_max_time': 'weeklyMaxTime',  # (required parameter)
            'days_of_week': 'daysOfWeek'
        }

        self._daily_min_time = None
        self._daily_max_time = None
        self._weekly_min_time = None
        self._weekly_max_time = None
        self._days_of_week = None

    @property
    def daily_min_time(self):
        """
        Gets the daily_min_time of this DeviceAsupSchedule.
        ASUP daily minimum time

        :return: The daily_min_time of this DeviceAsupSchedule.
        :rtype: int
        :required/optional: required
        """
        return self._daily_min_time

    @daily_min_time.setter
    def daily_min_time(self, daily_min_time):
        """
        Sets the daily_min_time of this DeviceAsupSchedule.
        ASUP daily minimum time

        :param daily_min_time: The daily_min_time of this DeviceAsupSchedule.
        :type: int
        """
        self._daily_min_time = daily_min_time

    @property
    def daily_max_time(self):
        """
        Gets the daily_max_time of this DeviceAsupSchedule.
        ASUP daily maximum time

        :return: The daily_max_time of this DeviceAsupSchedule.
        :rtype: int
        :required/optional: required
        """
        return self._daily_max_time

    @daily_max_time.setter
    def daily_max_time(self, daily_max_time):
        """
        Sets the daily_max_time of this DeviceAsupSchedule.
        ASUP daily maximum time

        :param daily_max_time: The daily_max_time of this DeviceAsupSchedule.
        :type: int
        """
        self._daily_max_time = daily_max_time

    @property
    def weekly_min_time(self):
        """
        Gets the weekly_min_time of this DeviceAsupSchedule.
        ASUP weekly minimum time

        :return: The weekly_min_time of this DeviceAsupSchedule.
        :rtype: int
        :required/optional: required
        """
        return self._weekly_min_time

    @weekly_min_time.setter
    def weekly_min_time(self, weekly_min_time):
        """
        Sets the weekly_min_time of this DeviceAsupSchedule.
        ASUP weekly minimum time

        :param weekly_min_time: The weekly_min_time of this DeviceAsupSchedule.
        :type: int
        """
        self._weekly_min_time = weekly_min_time

    @property
    def weekly_max_time(self):
        """
        Gets the weekly_max_time of this DeviceAsupSchedule.
        ASUP weekly maximum time

        :return: The weekly_max_time of this DeviceAsupSchedule.
        :rtype: int
        :required/optional: required
        """
        return self._weekly_max_time

    @weekly_max_time.setter
    def weekly_max_time(self, weekly_max_time):
        """
        Sets the weekly_max_time of this DeviceAsupSchedule.
        ASUP weekly maximum time

        :param weekly_max_time: The weekly_max_time of this DeviceAsupSchedule.
        :type: int
        """
        self._weekly_max_time = weekly_max_time

    @property
    def days_of_week(self):
        """
        Gets the days_of_week of this DeviceAsupSchedule.
        ASUP days of week

        :return: The days_of_week of this DeviceAsupSchedule.
        :rtype: list[str]
        :required/optional: required
        """
        return self._days_of_week

    @days_of_week.setter
    def days_of_week(self, days_of_week):
        """
        Sets the days_of_week of this DeviceAsupSchedule.
        ASUP days of week

        :param days_of_week: The days_of_week of this DeviceAsupSchedule.
        :type: list[str]
        """
        self._days_of_week = days_of_week

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

