# coding: utf-8

"""
DriveFirmwareCompatiblitySet.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class DriveFirmwareCompatiblitySet(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        DriveFirmwareCompatiblitySet - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'filename': 'str',  # (required parameter)
            'firmware_version': 'str',  # (required parameter)
            'supported_firmware_versions': 'list[str]',  # (required parameter)
            'compatible_drives': 'list[DriveFirmwareCompatabilityEntry]'
        }

        self.attribute_map = {
            'filename': 'filename',  # (required parameter)
            'firmware_version': 'firmwareVersion',  # (required parameter)
            'supported_firmware_versions': 'supportedFirmwareVersions',  # (required parameter)
            'compatible_drives': 'compatibleDrives'
        }

        self._filename = None
        self._firmware_version = None
        self._supported_firmware_versions = None
        self._compatible_drives = None

    @property
    def filename(self):
        """
        Gets the filename of this DriveFirmwareCompatiblitySet.


        :return: The filename of this DriveFirmwareCompatiblitySet.
        :rtype: str
        :required/optional: required
        """
        return self._filename

    @filename.setter
    def filename(self, filename):
        """
        Sets the filename of this DriveFirmwareCompatiblitySet.


        :param filename: The filename of this DriveFirmwareCompatiblitySet.
        :type: str
        """
        self._filename = filename

    @property
    def firmware_version(self):
        """
        Gets the firmware_version of this DriveFirmwareCompatiblitySet.
        The version of firmware in file

        :return: The firmware_version of this DriveFirmwareCompatiblitySet.
        :rtype: str
        :required/optional: required
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """
        Sets the firmware_version of this DriveFirmwareCompatiblitySet.
        The version of firmware in file

        :param firmware_version: The firmware_version of this DriveFirmwareCompatiblitySet.
        :type: str
        """
        self._firmware_version = firmware_version

    @property
    def supported_firmware_versions(self):
        """
        Gets the supported_firmware_versions of this DriveFirmwareCompatiblitySet.
        Drive firmware versions supported by firmware file

        :return: The supported_firmware_versions of this DriveFirmwareCompatiblitySet.
        :rtype: list[str]
        :required/optional: required
        """
        return self._supported_firmware_versions

    @supported_firmware_versions.setter
    def supported_firmware_versions(self, supported_firmware_versions):
        """
        Sets the supported_firmware_versions of this DriveFirmwareCompatiblitySet.
        Drive firmware versions supported by firmware file

        :param supported_firmware_versions: The supported_firmware_versions of this DriveFirmwareCompatiblitySet.
        :type: list[str]
        """
        self._supported_firmware_versions = supported_firmware_versions

    @property
    def compatible_drives(self):
        """
        Gets the compatible_drives of this DriveFirmwareCompatiblitySet.
        List of drives that are compatible with firmware file

        :return: The compatible_drives of this DriveFirmwareCompatiblitySet.
        :rtype: list[DriveFirmwareCompatabilityEntry]
        :required/optional: required
        """
        return self._compatible_drives

    @compatible_drives.setter
    def compatible_drives(self, compatible_drives):
        """
        Sets the compatible_drives of this DriveFirmwareCompatiblitySet.
        List of drives that are compatible with firmware file

        :param compatible_drives: The compatible_drives of this DriveFirmwareCompatiblitySet.
        :type: list[DriveFirmwareCompatabilityEntry]
        """
        self._compatible_drives = compatible_drives

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

