# coding: utf-8

"""
EmbeddedCompatibilityCheckResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class EmbeddedCompatibilityCheckResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        EmbeddedCompatibilityCheckResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'file_compatible': 'bool',  # (required parameter)
            'version_contents': 'list[VersionContent]'
        }

        self.attribute_map = {
            'file_compatible': 'fileCompatible',  # (required parameter)
            'version_contents': 'versionContents'
        }

        self._file_compatible = None
        self._version_contents = None

    @property
    def file_compatible(self):
        """
        Gets the file_compatible of this EmbeddedCompatibilityCheckResponse.
        If the file is compatible

        :return: The file_compatible of this EmbeddedCompatibilityCheckResponse.
        :rtype: bool
        :required/optional: required
        """
        return self._file_compatible

    @file_compatible.setter
    def file_compatible(self, file_compatible):
        """
        Sets the file_compatible of this EmbeddedCompatibilityCheckResponse.
        If the file is compatible

        :param file_compatible: The file_compatible of this EmbeddedCompatibilityCheckResponse.
        :type: bool
        """
        self._file_compatible = file_compatible

    @property
    def version_contents(self):
        """
        Gets the version_contents of this EmbeddedCompatibilityCheckResponse.
        Enumerates all the versions on the bundle/nvsram file and what is on the controller

        :return: The version_contents of this EmbeddedCompatibilityCheckResponse.
        :rtype: list[VersionContent]
        :required/optional: required
        """
        return self._version_contents

    @version_contents.setter
    def version_contents(self, version_contents):
        """
        Sets the version_contents of this EmbeddedCompatibilityCheckResponse.
        Enumerates all the versions on the bundle/nvsram file and what is on the controller

        :param version_contents: The version_contents of this EmbeddedCompatibilityCheckResponse.
        :type: list[VersionContent]
        """
        self._version_contents = version_contents

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

