# coding: utf-8

"""
Folder.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Folder(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Folder - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'folder_id': 'str',  # (required parameter)
            'parent_folder_id': 'str',  # (required parameter)
            'name': 'str',  # (required parameter)
            'reserved': 'bool',  # (required parameter)
            'rules': 'list[Rule]',  # (required parameter)
            'storage_system_ids': 'list[str]'
        }

        self.attribute_map = {
            'folder_id': 'folderId',  # (required parameter)
            'parent_folder_id': 'parentFolderId',  # (required parameter)
            'name': 'name',  # (required parameter)
            'reserved': 'reserved',  # (required parameter)
            'rules': 'rules',  # (required parameter)
            'storage_system_ids': 'storageSystemIds'
        }

        self._folder_id = None
        self._parent_folder_id = None
        self._name = None
        self._reserved = None
        self._rules = None
        self._storage_system_ids = None

    @property
    def folder_id(self):
        """
        Gets the folder_id of this Folder.


        :return: The folder_id of this Folder.
        :rtype: str
        :required/optional: required
        """
        return self._folder_id

    @folder_id.setter
    def folder_id(self, folder_id):
        """
        Sets the folder_id of this Folder.


        :param folder_id: The folder_id of this Folder.
        :type: str
        """
        self._folder_id = folder_id

    @property
    def parent_folder_id(self):
        """
        Gets the parent_folder_id of this Folder.


        :return: The parent_folder_id of this Folder.
        :rtype: str
        :required/optional: required
        """
        return self._parent_folder_id

    @parent_folder_id.setter
    def parent_folder_id(self, parent_folder_id):
        """
        Sets the parent_folder_id of this Folder.


        :param parent_folder_id: The parent_folder_id of this Folder.
        :type: str
        """
        self._parent_folder_id = parent_folder_id

    @property
    def name(self):
        """
        Gets the name of this Folder.


        :return: The name of this Folder.
        :rtype: str
        :required/optional: required
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Folder.


        :param name: The name of this Folder.
        :type: str
        """
        self._name = name

    @property
    def reserved(self):
        """
        Gets the reserved of this Folder.


        :return: The reserved of this Folder.
        :rtype: bool
        :required/optional: required
        """
        return self._reserved

    @reserved.setter
    def reserved(self, reserved):
        """
        Sets the reserved of this Folder.


        :param reserved: The reserved of this Folder.
        :type: bool
        """
        self._reserved = reserved

    @property
    def rules(self):
        """
        Gets the rules of this Folder.
        Rules for dynamic folders

        :return: The rules of this Folder.
        :rtype: list[Rule]
        :required/optional: required
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """
        Sets the rules of this Folder.
        Rules for dynamic folders

        :param rules: The rules of this Folder.
        :type: list[Rule]
        """
        self._rules = rules

    @property
    def storage_system_ids(self):
        """
        Gets the storage_system_ids of this Folder.
        List of arrays for non-dynamic folders

        :return: The storage_system_ids of this Folder.
        :rtype: list[str]
        :required/optional: required
        """
        return self._storage_system_ids

    @storage_system_ids.setter
    def storage_system_ids(self, storage_system_ids):
        """
        Sets the storage_system_ids of this Folder.
        List of arrays for non-dynamic folders

        :param storage_system_ids: The storage_system_ids of this Folder.
        :type: list[str]
        """
        self._storage_system_ids = storage_system_ids

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

