# coding: utf-8

"""
FolderCreateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class FolderCreateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        FolderCreateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'parent_id': 'str',  
            'name': 'str',  # (required parameter)
            'rules': 'list[Rule]',  
            'storage_system_ids': 'list[str]'
        }

        self.attribute_map = {
            'parent_id': 'parentId',  
            'name': 'name',  # (required parameter)
            'rules': 'rules',  
            'storage_system_ids': 'storageSystemIds'
        }

        self._parent_id = None
        self._name = None
        self._rules = None
        self._storage_system_ids = None

    @property
    def parent_id(self):
        """
        Gets the parent_id of this FolderCreateRequest.
        Optional Parent folder Id for nested folders.

        :return: The parent_id of this FolderCreateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._parent_id

    @parent_id.setter
    def parent_id(self, parent_id):
        """
        Sets the parent_id of this FolderCreateRequest.
        Optional Parent folder Id for nested folders.

        :param parent_id: The parent_id of this FolderCreateRequest.
        :type: str
        """
        self._parent_id = parent_id

    @property
    def name(self):
        """
        Gets the name of this FolderCreateRequest.
        Name of the folder

        :return: The name of this FolderCreateRequest.
        :rtype: str
        :required/optional: required
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this FolderCreateRequest.
        Name of the folder

        :param name: The name of this FolderCreateRequest.
        :type: str
        """
        self._name = name

    @property
    def rules(self):
        """
        Gets the rules of this FolderCreateRequest.
        Optional List of rules used to define the folder.  These rules are ANDed together      Usually either rules OR a list of Ids are supplied.

        :return: The rules of this FolderCreateRequest.
        :rtype: list[Rule]
        :required/optional: optional
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """
        Sets the rules of this FolderCreateRequest.
        Optional List of rules used to define the folder.  These rules are ANDed together      Usually either rules OR a list of Ids are supplied.

        :param rules: The rules of this FolderCreateRequest.
        :type: list[Rule]
        """
        self._rules = rules

    @property
    def storage_system_ids(self):
        """
        Gets the storage_system_ids of this FolderCreateRequest.
        Optional list of storage system to include in the folder.  Usually either rules OR a list of Ids are supplied.

        :return: The storage_system_ids of this FolderCreateRequest.
        :rtype: list[str]
        :required/optional: optional
        """
        return self._storage_system_ids

    @storage_system_ids.setter
    def storage_system_ids(self, storage_system_ids):
        """
        Sets the storage_system_ids of this FolderCreateRequest.
        Optional list of storage system to include in the folder.  Usually either rules OR a list of Ids are supplied.

        :param storage_system_ids: The storage_system_ids of this FolderCreateRequest.
        :type: list[str]
        """
        self._storage_system_ids = storage_system_ids

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

