# coding: utf-8

"""
HistoricalStatsResponse.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HistoricalStatsResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HistoricalStatsResponse - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'volume_stats': 'list[AnalysedVolumeStatistics]',  # (required parameter)
            'controller_stats': 'list[AnalysedControllerStatistics]',  # (required parameter)
            'system_stats': 'list[AnalysedStorageSystemStatistics]',  # (required parameter)
            'interface_stats': 'list[AnalyzedInterfaceStatistics]',  # (required parameter)
            'disk_stats': 'list[AnalysedDiskStatistics]',  # (required parameter)
            'pool_stats': 'list[AnalyzedPoolStatistics]',  # (required parameter)
            'workload_stats': 'list[AnalyzedWorkloadStatistics]',  # (required parameter)
            'application_stats': 'list[AnalyzedApplicationStatistics]',  # (required parameter)
            'volumes': 'list[AnalysedVolumeStatistics]'
        }

        self.attribute_map = {
            'volume_stats': 'volumeStats',  # (required parameter)
            'controller_stats': 'controllerStats',  # (required parameter)
            'system_stats': 'systemStats',  # (required parameter)
            'interface_stats': 'interfaceStats',  # (required parameter)
            'disk_stats': 'diskStats',  # (required parameter)
            'pool_stats': 'poolStats',  # (required parameter)
            'workload_stats': 'workloadStats',  # (required parameter)
            'application_stats': 'applicationStats',  # (required parameter)
            'volumes': 'volumes'
        }

        self._volume_stats = None
        self._controller_stats = None
        self._system_stats = None
        self._interface_stats = None
        self._disk_stats = None
        self._pool_stats = None
        self._workload_stats = None
        self._application_stats = None
        self._volumes = None

    @property
    def volume_stats(self):
        """
        Gets the volume_stats of this HistoricalStatsResponse.


        :return: The volume_stats of this HistoricalStatsResponse.
        :rtype: list[AnalysedVolumeStatistics]
        :required/optional: required
        """
        return self._volume_stats

    @volume_stats.setter
    def volume_stats(self, volume_stats):
        """
        Sets the volume_stats of this HistoricalStatsResponse.


        :param volume_stats: The volume_stats of this HistoricalStatsResponse.
        :type: list[AnalysedVolumeStatistics]
        """
        self._volume_stats = volume_stats

    @property
    def controller_stats(self):
        """
        Gets the controller_stats of this HistoricalStatsResponse.


        :return: The controller_stats of this HistoricalStatsResponse.
        :rtype: list[AnalysedControllerStatistics]
        :required/optional: required
        """
        return self._controller_stats

    @controller_stats.setter
    def controller_stats(self, controller_stats):
        """
        Sets the controller_stats of this HistoricalStatsResponse.


        :param controller_stats: The controller_stats of this HistoricalStatsResponse.
        :type: list[AnalysedControllerStatistics]
        """
        self._controller_stats = controller_stats

    @property
    def system_stats(self):
        """
        Gets the system_stats of this HistoricalStatsResponse.


        :return: The system_stats of this HistoricalStatsResponse.
        :rtype: list[AnalysedStorageSystemStatistics]
        :required/optional: required
        """
        return self._system_stats

    @system_stats.setter
    def system_stats(self, system_stats):
        """
        Sets the system_stats of this HistoricalStatsResponse.


        :param system_stats: The system_stats of this HistoricalStatsResponse.
        :type: list[AnalysedStorageSystemStatistics]
        """
        self._system_stats = system_stats

    @property
    def interface_stats(self):
        """
        Gets the interface_stats of this HistoricalStatsResponse.


        :return: The interface_stats of this HistoricalStatsResponse.
        :rtype: list[AnalyzedInterfaceStatistics]
        :required/optional: required
        """
        return self._interface_stats

    @interface_stats.setter
    def interface_stats(self, interface_stats):
        """
        Sets the interface_stats of this HistoricalStatsResponse.


        :param interface_stats: The interface_stats of this HistoricalStatsResponse.
        :type: list[AnalyzedInterfaceStatistics]
        """
        self._interface_stats = interface_stats

    @property
    def disk_stats(self):
        """
        Gets the disk_stats of this HistoricalStatsResponse.


        :return: The disk_stats of this HistoricalStatsResponse.
        :rtype: list[AnalysedDiskStatistics]
        :required/optional: required
        """
        return self._disk_stats

    @disk_stats.setter
    def disk_stats(self, disk_stats):
        """
        Sets the disk_stats of this HistoricalStatsResponse.


        :param disk_stats: The disk_stats of this HistoricalStatsResponse.
        :type: list[AnalysedDiskStatistics]
        """
        self._disk_stats = disk_stats

    @property
    def pool_stats(self):
        """
        Gets the pool_stats of this HistoricalStatsResponse.


        :return: The pool_stats of this HistoricalStatsResponse.
        :rtype: list[AnalyzedPoolStatistics]
        :required/optional: required
        """
        return self._pool_stats

    @pool_stats.setter
    def pool_stats(self, pool_stats):
        """
        Sets the pool_stats of this HistoricalStatsResponse.


        :param pool_stats: The pool_stats of this HistoricalStatsResponse.
        :type: list[AnalyzedPoolStatistics]
        """
        self._pool_stats = pool_stats

    @property
    def workload_stats(self):
        """
        Gets the workload_stats of this HistoricalStatsResponse.


        :return: The workload_stats of this HistoricalStatsResponse.
        :rtype: list[AnalyzedWorkloadStatistics]
        :required/optional: required
        """
        return self._workload_stats

    @workload_stats.setter
    def workload_stats(self, workload_stats):
        """
        Sets the workload_stats of this HistoricalStatsResponse.


        :param workload_stats: The workload_stats of this HistoricalStatsResponse.
        :type: list[AnalyzedWorkloadStatistics]
        """
        self._workload_stats = workload_stats

    @property
    def application_stats(self):
        """
        Gets the application_stats of this HistoricalStatsResponse.


        :return: The application_stats of this HistoricalStatsResponse.
        :rtype: list[AnalyzedApplicationStatistics]
        :required/optional: required
        """
        return self._application_stats

    @application_stats.setter
    def application_stats(self, application_stats):
        """
        Sets the application_stats of this HistoricalStatsResponse.


        :param application_stats: The application_stats of this HistoricalStatsResponse.
        :type: list[AnalyzedApplicationStatistics]
        """
        self._application_stats = application_stats

    @property
    def volumes(self):
        """
        Gets the volumes of this HistoricalStatsResponse.


        :return: The volumes of this HistoricalStatsResponse.
        :rtype: list[AnalysedVolumeStatistics]
        :required/optional: optional
        """
        return self._volumes

    @volumes.setter
    def volumes(self, volumes):
        """
        Sets the volumes of this HistoricalStatsResponse.


        :param volumes: The volumes of this HistoricalStatsResponse.
        :type: list[AnalysedVolumeStatistics]
        """
        self._volumes = volumes

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

