# coding: utf-8

"""
HostType.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class HostType(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        HostType - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',  
            'index': 'int',  # (required parameter)
            'code': 'str',  
            'used': 'bool',  
            'default': 'bool'
        }

        self.attribute_map = {
            'name': 'name',  
            'index': 'index',  # (required parameter)
            'code': 'code',  
            'used': 'used',  
            'default': 'default'
        }

        self._name = None
        self._index = None
        self._code = None
        self._used = None
        self._default = None

    @property
    def name(self):
        """
        Gets the name of this HostType.


        :return: The name of this HostType.
        :rtype: str
        :required/optional: optional
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this HostType.


        :param name: The name of this HostType.
        :type: str
        """
        self._name = name

    @property
    def index(self):
        """
        Gets the index of this HostType.


        :return: The index of this HostType.
        :rtype: int
        :required/optional: required
        """
        return self._index

    @index.setter
    def index(self, index):
        """
        Sets the index of this HostType.


        :param index: The index of this HostType.
        :type: int
        """
        self._index = index

    @property
    def code(self):
        """
        Gets the code of this HostType.


        :return: The code of this HostType.
        :rtype: str
        :required/optional: optional
        """
        return self._code

    @code.setter
    def code(self, code):
        """
        Sets the code of this HostType.


        :param code: The code of this HostType.
        :type: str
        """
        self._code = code

    @property
    def used(self):
        """
        Gets the used of this HostType.


        :return: The used of this HostType.
        :rtype: bool
        :required/optional: optional
        """
        return self._used

    @used.setter
    def used(self, used):
        """
        Sets the used of this HostType.


        :param used: The used of this HostType.
        :type: bool
        """
        self._used = used

    @property
    def default(self):
        """
        Gets the default of this HostType.


        :return: The default of this HostType.
        :rtype: bool
        :required/optional: optional
        """
        return self._default

    @default.setter
    def default(self, default):
        """
        Sets the default of this HostType.


        :param default: The default of this HostType.
        :type: bool
        """
        self._default = default

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

