# coding: utf-8

"""
LocalizedLogMessage.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class LocalizedLogMessage(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        LocalizedLogMessage - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'logger_type': 'str',  # (required parameter)
            'timestamp': 'datetime',  # (required parameter)
            'message_text': 'str',  
            'context': 'str',  # (required parameter)
            'record_id': 'int'
        }

        self.attribute_map = {
            'logger_type': 'loggerType',  # (required parameter)
            'timestamp': 'timestamp',  # (required parameter)
            'message_text': 'messageText',  
            'context': 'context',  # (required parameter)
            'record_id': 'recordId'
        }

        self._logger_type = None
        self._timestamp = None
        self._message_text = None
        self._context = None
        self._record_id = None

    @property
    def logger_type(self):
        """
        Gets the logger_type of this LocalizedLogMessage.
        Logger type of this message

        :return: The logger_type of this LocalizedLogMessage.
        :rtype: str
        :required/optional: required
        """
        return self._logger_type

    @logger_type.setter
    def logger_type(self, logger_type):
        """
        Sets the logger_type of this LocalizedLogMessage.
        Logger type of this message

        :param logger_type: The logger_type of this LocalizedLogMessage.
        :type: str
        """
        allowed_values = ["cfwUpgradeLogger", "driveUpgradeLogger", "iomServiceLogger", "cfwUpgradeTimestamp", "driveUpgradeTimestamp", "iomServiceTimestamp"]
        if logger_type not in allowed_values:
            raise ValueError(
                "Invalid value for `logger_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._logger_type = logger_type

    @property
    def timestamp(self):
        """
        Gets the timestamp of this LocalizedLogMessage.
        Timestamp for this log message

        :return: The timestamp of this LocalizedLogMessage.
        :rtype: datetime
        :required/optional: required
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """
        Sets the timestamp of this LocalizedLogMessage.
        Timestamp for this log message

        :param timestamp: The timestamp of this LocalizedLogMessage.
        :type: datetime
        """
        self._timestamp = timestamp

    @property
    def message_text(self):
        """
        Gets the message_text of this LocalizedLogMessage.
        Localized message text

        :return: The message_text of this LocalizedLogMessage.
        :rtype: str
        :required/optional: optional
        """
        return self._message_text

    @message_text.setter
    def message_text(self, message_text):
        """
        Sets the message_text of this LocalizedLogMessage.
        Localized message text

        :param message_text: The message_text of this LocalizedLogMessage.
        :type: str
        """
        self._message_text = message_text

    @property
    def context(self):
        """
        Gets the context of this LocalizedLogMessage.
        Log message context

        :return: The context of this LocalizedLogMessage.
        :rtype: str
        :required/optional: required
        """
        return self._context

    @context.setter
    def context(self, context):
        """
        Sets the context of this LocalizedLogMessage.
        Log message context

        :param context: The context of this LocalizedLogMessage.
        :type: str
        """
        self._context = context

    @property
    def record_id(self):
        """
        Gets the record_id of this LocalizedLogMessage.
        ReplicatedRecord ID for this message

        :return: The record_id of this LocalizedLogMessage.
        :rtype: int
        :required/optional: required
        """
        return self._record_id

    @record_id.setter
    def record_id(self, record_id):
        """
        Sets the record_id of this LocalizedLogMessage.
        ReplicatedRecord ID for this message

        :param record_id: The record_id of this LocalizedLogMessage.
        :type: int
        """
        self._record_id = record_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

