# coding: utf-8

"""
ObjectGraphChangeEvent.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ObjectGraphChangeEvent(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ObjectGraphChangeEvent - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'timestamp': 'datetime',  # (required parameter)
            'event_number': 'int',  # (required parameter)
            'event_type': 'str',  # (required parameter)
            'storage_system_id': 'str',  # (required parameter)
            'current_config_gen': 'int',  # (required parameter)
            'previous_config_gen': 'int',  # (required parameter)
            'system_wwn': 'str'
        }

        self.attribute_map = {
            'timestamp': 'timestamp',  # (required parameter)
            'event_number': 'eventNumber',  # (required parameter)
            'event_type': 'eventType',  # (required parameter)
            'storage_system_id': 'storageSystemId',  # (required parameter)
            'current_config_gen': 'currentConfigGen',  # (required parameter)
            'previous_config_gen': 'previousConfigGen',  # (required parameter)
            'system_wwn': 'systemWWN'
        }

        self._timestamp = None
        self._event_number = None
        self._event_type = None
        self._storage_system_id = None
        self._current_config_gen = None
        self._previous_config_gen = None
        self._system_wwn = None

    @property
    def timestamp(self):
        """
        Gets the timestamp of this ObjectGraphChangeEvent.


        :return: The timestamp of this ObjectGraphChangeEvent.
        :rtype: datetime
        :required/optional: required
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """
        Sets the timestamp of this ObjectGraphChangeEvent.


        :param timestamp: The timestamp of this ObjectGraphChangeEvent.
        :type: datetime
        """
        self._timestamp = timestamp

    @property
    def event_number(self):
        """
        Gets the event_number of this ObjectGraphChangeEvent.


        :return: The event_number of this ObjectGraphChangeEvent.
        :rtype: int
        :required/optional: required
        """
        return self._event_number

    @event_number.setter
    def event_number(self, event_number):
        """
        Sets the event_number of this ObjectGraphChangeEvent.


        :param event_number: The event_number of this ObjectGraphChangeEvent.
        :type: int
        """
        self._event_number = event_number

    @property
    def event_type(self):
        """
        Gets the event_type of this ObjectGraphChangeEvent.


        :return: The event_type of this ObjectGraphChangeEvent.
        :rtype: str
        :required/optional: required
        """
        return self._event_type

    @event_type.setter
    def event_type(self, event_type):
        """
        Sets the event_type of this ObjectGraphChangeEvent.


        :param event_type: The event_type of this ObjectGraphChangeEvent.
        :type: str
        """
        allowed_values = ["objectGraphChangeEvent", "passwordStatusEvent", "storageSystemStatusEvent", "storageSystemMDChangeEvent", "folderEvent", "metadataTagEvent", "softwareDownloadEvent", "softwareReloadEvent", "asupConfigChangeEvent", "iomConfigChangeEvent", "alertConfigChangeEvent", "firmwareDownloadEvent", "criticalMelChangeEvent", "statisticsCollectionEvent", "melClearEvent", "workload"]
        if event_type not in allowed_values:
            raise ValueError(
                "Invalid value for `event_type`, must be one of {0}"
                .format(allowed_values)
            )
        self._event_type = event_type

    @property
    def storage_system_id(self):
        """
        Gets the storage_system_id of this ObjectGraphChangeEvent.


        :return: The storage_system_id of this ObjectGraphChangeEvent.
        :rtype: str
        :required/optional: required
        """
        return self._storage_system_id

    @storage_system_id.setter
    def storage_system_id(self, storage_system_id):
        """
        Sets the storage_system_id of this ObjectGraphChangeEvent.


        :param storage_system_id: The storage_system_id of this ObjectGraphChangeEvent.
        :type: str
        """
        self._storage_system_id = storage_system_id

    @property
    def current_config_gen(self):
        """
        Gets the current_config_gen of this ObjectGraphChangeEvent.
        The config gen number associated to the with these events.

        :return: The current_config_gen of this ObjectGraphChangeEvent.
        :rtype: int
        :required/optional: required
        """
        return self._current_config_gen

    @current_config_gen.setter
    def current_config_gen(self, current_config_gen):
        """
        Sets the current_config_gen of this ObjectGraphChangeEvent.
        The config gen number associated to the with these events.

        :param current_config_gen: The current_config_gen of this ObjectGraphChangeEvent.
        :type: int
        """
        self._current_config_gen = current_config_gen

    @property
    def previous_config_gen(self):
        """
        Gets the previous_config_gen of this ObjectGraphChangeEvent.
        The config gen number that was currently known.  It is possible for there to be a gap between currentConfig and previous      Don't expect them to be sequential

        :return: The previous_config_gen of this ObjectGraphChangeEvent.
        :rtype: int
        :required/optional: required
        """
        return self._previous_config_gen

    @previous_config_gen.setter
    def previous_config_gen(self, previous_config_gen):
        """
        Sets the previous_config_gen of this ObjectGraphChangeEvent.
        The config gen number that was currently known.  It is possible for there to be a gap between currentConfig and previous      Don't expect them to be sequential

        :param previous_config_gen: The previous_config_gen of this ObjectGraphChangeEvent.
        :type: int
        """
        self._previous_config_gen = previous_config_gen

    @property
    def system_wwn(self):
        """
        Gets the system_wwn of this ObjectGraphChangeEvent.
        The storage systems World Wide Name

        :return: The system_wwn of this ObjectGraphChangeEvent.
        :rtype: str
        :required/optional: required
        """
        return self._system_wwn

    @system_wwn.setter
    def system_wwn(self, system_wwn):
        """
        Sets the system_wwn of this ObjectGraphChangeEvent.
        The storage systems World Wide Name

        :param system_wwn: The system_wwn of this ObjectGraphChangeEvent.
        :type: str
        """
        self._system_wwn = system_wwn

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

