# coding: utf-8

"""
PasswordSetRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class PasswordSetRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        PasswordSetRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'current_admin_password': 'str',  # (required parameter)
            'admin_password': 'bool',  # (required parameter)
            'new_password': 'str'
        }

        self.attribute_map = {
            'current_admin_password': 'currentAdminPassword',  # (required parameter)
            'admin_password': 'adminPassword',  # (required parameter)
            'new_password': 'newPassword'
        }

        self._current_admin_password = None
        self._admin_password = None
        self._new_password = None

    @property
    def current_admin_password(self):
        """
        Gets the current_admin_password of this PasswordSetRequest.
        The current admin password

        :return: The current_admin_password of this PasswordSetRequest.
        :rtype: str
        :required/optional: required
        """
        return self._current_admin_password

    @current_admin_password.setter
    def current_admin_password(self, current_admin_password):
        """
        Sets the current_admin_password of this PasswordSetRequest.
        The current admin password

        :param current_admin_password: The current_admin_password of this PasswordSetRequest.
        :type: str
        """
        self._current_admin_password = current_admin_password

    @property
    def admin_password(self):
        """
        Gets the admin_password of this PasswordSetRequest.
        If this is true, this call will set the admin password, if false, it sets the RO password

        :return: The admin_password of this PasswordSetRequest.
        :rtype: bool
        :required/optional: required
        """
        return self._admin_password

    @admin_password.setter
    def admin_password(self, admin_password):
        """
        Sets the admin_password of this PasswordSetRequest.
        If this is true, this call will set the admin password, if false, it sets the RO password

        :param admin_password: The admin_password of this PasswordSetRequest.
        :type: bool
        """
        self._admin_password = admin_password

    @property
    def new_password(self):
        """
        Gets the new_password of this PasswordSetRequest.
        The new password

        :return: The new_password of this PasswordSetRequest.
        :rtype: str
        :required/optional: required
        """
        return self._new_password

    @new_password.setter
    def new_password(self, new_password):
        """
        Sets the new_password of this PasswordSetRequest.
        The new password

        :param new_password: The new_password of this PasswordSetRequest.
        :type: str
        """
        self._new_password = new_password

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

