# coding: utf-8

"""
RemoteCandidate.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RemoteCandidate(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RemoteCandidate - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'wwn': 'str',  # (required parameter)
            'id': 'str',  # (required parameter)
            'name': 'str',  # (required parameter)
            'type': 'str',  # (required parameter)
            'fc_mirroring_state': 'str'
        }

        self.attribute_map = {
            'wwn': 'wwn',  # (required parameter)
            'id': 'id',  # (required parameter)
            'name': 'name',  # (required parameter)
            'type': 'type',  # (required parameter)
            'fc_mirroring_state': 'fcMirroringState'
        }

        self._wwn = None
        self._id = None
        self._name = None
        self._type = None
        self._fc_mirroring_state = None

    @property
    def wwn(self):
        """
        Gets the wwn of this RemoteCandidate.


        :return: The wwn of this RemoteCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._wwn

    @wwn.setter
    def wwn(self, wwn):
        """
        Sets the wwn of this RemoteCandidate.


        :param wwn: The wwn of this RemoteCandidate.
        :type: str
        """
        self._wwn = wwn

    @property
    def id(self):
        """
        Gets the id of this RemoteCandidate.


        :return: The id of this RemoteCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this RemoteCandidate.


        :param id: The id of this RemoteCandidate.
        :type: str
        """
        self._id = id

    @property
    def name(self):
        """
        Gets the name of this RemoteCandidate.


        :return: The name of this RemoteCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this RemoteCandidate.


        :param name: The name of this RemoteCandidate.
        :type: str
        """
        self._name = name

    @property
    def type(self):
        """
        Gets the type of this RemoteCandidate.


        :return: The type of this RemoteCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this RemoteCandidate.


        :param type: The type of this RemoteCandidate.
        :type: str
        """
        allowed_values = ["fibre", "iscsi", "fibreAndIscsi", "none"]
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type`, must be one of {0}"
                .format(allowed_values)
            )
        self._type = type

    @property
    def fc_mirroring_state(self):
        """
        Gets the fc_mirroring_state of this RemoteCandidate.


        :return: The fc_mirroring_state of this RemoteCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._fc_mirroring_state

    @fc_mirroring_state.setter
    def fc_mirroring_state(self, fc_mirroring_state):
        """
        Sets the fc_mirroring_state of this RemoteCandidate.


        :param fc_mirroring_state: The fc_mirroring_state of this RemoteCandidate.
        :type: str
        """
        allowed_values = ["unknown", "disabled", "enabledLegacyRvm", "enabledArvm", "enabledAll", "__UNDEFINED"]
        if fc_mirroring_state not in allowed_values:
            raise ValueError(
                "Invalid value for `fc_mirroring_state`, must be one of {0}"
                .format(allowed_values)
            )
        self._fc_mirroring_state = fc_mirroring_state

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

