# coding: utf-8

"""
RemoteMirrorCandidate.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class RemoteMirrorCandidate(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        RemoteMirrorCandidate - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'source_volume': 'VolumeEx',  # (required parameter)
            'target_volumes': 'list[VolumeEx]',  # (required parameter)
            'target_array_name': 'str',  # (required parameter)
            'target_array_id': 'str'
        }

        self.attribute_map = {
            'source_volume': 'sourceVolume',  # (required parameter)
            'target_volumes': 'targetVolumes',  # (required parameter)
            'target_array_name': 'targetArrayName',  # (required parameter)
            'target_array_id': 'targetArrayId'
        }

        self._source_volume = None
        self._target_volumes = None
        self._target_array_name = None
        self._target_array_id = None

    @property
    def source_volume(self):
        """
        Gets the source_volume of this RemoteMirrorCandidate.


        :return: The source_volume of this RemoteMirrorCandidate.
        :rtype: VolumeEx
        :required/optional: required
        """
        return self._source_volume

    @source_volume.setter
    def source_volume(self, source_volume):
        """
        Sets the source_volume of this RemoteMirrorCandidate.


        :param source_volume: The source_volume of this RemoteMirrorCandidate.
        :type: VolumeEx
        """
        self._source_volume = source_volume

    @property
    def target_volumes(self):
        """
        Gets the target_volumes of this RemoteMirrorCandidate.


        :return: The target_volumes of this RemoteMirrorCandidate.
        :rtype: list[VolumeEx]
        :required/optional: required
        """
        return self._target_volumes

    @target_volumes.setter
    def target_volumes(self, target_volumes):
        """
        Sets the target_volumes of this RemoteMirrorCandidate.


        :param target_volumes: The target_volumes of this RemoteMirrorCandidate.
        :type: list[VolumeEx]
        """
        self._target_volumes = target_volumes

    @property
    def target_array_name(self):
        """
        Gets the target_array_name of this RemoteMirrorCandidate.


        :return: The target_array_name of this RemoteMirrorCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._target_array_name

    @target_array_name.setter
    def target_array_name(self, target_array_name):
        """
        Sets the target_array_name of this RemoteMirrorCandidate.


        :param target_array_name: The target_array_name of this RemoteMirrorCandidate.
        :type: str
        """
        self._target_array_name = target_array_name

    @property
    def target_array_id(self):
        """
        Gets the target_array_id of this RemoteMirrorCandidate.


        :return: The target_array_id of this RemoteMirrorCandidate.
        :rtype: str
        :required/optional: required
        """
        return self._target_array_id

    @target_array_id.setter
    def target_array_id(self, target_array_id):
        """
        Sets the target_array_id of this RemoteMirrorCandidate.


        :param target_array_id: The target_array_id of this RemoteMirrorCandidate.
        :type: str
        """
        self._target_array_id = target_array_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

