# coding: utf-8

"""
SaveConfigSpec.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SaveConfigSpec(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SaveConfigSpec - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'storage_array_settings': 'bool',  
            'volume_configuration': 'bool',  
            'host_configuration': 'bool',  
            'volume_mappings': 'bool'
        }

        self.attribute_map = {
            'storage_array_settings': 'storageArraySettings',  
            'volume_configuration': 'volumeConfiguration',  
            'host_configuration': 'hostConfiguration',  
            'volume_mappings': 'volumeMappings'
        }

        self._storage_array_settings = None
        self._volume_configuration = None
        self._host_configuration = None
        self._volume_mappings = None

    @property
    def storage_array_settings(self):
        """
        Gets the storage_array_settings of this SaveConfigSpec.
        Set true to save general storage array settings.

        :return: The storage_array_settings of this SaveConfigSpec.
        :rtype: bool
        :required/optional: optional
        """
        return self._storage_array_settings

    @storage_array_settings.setter
    def storage_array_settings(self, storage_array_settings):
        """
        Sets the storage_array_settings of this SaveConfigSpec.
        Set true to save general storage array settings.

        :param storage_array_settings: The storage_array_settings of this SaveConfigSpec.
        :type: bool
        """
        self._storage_array_settings = storage_array_settings

    @property
    def volume_configuration(self):
        """
        Gets the volume_configuration of this SaveConfigSpec.
        Set true to save storage array volume configuration.

        :return: The volume_configuration of this SaveConfigSpec.
        :rtype: bool
        :required/optional: optional
        """
        return self._volume_configuration

    @volume_configuration.setter
    def volume_configuration(self, volume_configuration):
        """
        Sets the volume_configuration of this SaveConfigSpec.
        Set true to save storage array volume configuration.

        :param volume_configuration: The volume_configuration of this SaveConfigSpec.
        :type: bool
        """
        self._volume_configuration = volume_configuration

    @property
    def host_configuration(self):
        """
        Gets the host_configuration of this SaveConfigSpec.
        Set true to save host and host port configuration.

        :return: The host_configuration of this SaveConfigSpec.
        :rtype: bool
        :required/optional: optional
        """
        return self._host_configuration

    @host_configuration.setter
    def host_configuration(self, host_configuration):
        """
        Sets the host_configuration of this SaveConfigSpec.
        Set true to save host and host port configuration.

        :param host_configuration: The host_configuration of this SaveConfigSpec.
        :type: bool
        """
        self._host_configuration = host_configuration

    @property
    def volume_mappings(self):
        """
        Gets the volume_mappings of this SaveConfigSpec.
        Set true to save volume mappings.

        :return: The volume_mappings of this SaveConfigSpec.
        :rtype: bool
        :required/optional: optional
        """
        return self._volume_mappings

    @volume_mappings.setter
    def volume_mappings(self, volume_mappings):
        """
        Sets the volume_mappings of this SaveConfigSpec.
        Set true to save volume mappings.

        :param volume_mappings: The volume_mappings of this SaveConfigSpec.
        :type: bool
        """
        self._volume_mappings = volume_mappings

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

