# coding: utf-8

"""
SscVolumeUpdateRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class SscVolumeUpdateRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        SscVolumeUpdateRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',  
            'new_size': 'int',  
            'size_unit': 'str',  
            'flash_cache': 'bool',  
            'owning_controller_id': 'str',  
            'read_cache_enable': 'bool',  
            'write_cache_enable': 'bool',  
            'scan_settings': 'VolumeMediaScanParams',  
            'meta_tags': 'list[VolumeMetadataItem]'
        }

        self.attribute_map = {
            'name': 'name',  
            'new_size': 'newSize',  
            'size_unit': 'sizeUnit',  
            'flash_cache': 'flashCache',  
            'owning_controller_id': 'owningControllerId',  
            'read_cache_enable': 'readCacheEnable',  
            'write_cache_enable': 'writeCacheEnable',  
            'scan_settings': 'scanSettings',  
            'meta_tags': 'metaTags'
        }

        self._name = None
        self._new_size = None
        self._size_unit = None
        self._flash_cache = None
        self._owning_controller_id = None
        self._read_cache_enable = None
        self._write_cache_enable = None
        self._scan_settings = None
        self._meta_tags = None

    @property
    def name(self):
        """
        Gets the name of this SscVolumeUpdateRequest.
        The user-label to assign to the volume.

        :return: The name of this SscVolumeUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SscVolumeUpdateRequest.
        The user-label to assign to the volume.

        :param name: The name of this SscVolumeUpdateRequest.
        :type: str
        """
        self._name = name

    @property
    def new_size(self):
        """
        Gets the new_size of this SscVolumeUpdateRequest.
        Expand the volume to this capacity.

        :return: The new_size of this SscVolumeUpdateRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._new_size

    @new_size.setter
    def new_size(self, new_size):
        """
        Sets the new_size of this SscVolumeUpdateRequest.
        Expand the volume to this capacity.

        :param new_size: The new_size of this SscVolumeUpdateRequest.
        :type: int
        """
        self._new_size = new_size

    @property
    def size_unit(self):
        """
        Gets the size_unit of this SscVolumeUpdateRequest.
        Expand the volume to this capacity.

        :return: The size_unit of this SscVolumeUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._size_unit

    @size_unit.setter
    def size_unit(self, size_unit):
        """
        Sets the size_unit of this SscVolumeUpdateRequest.
        Expand the volume to this capacity.

        :param size_unit: The size_unit of this SscVolumeUpdateRequest.
        :type: str
        """
        allowed_values = ["bytes", "b", "kb", "mb", "gb", "tb", "pb", "eb", "zb", "yb"]
        if size_unit not in allowed_values:
            raise ValueError(
                "Invalid value for `size_unit`, must be one of {0}"
                .format(allowed_values)
            )
        self._size_unit = size_unit

    @property
    def flash_cache(self):
        """
        Gets the flash_cache of this SscVolumeUpdateRequest.
        If true, add the volume to the flashCache if one is defined. If false, remove from the flashCache if one exists.

        :return: The flash_cache of this SscVolumeUpdateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._flash_cache

    @flash_cache.setter
    def flash_cache(self, flash_cache):
        """
        Sets the flash_cache of this SscVolumeUpdateRequest.
        If true, add the volume to the flashCache if one is defined. If false, remove from the flashCache if one exists.

        :param flash_cache: The flash_cache of this SscVolumeUpdateRequest.
        :type: bool
        """
        self._flash_cache = flash_cache

    @property
    def owning_controller_id(self):
        """
        Gets the owning_controller_id of this SscVolumeUpdateRequest.
        Set the preferred owning controller

        :return: The owning_controller_id of this SscVolumeUpdateRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._owning_controller_id

    @owning_controller_id.setter
    def owning_controller_id(self, owning_controller_id):
        """
        Sets the owning_controller_id of this SscVolumeUpdateRequest.
        Set the preferred owning controller

        :param owning_controller_id: The owning_controller_id of this SscVolumeUpdateRequest.
        :type: str
        """
        self._owning_controller_id = owning_controller_id

    @property
    def read_cache_enable(self):
        """
        Gets the read_cache_enable of this SscVolumeUpdateRequest.


        :return: The read_cache_enable of this SscVolumeUpdateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._read_cache_enable

    @read_cache_enable.setter
    def read_cache_enable(self, read_cache_enable):
        """
        Sets the read_cache_enable of this SscVolumeUpdateRequest.


        :param read_cache_enable: The read_cache_enable of this SscVolumeUpdateRequest.
        :type: bool
        """
        self._read_cache_enable = read_cache_enable

    @property
    def write_cache_enable(self):
        """
        Gets the write_cache_enable of this SscVolumeUpdateRequest.


        :return: The write_cache_enable of this SscVolumeUpdateRequest.
        :rtype: bool
        :required/optional: optional
        """
        return self._write_cache_enable

    @write_cache_enable.setter
    def write_cache_enable(self, write_cache_enable):
        """
        Sets the write_cache_enable of this SscVolumeUpdateRequest.


        :param write_cache_enable: The write_cache_enable of this SscVolumeUpdateRequest.
        :type: bool
        """
        self._write_cache_enable = write_cache_enable

    @property
    def scan_settings(self):
        """
        Gets the scan_settings of this SscVolumeUpdateRequest.
        Configure scan settings with regard to the controller's background media scan operation

        :return: The scan_settings of this SscVolumeUpdateRequest.
        :rtype: VolumeMediaScanParams
        :required/optional: optional
        """
        return self._scan_settings

    @scan_settings.setter
    def scan_settings(self, scan_settings):
        """
        Sets the scan_settings of this SscVolumeUpdateRequest.
        Configure scan settings with regard to the controller's background media scan operation

        :param scan_settings: The scan_settings of this SscVolumeUpdateRequest.
        :type: VolumeMediaScanParams
        """
        self._scan_settings = scan_settings

    @property
    def meta_tags(self):
        """
        Gets the meta_tags of this SscVolumeUpdateRequest.
        Optional list of MetaData tags to assign to the volume. This will replace any existing tags.

        :return: The meta_tags of this SscVolumeUpdateRequest.
        :rtype: list[VolumeMetadataItem]
        :required/optional: optional
        """
        return self._meta_tags

    @meta_tags.setter
    def meta_tags(self, meta_tags):
        """
        Sets the meta_tags of this SscVolumeUpdateRequest.
        Optional list of MetaData tags to assign to the volume. This will replace any existing tags.

        :param meta_tags: The meta_tags of this SscVolumeUpdateRequest.
        :type: list[VolumeMetadataItem]
        """
        self._meta_tags = meta_tags

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

