# coding: utf-8

"""
ThinVolumeExpansionRequest.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class ThinVolumeExpansionRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        ThinVolumeExpansionRequest - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'size_unit': 'str',  
            'new_virtual_size': 'int',  
            'new_repository_size': 'int'
        }

        self.attribute_map = {
            'size_unit': 'sizeUnit',  
            'new_virtual_size': 'newVirtualSize',  
            'new_repository_size': 'newRepositorySize'
        }

        self._size_unit = None
        self._new_virtual_size = None
        self._new_repository_size = None

    @property
    def size_unit(self):
        """
        Gets the size_unit of this ThinVolumeExpansionRequest.
        Unit for \"size\"

        :return: The size_unit of this ThinVolumeExpansionRequest.
        :rtype: str
        :required/optional: optional
        """
        return self._size_unit

    @size_unit.setter
    def size_unit(self, size_unit):
        """
        Sets the size_unit of this ThinVolumeExpansionRequest.
        Unit for \"size\"

        :param size_unit: The size_unit of this ThinVolumeExpansionRequest.
        :type: str
        """
        allowed_values = ["bytes", "b", "kb", "mb", "gb", "tb", "pb", "eb", "zb", "yb"]
        if size_unit not in allowed_values:
            raise ValueError(
                "Invalid value for `size_unit`, must be one of {0}"
                .format(allowed_values)
            )
        self._size_unit = size_unit

    @property
    def new_virtual_size(self):
        """
        Gets the new_virtual_size of this ThinVolumeExpansionRequest.
        The new virtual capacity for the thin volume. New virtual capacity cannot be smaller      than original value!

        :return: The new_virtual_size of this ThinVolumeExpansionRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._new_virtual_size

    @new_virtual_size.setter
    def new_virtual_size(self, new_virtual_size):
        """
        Sets the new_virtual_size of this ThinVolumeExpansionRequest.
        The new virtual capacity for the thin volume. New virtual capacity cannot be smaller      than original value!

        :param new_virtual_size: The new_virtual_size of this ThinVolumeExpansionRequest.
        :type: int
        """
        self._new_virtual_size = new_virtual_size

    @property
    def new_repository_size(self):
        """
        Gets the new_repository_size of this ThinVolumeExpansionRequest.
        The new repository capacity of the thin volume. If expansion policy is Automatic, this      will increase the maximum repository capacity. If the expansion policy is Manual, this will increase the      capacity of the repository directly.

        :return: The new_repository_size of this ThinVolumeExpansionRequest.
        :rtype: int
        :required/optional: optional
        """
        return self._new_repository_size

    @new_repository_size.setter
    def new_repository_size(self, new_repository_size):
        """
        Sets the new_repository_size of this ThinVolumeExpansionRequest.
        The new repository capacity of the thin volume. If expansion policy is Automatic, this      will increase the maximum repository capacity. If the expansion policy is Manual, this will increase the      capacity of the repository directly.

        :param new_repository_size: The new_repository_size of this ThinVolumeExpansionRequest.
        :type: int
        """
        self._new_repository_size = new_repository_size

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

