# coding: utf-8

"""
Throwable.py

 The Clear BSD License

 Copyright (c) – 2016, NetApp, Inc. All rights reserved.

 Redistribution and use in source and binary forms, with or without modification, are permitted (subject to the limitations in the disclaimer below) provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

 * Neither the name of NetApp, Inc. nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

 NO EXPRESS OR IMPLIED LICENSES TO ANY PARTY'S PATENT RIGHTS ARE GRANTED BY THIS LICENSE. THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
"""

from pprint import pformat
from six import iteritems


class Throwable(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Throwable - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'cause': 'Throwable',  
            'stack_trace': 'list[StackTraceElement]',  
            'message': 'str',  
            'localized_message': 'str',  
            'suppressed': 'list[Throwable]'
        }

        self.attribute_map = {
            'cause': 'cause',  
            'stack_trace': 'stackTrace',  
            'message': 'message',  
            'localized_message': 'localizedMessage',  
            'suppressed': 'suppressed'
        }

        self._cause = None
        self._stack_trace = None
        self._message = None
        self._localized_message = None
        self._suppressed = None

    @property
    def cause(self):
        """
        Gets the cause of this Throwable.


        :return: The cause of this Throwable.
        :rtype: Throwable
        :required/optional: optional
        """
        return self._cause

    @cause.setter
    def cause(self, cause):
        """
        Sets the cause of this Throwable.


        :param cause: The cause of this Throwable.
        :type: Throwable
        """
        self._cause = cause

    @property
    def stack_trace(self):
        """
        Gets the stack_trace of this Throwable.


        :return: The stack_trace of this Throwable.
        :rtype: list[StackTraceElement]
        :required/optional: optional
        """
        return self._stack_trace

    @stack_trace.setter
    def stack_trace(self, stack_trace):
        """
        Sets the stack_trace of this Throwable.


        :param stack_trace: The stack_trace of this Throwable.
        :type: list[StackTraceElement]
        """
        self._stack_trace = stack_trace

    @property
    def message(self):
        """
        Gets the message of this Throwable.


        :return: The message of this Throwable.
        :rtype: str
        :required/optional: optional
        """
        return self._message

    @message.setter
    def message(self, message):
        """
        Sets the message of this Throwable.


        :param message: The message of this Throwable.
        :type: str
        """
        self._message = message

    @property
    def localized_message(self):
        """
        Gets the localized_message of this Throwable.


        :return: The localized_message of this Throwable.
        :rtype: str
        :required/optional: optional
        """
        return self._localized_message

    @localized_message.setter
    def localized_message(self, localized_message):
        """
        Sets the localized_message of this Throwable.


        :param localized_message: The localized_message of this Throwable.
        :type: str
        """
        self._localized_message = localized_message

    @property
    def suppressed(self):
        """
        Gets the suppressed of this Throwable.


        :return: The suppressed of this Throwable.
        :rtype: list[Throwable]
        :required/optional: optional
        """
        return self._suppressed

    @suppressed.setter
    def suppressed(self, suppressed):
        """
        Sets the suppressed of this Throwable.


        :param suppressed: The suppressed of this Throwable.
        :type: list[Throwable]
        """
        self._suppressed = suppressed

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        if self is None:
           return None
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if self is None or other is None:
            return None
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

